var pveapi = [
   {
      "children" : [
         {
            "children" : [
               {
                  "children" : [
                     {
                        "children" : [
                           {
                              "info" : {
                                 "DELETE" : {
                                    "description" : "Delete rule.",
                                    "method" : "DELETE",
                                    "name" : "delete_rule",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "digest" : {
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "group" : {
                                             "description" : "Security Group name.",
                                             "maxLength" : 18,
                                             "minLength" : 2,
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                             "type" : "string"
                                          },
                                          "pos" : {
                                             "description" : "Update rule at position <pos>.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : null,
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 },
                                 "GET" : {
                                    "description" : "Get single rule data.",
                                    "method" : "GET",
                                    "name" : "get_rule",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "group" : {
                                             "description" : "Security Group name.",
                                             "maxLength" : 18,
                                             "minLength" : 2,
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                             "type" : "string"
                                          },
                                          "pos" : {
                                             "description" : "Update rule at position <pos>.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Audit"
                                          ]
                                       ]
                                    },
                                    "proxyto" : null,
                                    "returns" : {
                                       "properties" : {
                                          "pos" : {
                                             "type" : "integer"
                                          }
                                       },
                                       "type" : "object"
                                    }
                                 },
                                 "PUT" : {
                                    "description" : "Modify rule data.",
                                    "method" : "PUT",
                                    "name" : "update_rule",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "action" : {
                                             "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                             "maxLength" : 20,
                                             "minLength" : 2,
                                             "optional" : 1,
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                             "type" : "string"
                                          },
                                          "comment" : {
                                             "description" : "Descriptive comment.",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "delete" : {
                                             "description" : "A list of settings you want to delete.",
                                             "format" : "pve-configid-list",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "dest" : {
                                             "description" : "Restrict packet destination address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                             "format" : "pve-fw-addr-spec",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "digest" : {
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "dport" : {
                                             "description" : "Restrict TCP/UDP destination port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                             "format" : "pve-fw-dport-spec",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "enable" : {
                                             "description" : "Flag to enable/disable a rule.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          },
                                          "group" : {
                                             "description" : "Security Group name.",
                                             "maxLength" : 18,
                                             "minLength" : 2,
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                             "type" : "string"
                                          },
                                          "iface" : {
                                             "description" : "Network interface name. You have to use network configuration key names for VMs and containers ('net\\d+'). Host related rules can use arbitrary strings.",
                                             "format" : "pve-iface",
                                             "maxLength" : 20,
                                             "minLength" : 2,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "macro" : {
                                             "description" : "Use predefined standard macro.",
                                             "maxLength" : 128,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "moveto" : {
                                             "description" : "Move rule to new position <moveto>. Other arguments are ignored.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          },
                                          "pos" : {
                                             "description" : "Update rule at position <pos>.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          },
                                          "proto" : {
                                             "description" : "IP protocol. You can use protocol names ('tcp'/'udp') or simple numbers, as defined in '/etc/protocols'.",
                                             "format" : "pve-fw-protocol-spec",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "source" : {
                                             "description" : "Restrict packet source address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                             "format" : "pve-fw-addr-spec",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "sport" : {
                                             "description" : "Restrict TCP/UDP source port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                             "format" : "pve-fw-sport-spec",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "type" : {
                                             "description" : "Rule type.",
                                             "enum" : [
                                                "in",
                                                "out",
                                                "group"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : null,
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/cluster/firewall/groups/{group}/{pos}",
                              "text" : "{pos}"
                           }
                        ],
                        "info" : {
                           "DELETE" : {
                              "description" : "Delete security group.",
                              "method" : "DELETE",
                              "name" : "delete_security_group",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "group" : {
                                       "description" : "Security Group name.",
                                       "maxLength" : 18,
                                       "minLength" : 2,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "returns" : {
                                 "type" : "null"
                              }
                           },
                           "GET" : {
                              "description" : "List rules.",
                              "method" : "GET",
                              "name" : "get_rules",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "group" : {
                                       "description" : "Security Group name.",
                                       "maxLength" : 18,
                                       "minLength" : 2,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "proxyto" : null,
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "pos" : {
                                          "type" : "integer"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "links" : [
                                    {
                                       "href" : "{pos}",
                                       "rel" : "child"
                                    }
                                 ],
                                 "type" : "array"
                              }
                           },
                           "POST" : {
                              "description" : "Create new rule.",
                              "method" : "POST",
                              "name" : "create_rule",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "action" : {
                                       "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                       "maxLength" : 20,
                                       "minLength" : 2,
                                       "optional" : 0,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    },
                                    "comment" : {
                                       "description" : "Descriptive comment.",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "dest" : {
                                       "description" : "Restrict packet destination address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                       "format" : "pve-fw-addr-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "digest" : {
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "maxLength" : 40,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "dport" : {
                                       "description" : "Restrict TCP/UDP destination port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                       "format" : "pve-fw-dport-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "enable" : {
                                       "description" : "Flag to enable/disable a rule.",
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0- N)"
                                    },
                                    "group" : {
                                       "description" : "Security Group name.",
                                       "maxLength" : 18,
                                       "minLength" : 2,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    },
                                    "iface" : {
                                       "description" : "Network interface name. You have to use network configuration key names for VMs and containers ('net\\d+'). Host related rules can use arbitrary strings.",
                                       "format" : "pve-iface",
                                       "maxLength" : 20,
                                       "minLength" : 2,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "macro" : {
                                       "description" : "Use predefined standard macro.",
                                       "maxLength" : 128,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "pos" : {
                                       "description" : "Update rule at position <pos>.",
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0- N)"
                                    },
                                    "proto" : {
                                       "description" : "IP protocol. You can use protocol names ('tcp'/'udp') or simple numbers, as defined in '/etc/protocols'.",
                                       "format" : "pve-fw-protocol-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "source" : {
                                       "description" : "Restrict packet source address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                       "format" : "pve-fw-addr-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "sport" : {
                                       "description" : "Restrict TCP/UDP source port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                       "format" : "pve-fw-sport-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "type" : {
                                       "description" : "Rule type.",
                                       "enum" : [
                                          "in",
                                          "out",
                                          "group"
                                       ],
                                       "optional" : 0,
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : null,
                              "returns" : {
                                 "type" : "null"
                              }
                           }
                        },
                        "leaf" : 0,
                        "path" : "/cluster/firewall/groups/{group}",
                        "text" : "{group}"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "List security groups.",
                        "method" : "GET",
                        "name" : "list_security_groups",
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "permissions" : {
                           "user" : "all"
                        },
                        "returns" : {
                           "items" : {
                              "properties" : {
                                 "comment" : {
                                    "optional" : 1,
                                    "type" : "string"
                                 },
                                 "digest" : {
                                    "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                    "maxLength" : 40,
                                    "optional" : 0,
                                    "type" : "string"
                                 },
                                 "group" : {
                                    "description" : "Security Group name.",
                                    "maxLength" : 18,
                                    "minLength" : 2,
                                    "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{group}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     },
                     "POST" : {
                        "description" : "Create new security group.",
                        "method" : "POST",
                        "name" : "create_security_group",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "comment" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "digest" : {
                                 "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                 "maxLength" : 40,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "group" : {
                                 "description" : "Security Group name.",
                                 "maxLength" : 18,
                                 "minLength" : 2,
                                 "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                 "type" : "string"
                              },
                              "rename" : {
                                 "description" : "Rename/update an existing security group. You can set 'rename' to the same value as 'name' to update the 'comment' of an existing group.",
                                 "maxLength" : 18,
                                 "minLength" : 2,
                                 "optional" : 1,
                                 "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/cluster/firewall/groups",
                  "text" : "groups"
               },
               {
                  "children" : [
                     {
                        "info" : {
                           "DELETE" : {
                              "description" : "Delete rule.",
                              "method" : "DELETE",
                              "name" : "delete_rule",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "digest" : {
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "maxLength" : 40,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "pos" : {
                                       "description" : "Update rule at position <pos>.",
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0- N)"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : null,
                              "returns" : {
                                 "type" : "null"
                              }
                           },
                           "GET" : {
                              "description" : "Get single rule data.",
                              "method" : "GET",
                              "name" : "get_rule",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "pos" : {
                                       "description" : "Update rule at position <pos>.",
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0- N)"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "proxyto" : null,
                              "returns" : {
                                 "properties" : {
                                    "pos" : {
                                       "type" : "integer"
                                    }
                                 },
                                 "type" : "object"
                              }
                           },
                           "PUT" : {
                              "description" : "Modify rule data.",
                              "method" : "PUT",
                              "name" : "update_rule",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "action" : {
                                       "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                       "maxLength" : 20,
                                       "minLength" : 2,
                                       "optional" : 1,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    },
                                    "comment" : {
                                       "description" : "Descriptive comment.",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "delete" : {
                                       "description" : "A list of settings you want to delete.",
                                       "format" : "pve-configid-list",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "dest" : {
                                       "description" : "Restrict packet destination address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                       "format" : "pve-fw-addr-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "digest" : {
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "maxLength" : 40,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "dport" : {
                                       "description" : "Restrict TCP/UDP destination port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                       "format" : "pve-fw-dport-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "enable" : {
                                       "description" : "Flag to enable/disable a rule.",
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0- N)"
                                    },
                                    "iface" : {
                                       "description" : "Network interface name. You have to use network configuration key names for VMs and containers ('net\\d+'). Host related rules can use arbitrary strings.",
                                       "format" : "pve-iface",
                                       "maxLength" : 20,
                                       "minLength" : 2,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "macro" : {
                                       "description" : "Use predefined standard macro.",
                                       "maxLength" : 128,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "moveto" : {
                                       "description" : "Move rule to new position <moveto>. Other arguments are ignored.",
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0- N)"
                                    },
                                    "pos" : {
                                       "description" : "Update rule at position <pos>.",
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0- N)"
                                    },
                                    "proto" : {
                                       "description" : "IP protocol. You can use protocol names ('tcp'/'udp') or simple numbers, as defined in '/etc/protocols'.",
                                       "format" : "pve-fw-protocol-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "source" : {
                                       "description" : "Restrict packet source address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                       "format" : "pve-fw-addr-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "sport" : {
                                       "description" : "Restrict TCP/UDP source port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                       "format" : "pve-fw-sport-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "type" : {
                                       "description" : "Rule type.",
                                       "enum" : [
                                          "in",
                                          "out",
                                          "group"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : null,
                              "returns" : {
                                 "type" : "null"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/cluster/firewall/rules/{pos}",
                        "text" : "{pos}"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "List rules.",
                        "method" : "GET",
                        "name" : "get_rules",
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "proxyto" : null,
                        "returns" : {
                           "items" : {
                              "properties" : {
                                 "pos" : {
                                    "type" : "integer"
                                 }
                              },
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{pos}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     },
                     "POST" : {
                        "description" : "Create new rule.",
                        "method" : "POST",
                        "name" : "create_rule",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "action" : {
                                 "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                 "maxLength" : 20,
                                 "minLength" : 2,
                                 "optional" : 0,
                                 "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                 "type" : "string"
                              },
                              "comment" : {
                                 "description" : "Descriptive comment.",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "dest" : {
                                 "description" : "Restrict packet destination address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                 "format" : "pve-fw-addr-spec",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "digest" : {
                                 "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                 "maxLength" : 40,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "dport" : {
                                 "description" : "Restrict TCP/UDP destination port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                 "format" : "pve-fw-dport-spec",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "enable" : {
                                 "description" : "Flag to enable/disable a rule.",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "iface" : {
                                 "description" : "Network interface name. You have to use network configuration key names for VMs and containers ('net\\d+'). Host related rules can use arbitrary strings.",
                                 "format" : "pve-iface",
                                 "maxLength" : 20,
                                 "minLength" : 2,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "macro" : {
                                 "description" : "Use predefined standard macro.",
                                 "maxLength" : 128,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "pos" : {
                                 "description" : "Update rule at position <pos>.",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "proto" : {
                                 "description" : "IP protocol. You can use protocol names ('tcp'/'udp') or simple numbers, as defined in '/etc/protocols'.",
                                 "format" : "pve-fw-protocol-spec",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "source" : {
                                 "description" : "Restrict packet source address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                 "format" : "pve-fw-addr-spec",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "sport" : {
                                 "description" : "Restrict TCP/UDP source port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                 "format" : "pve-fw-sport-spec",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "type" : {
                                 "description" : "Rule type.",
                                 "enum" : [
                                    "in",
                                    "out",
                                    "group"
                                 ],
                                 "optional" : 0,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "proxyto" : null,
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/cluster/firewall/rules",
                  "text" : "rules"
               },
               {
                  "children" : [
                     {
                        "children" : [
                           {
                              "info" : {
                                 "DELETE" : {
                                    "description" : "Remove IP or Network from IPSet.",
                                    "method" : "DELETE",
                                    "name" : "remove_ip",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "cidr" : {
                                             "description" : "Network/IP specification in CIDR format.",
                                             "format" : "IPorCIDRorAlias",
                                             "type" : "string"
                                          },
                                          "digest" : {
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "name" : {
                                             "description" : "IP set name.",
                                             "maxLength" : 64,
                                             "minLength" : 2,
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 },
                                 "GET" : {
                                    "description" : "Read IP or Network settings from IPSet.",
                                    "method" : "GET",
                                    "name" : "read_ip",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "cidr" : {
                                             "description" : "Network/IP specification in CIDR format.",
                                             "format" : "IPorCIDRorAlias",
                                             "type" : "string"
                                          },
                                          "name" : {
                                             "description" : "IP set name.",
                                             "maxLength" : 64,
                                             "minLength" : 2,
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Audit"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "returns" : {
                                       "type" : "object"
                                    }
                                 },
                                 "PUT" : {
                                    "description" : "Update IP or Network settings",
                                    "method" : "PUT",
                                    "name" : "update_ip",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "cidr" : {
                                             "description" : "Network/IP specification in CIDR format.",
                                             "format" : "IPorCIDRorAlias",
                                             "type" : "string"
                                          },
                                          "comment" : {
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "digest" : {
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "name" : {
                                             "description" : "IP set name.",
                                             "maxLength" : 64,
                                             "minLength" : 2,
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                             "type" : "string"
                                          },
                                          "nomatch" : {
                                             "optional" : 1,
                                             "type" : "boolean"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/cluster/firewall/ipset/{name}/{cidr}",
                              "text" : "{cidr}"
                           }
                        ],
                        "info" : {
                           "DELETE" : {
                              "description" : "Delete IPSet",
                              "method" : "DELETE",
                              "name" : "delete_ipset",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "name" : {
                                       "description" : "IP set name.",
                                       "maxLength" : 64,
                                       "minLength" : 2,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "returns" : {
                                 "type" : "null"
                              }
                           },
                           "GET" : {
                              "description" : "List IPSet content",
                              "method" : "GET",
                              "name" : "get_ipset",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "name" : {
                                       "description" : "IP set name.",
                                       "maxLength" : 64,
                                       "minLength" : 2,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "cidr" : {
                                          "type" : "string"
                                       },
                                       "comment" : {
                                          "optional" : 1,
                                          "type" : "string"
                                       },
                                       "digest" : {
                                          "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                          "maxLength" : 40,
                                          "optional" : 0,
                                          "type" : "string"
                                       },
                                       "nomatch" : {
                                          "optional" : 1,
                                          "type" : "boolean"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "links" : [
                                    {
                                       "href" : "{cidr}",
                                       "rel" : "child"
                                    }
                                 ],
                                 "type" : "array"
                              }
                           },
                           "POST" : {
                              "description" : "Add IP or Network to IPSet.",
                              "method" : "POST",
                              "name" : "create_ip",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "cidr" : {
                                       "description" : "Network/IP specification in CIDR format.",
                                       "format" : "IPorCIDRorAlias",
                                       "type" : "string"
                                    },
                                    "comment" : {
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "name" : {
                                       "description" : "IP set name.",
                                       "maxLength" : 64,
                                       "minLength" : 2,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    },
                                    "nomatch" : {
                                       "optional" : 1,
                                       "type" : "boolean"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "returns" : {
                                 "type" : "null"
                              }
                           }
                        },
                        "leaf" : 0,
                        "path" : "/cluster/firewall/ipset/{name}",
                        "text" : "{name}"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "List IPSets",
                        "method" : "GET",
                        "name" : "ipset_index",
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "returns" : {
                           "items" : {
                              "properties" : {
                                 "comment" : {
                                    "optional" : 1,
                                    "type" : "string"
                                 },
                                 "digest" : {
                                    "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                    "maxLength" : 40,
                                    "optional" : 0,
                                    "type" : "string"
                                 },
                                 "name" : {
                                    "description" : "IP set name.",
                                    "maxLength" : 64,
                                    "minLength" : 2,
                                    "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{name}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     },
                     "POST" : {
                        "description" : "Create new IPSet",
                        "method" : "POST",
                        "name" : "create_ipset",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "comment" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "digest" : {
                                 "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                 "maxLength" : 40,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "name" : {
                                 "description" : "IP set name.",
                                 "maxLength" : 64,
                                 "minLength" : 2,
                                 "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                 "type" : "string"
                              },
                              "rename" : {
                                 "description" : "Rename an existing IPSet. You can set 'rename' to the same value as 'name' to update the 'comment' of an existing IPSet.",
                                 "maxLength" : 64,
                                 "minLength" : 2,
                                 "optional" : 1,
                                 "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/cluster/firewall/ipset",
                  "text" : "ipset"
               },
               {
                  "children" : [
                     {
                        "info" : {
                           "DELETE" : {
                              "description" : "Remove IP or Network alias.",
                              "method" : "DELETE",
                              "name" : "remove_alias",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "digest" : {
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "maxLength" : 40,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "name" : {
                                       "description" : "Alias name.",
                                       "maxLength" : 64,
                                       "minLength" : 2,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "returns" : {
                                 "type" : "null"
                              }
                           },
                           "GET" : {
                              "description" : "Read alias.",
                              "method" : "GET",
                              "name" : "read_alias",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "name" : {
                                       "description" : "Alias name.",
                                       "maxLength" : 64,
                                       "minLength" : 2,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "returns" : {
                                 "type" : "object"
                              }
                           },
                           "PUT" : {
                              "description" : "Update IP or Network alias.",
                              "method" : "PUT",
                              "name" : "update_alias",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "cidr" : {
                                       "description" : "Network/IP specification in CIDR format.",
                                       "format" : "IPorCIDR",
                                       "type" : "string"
                                    },
                                    "comment" : {
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "digest" : {
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "maxLength" : 40,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "name" : {
                                       "description" : "Alias name.",
                                       "maxLength" : 64,
                                       "minLength" : 2,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    },
                                    "rename" : {
                                       "description" : "Rename an existing alias.",
                                       "maxLength" : 64,
                                       "minLength" : 2,
                                       "optional" : 1,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "returns" : {
                                 "type" : "null"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/cluster/firewall/aliases/{name}",
                        "text" : "{name}"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "List aliases",
                        "method" : "GET",
                        "name" : "get_aliases",
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "returns" : {
                           "items" : {
                              "properties" : {
                                 "cidr" : {
                                    "type" : "string"
                                 },
                                 "comment" : {
                                    "optional" : 1,
                                    "type" : "string"
                                 },
                                 "digest" : {
                                    "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                    "maxLength" : 40,
                                    "optional" : 0,
                                    "type" : "string"
                                 },
                                 "name" : {
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{name}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     },
                     "POST" : {
                        "description" : "Create IP or Network Alias.",
                        "method" : "POST",
                        "name" : "create_alias",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "cidr" : {
                                 "description" : "Network/IP specification in CIDR format.",
                                 "format" : "IPorCIDR",
                                 "type" : "string"
                              },
                              "comment" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "name" : {
                                 "description" : "Alias name.",
                                 "maxLength" : 64,
                                 "minLength" : 2,
                                 "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/cluster/firewall/aliases",
                  "text" : "aliases"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "Get Firewall options.",
                        "method" : "GET",
                        "name" : "get_options",
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "returns" : {
                           "properties" : {
                              "enable" : {
                                 "description" : "Enable or disable the firewall cluster wide.",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer"
                              },
                              "policy_in" : {
                                 "description" : "Input policy.",
                                 "enum" : [
                                    "ACCEPT",
                                    "REJECT",
                                    "DROP"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "policy_out" : {
                                 "description" : "Output policy.",
                                 "enum" : [
                                    "ACCEPT",
                                    "REJECT",
                                    "DROP"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              }
                           },
                           "type" : "object"
                        }
                     },
                     "PUT" : {
                        "description" : "Set Firewall options.",
                        "method" : "PUT",
                        "name" : "set_options",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "delete" : {
                                 "description" : "A list of settings you want to delete.",
                                 "format" : "pve-configid-list",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "digest" : {
                                 "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                 "maxLength" : 40,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "enable" : {
                                 "description" : "Enable or disable the firewall cluster wide.",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "policy_in" : {
                                 "description" : "Input policy.",
                                 "enum" : [
                                    "ACCEPT",
                                    "REJECT",
                                    "DROP"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "policy_out" : {
                                 "description" : "Output policy.",
                                 "enum" : [
                                    "ACCEPT",
                                    "REJECT",
                                    "DROP"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/cluster/firewall/options",
                  "text" : "options"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "List available macros",
                        "method" : "GET",
                        "name" : "get_macros",
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "permissions" : {
                           "user" : "all"
                        },
                        "returns" : {
                           "items" : {
                              "properties" : {
                                 "descr" : {
                                    "description" : "More verbose description (if available).",
                                    "type" : "string"
                                 },
                                 "macro" : {
                                    "description" : "Macro name.",
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           },
                           "type" : "array"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/cluster/firewall/macros",
                  "text" : "macros"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "Lists possible IPSet/Alias reference which are allowed in source/dest properties.",
                        "method" : "GET",
                        "name" : "refs",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "type" : {
                                 "description" : "Only list references of specified type.",
                                 "enum" : [
                                    "alias",
                                    "ipset"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "returns" : {
                           "items" : {
                              "properties" : {
                                 "comment" : {
                                    "optional" : 1,
                                    "type" : "string"
                                 },
                                 "name" : {
                                    "type" : "string"
                                 },
                                 "ref" : {
                                    "type" : "string"
                                 },
                                 "type" : {
                                    "enum" : [
                                       "alias",
                                       "ipset"
                                    ],
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           },
                           "type" : "array"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/cluster/firewall/refs",
                  "text" : "refs"
               }
            ],
            "info" : {
               "GET" : {
                  "description" : "Directory index.",
                  "method" : "GET",
                  "name" : "index",
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "permissions" : {
                     "user" : "all"
                  },
                  "returns" : {
                     "items" : {
                        "properties" : {},
                        "type" : "object"
                     },
                     "links" : [
                        {
                           "href" : "{name}",
                           "rel" : "child"
                        }
                     ],
                     "type" : "array"
                  }
               }
            },
            "leaf" : 0,
            "path" : "/cluster/firewall",
            "text" : "firewall"
         },
         {
            "children" : [
               {
                  "info" : {
                     "DELETE" : {
                        "description" : "Delete vzdump backup job definition.",
                        "method" : "DELETE",
                        "name" : "delete_job",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "id" : {
                                 "description" : "The job ID.",
                                 "maxLength" : 50,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     },
                     "GET" : {
                        "description" : "Read vzdump backup job definition.",
                        "method" : "GET",
                        "name" : "read_job",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "id" : {
                                 "description" : "The job ID.",
                                 "maxLength" : 50,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "returns" : {
                           "type" : "object"
                        }
                     },
                     "PUT" : {
                        "description" : "Update vzdump backup job definition.",
                        "method" : "PUT",
                        "name" : "update_job",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "all" : {
                                 "default" : 0,
                                 "description" : "Backup all known guest systems on this host.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "bwlimit" : {
                                 "default" : 0,
                                 "description" : "Limit I/O bandwidth (KBytes per second).",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "compress" : {
                                 "default" : "0",
                                 "description" : "Compress dump file.",
                                 "enum" : [
                                    "0",
                                    "1",
                                    "gzip",
                                    "lzo"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "delete" : {
                                 "description" : "A list of settings you want to delete.",
                                 "format" : "pve-configid-list",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "dow" : {
                                 "description" : "Day of week selection.",
                                 "format" : "pve-day-of-week-list",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "dumpdir" : {
                                 "description" : "Store resulting files to specified directory.",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "enabled" : {
                                 "default" : "1",
                                 "description" : "Enable or disable the job.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "exclude" : {
                                 "description" : "Exclude specified guest systems (assumes --all)",
                                 "format" : "pve-vmid-list",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "exclude-path" : {
                                 "description" : "Exclude certain files/directories (shell globs).",
                                 "format" : "string-alist",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "id" : {
                                 "description" : "The job ID.",
                                 "maxLength" : 50,
                                 "type" : "string"
                              },
                              "ionice" : {
                                 "default" : 7,
                                 "description" : "Set CFQ ionice priority.",
                                 "maximum" : 8,
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0-8)"
                              },
                              "lockwait" : {
                                 "default" : 180,
                                 "description" : "Maximal time to wait for the global lock (minutes).",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "mailnotification" : {
                                 "default" : "always",
                                 "description" : "Specify when to send an email",
                                 "enum" : [
                                    "always",
                                    "failure"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "mailto" : {
                                 "description" : "Comma-separated list of email addresses that should receive email notifications.",
                                 "format" : "string-list",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "maxfiles" : {
                                 "default" : 1,
                                 "description" : "Maximal number of backup files per guest system.",
                                 "minimum" : 1,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (1- N)"
                              },
                              "mode" : {
                                 "default" : "snapshot",
                                 "description" : "Backup mode.",
                                 "enum" : [
                                    "snapshot",
                                    "suspend",
                                    "stop"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "node" : {
                                 "description" : "Only run if executed on this node.",
                                 "format" : "pve-node",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "pigz" : {
                                 "default" : 0,
                                 "description" : "Use pigz instead of gzip when N>0. N=1 uses half of cores, N>1 uses N as thread count.",
                                 "optional" : 1,
                                 "type" : "integer"
                              },
                              "quiet" : {
                                 "default" : 0,
                                 "description" : "Be quiet.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "remove" : {
                                 "default" : 1,
                                 "description" : "Remove old backup files if there are more than 'maxfiles' backup files.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "script" : {
                                 "description" : "Use specified hook script.",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "size" : {
                                 "default" : 1024,
                                 "description" : "Unused, will be removed in a future release.",
                                 "minimum" : 500,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (500- N)"
                              },
                              "starttime" : {
                                 "description" : "Job Start time.",
                                 "pattern" : "\\d{1,2}:\\d{1,2}",
                                 "type" : "string",
                                 "typetext" : "HH:MM"
                              },
                              "stdexcludes" : {
                                 "default" : 1,
                                 "description" : "Exclude temporary files and logs.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "stop" : {
                                 "default" : 0,
                                 "description" : "Stop runnig backup jobs on this host.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "stopwait" : {
                                 "default" : 10,
                                 "description" : "Maximal time to wait until a guest system is stopped (minutes).",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "storage" : {
                                 "description" : "Store resulting file to this storage.",
                                 "format" : "pve-storage-id",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "tmpdir" : {
                                 "description" : "Store temporary files to specified directory.",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "vmid" : {
                                 "description" : "The ID of the guest system you want to backup.",
                                 "format" : "pve-vmid-list",
                                 "optional" : 1,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/cluster/backup/{id}",
                  "text" : "{id}"
               }
            ],
            "info" : {
               "GET" : {
                  "description" : "List vzdump backup schedule.",
                  "method" : "GET",
                  "name" : "index",
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/",
                        [
                           "Sys.Audit"
                        ]
                     ]
                  },
                  "returns" : {
                     "items" : {
                        "properties" : {
                           "id" : {
                              "type" : "string"
                           }
                        },
                        "type" : "object"
                     },
                     "links" : [
                        {
                           "href" : "{id}",
                           "rel" : "child"
                        }
                     ],
                     "type" : "array"
                  }
               },
               "POST" : {
                  "description" : "Create new vzdump backup job.",
                  "method" : "POST",
                  "name" : "create_job",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "all" : {
                           "default" : 0,
                           "description" : "Backup all known guest systems on this host.",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "bwlimit" : {
                           "default" : 0,
                           "description" : "Limit I/O bandwidth (KBytes per second).",
                           "minimum" : 0,
                           "optional" : 1,
                           "type" : "integer",
                           "typetext" : "integer (0- N)"
                        },
                        "compress" : {
                           "default" : "0",
                           "description" : "Compress dump file.",
                           "enum" : [
                              "0",
                              "1",
                              "gzip",
                              "lzo"
                           ],
                           "optional" : 1,
                           "type" : "string"
                        },
                        "dow" : {
                           "default" : "mon,tue,wed,thu,fri,sat,sun",
                           "description" : "Day of week selection.",
                           "format" : "pve-day-of-week-list",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "dumpdir" : {
                           "description" : "Store resulting files to specified directory.",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "enabled" : {
                           "default" : "1",
                           "description" : "Enable or disable the job.",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "exclude" : {
                           "description" : "Exclude specified guest systems (assumes --all)",
                           "format" : "pve-vmid-list",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "exclude-path" : {
                           "description" : "Exclude certain files/directories (shell globs).",
                           "format" : "string-alist",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "ionice" : {
                           "default" : 7,
                           "description" : "Set CFQ ionice priority.",
                           "maximum" : 8,
                           "minimum" : 0,
                           "optional" : 1,
                           "type" : "integer",
                           "typetext" : "integer (0-8)"
                        },
                        "lockwait" : {
                           "default" : 180,
                           "description" : "Maximal time to wait for the global lock (minutes).",
                           "minimum" : 0,
                           "optional" : 1,
                           "type" : "integer",
                           "typetext" : "integer (0- N)"
                        },
                        "mailnotification" : {
                           "default" : "always",
                           "description" : "Specify when to send an email",
                           "enum" : [
                              "always",
                              "failure"
                           ],
                           "optional" : 1,
                           "type" : "string"
                        },
                        "mailto" : {
                           "description" : "Comma-separated list of email addresses that should receive email notifications.",
                           "format" : "string-list",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "maxfiles" : {
                           "default" : 1,
                           "description" : "Maximal number of backup files per guest system.",
                           "minimum" : 1,
                           "optional" : 1,
                           "type" : "integer",
                           "typetext" : "integer (1- N)"
                        },
                        "mode" : {
                           "default" : "snapshot",
                           "description" : "Backup mode.",
                           "enum" : [
                              "snapshot",
                              "suspend",
                              "stop"
                           ],
                           "optional" : 1,
                           "type" : "string"
                        },
                        "node" : {
                           "description" : "Only run if executed on this node.",
                           "format" : "pve-node",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "pigz" : {
                           "default" : 0,
                           "description" : "Use pigz instead of gzip when N>0. N=1 uses half of cores, N>1 uses N as thread count.",
                           "optional" : 1,
                           "type" : "integer"
                        },
                        "quiet" : {
                           "default" : 0,
                           "description" : "Be quiet.",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "remove" : {
                           "default" : 1,
                           "description" : "Remove old backup files if there are more than 'maxfiles' backup files.",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "script" : {
                           "description" : "Use specified hook script.",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "size" : {
                           "default" : 1024,
                           "description" : "Unused, will be removed in a future release.",
                           "minimum" : 500,
                           "optional" : 1,
                           "type" : "integer",
                           "typetext" : "integer (500- N)"
                        },
                        "starttime" : {
                           "description" : "Job Start time.",
                           "pattern" : "\\d{1,2}:\\d{1,2}",
                           "type" : "string",
                           "typetext" : "HH:MM"
                        },
                        "stdexcludes" : {
                           "default" : 1,
                           "description" : "Exclude temporary files and logs.",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "stop" : {
                           "default" : 0,
                           "description" : "Stop runnig backup jobs on this host.",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "stopwait" : {
                           "default" : 10,
                           "description" : "Maximal time to wait until a guest system is stopped (minutes).",
                           "minimum" : 0,
                           "optional" : 1,
                           "type" : "integer",
                           "typetext" : "integer (0- N)"
                        },
                        "storage" : {
                           "description" : "Store resulting file to this storage.",
                           "format" : "pve-storage-id",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "tmpdir" : {
                           "description" : "Store temporary files to specified directory.",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "vmid" : {
                           "description" : "The ID of the guest system you want to backup.",
                           "format" : "pve-vmid-list",
                           "optional" : 1,
                           "type" : "string"
                        }
                     }
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/",
                        [
                           "Sys.Modify"
                        ]
                     ]
                  },
                  "protected" : 1,
                  "returns" : {
                     "type" : "null"
                  }
               }
            },
            "leaf" : 0,
            "path" : "/cluster/backup",
            "text" : "backup"
         },
         {
            "children" : [
               {
                  "children" : [
                     {
                        "children" : [
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Request resource migration (online) to another node.",
                                    "method" : "POST",
                                    "name" : "migrate",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "sid" : {
                                             "description" : "HA resource ID. This consists of a resource type followed by a resource specific name, separated with colon (example: vm:100 / ct:100). For virtual machines and containers, you can simply use the VM or CT id as a shortcut (example: 100).",
                                             "format" : "pve-ha-resource-or-vm-id",
                                             "type" : "string",
                                             "typetext" : "<type>:<name>"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Console"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/cluster/ha/resources/{sid}/migrate",
                              "text" : "migrate"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Request resource relocatzion to another node. This stops the service on the old node, and restarts it on the target node.",
                                    "method" : "POST",
                                    "name" : "relocate",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "sid" : {
                                             "description" : "HA resource ID. This consists of a resource type followed by a resource specific name, separated with colon (example: vm:100 / ct:100). For virtual machines and containers, you can simply use the VM or CT id as a shortcut (example: 100).",
                                             "format" : "pve-ha-resource-or-vm-id",
                                             "type" : "string",
                                             "typetext" : "<type>:<name>"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Console"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/cluster/ha/resources/{sid}/relocate",
                              "text" : "relocate"
                           }
                        ],
                        "info" : {
                           "DELETE" : {
                              "description" : "Delete resource configuration.",
                              "method" : "DELETE",
                              "name" : "delete",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "sid" : {
                                       "description" : "HA resource ID. This consists of a resource type followed by a resource specific name, separated with colon (example: vm:100 / ct:100). For virtual machines and containers, you can simply use the VM or CT id as a shortcut (example: 100).",
                                       "format" : "pve-ha-resource-or-vm-id",
                                       "type" : "string",
                                       "typetext" : "<type>:<name>"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Console"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "returns" : {
                                 "type" : "null"
                              }
                           },
                           "GET" : {
                              "description" : "Read resource configuration.",
                              "method" : "GET",
                              "name" : "read",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "sid" : {
                                       "description" : "HA resource ID. This consists of a resource type followed by a resource specific name, separated with colon (example: vm:100 / ct:100). For virtual machines and containers, you can simply use the VM or CT id as a shortcut (example: 100).",
                                       "format" : "pve-ha-resource-or-vm-id",
                                       "type" : "string",
                                       "typetext" : "<type>:<name>"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "returns" : {}
                           },
                           "PUT" : {
                              "description" : "Update resource configuration.",
                              "method" : "PUT",
                              "name" : "update",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "comment" : {
                                       "description" : "Description.",
                                       "maxLength" : 4096,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "delete" : {
                                       "description" : "A list of settings you want to delete.",
                                       "format" : "pve-configid-list",
                                       "maxLength" : 4096,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "digest" : {
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "maxLength" : 40,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "group" : {
                                       "description" : "The HA group identifier.",
                                       "format" : "pve-configid",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "max_relocate" : {
                                       "default" : 1,
                                       "description" : "Maximal number of service relocate tries when a service failes to start.",
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0- N)"
                                    },
                                    "max_restart" : {
                                       "default" : 1,
                                       "description" : "Maximal number of tries to restart the service on a node after its start failed.",
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0- N)"
                                    },
                                    "sid" : {
                                       "description" : "HA resource ID. This consists of a resource type followed by a resource specific name, separated with colon (example: vm:100 / ct:100). For virtual machines and containers, you can simply use the VM or CT id as a shortcut (example: 100).",
                                       "format" : "pve-ha-resource-or-vm-id",
                                       "type" : "string",
                                       "typetext" : "<type>:<name>"
                                    },
                                    "state" : {
                                       "default" : "enabled",
                                       "description" : "Resource state.",
                                       "enum" : [
                                          "enabled",
                                          "disabled"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    }
                                 },
                                 "type" : "object"
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Console"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "returns" : {
                                 "type" : "null"
                              }
                           }
                        },
                        "leaf" : 0,
                        "path" : "/cluster/ha/resources/{sid}",
                        "text" : "{sid}"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "List HA resources.",
                        "method" : "GET",
                        "name" : "index",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "type" : {
                                 "description" : "Only list resources of specific type",
                                 "enum" : [
                                    "ct",
                                    "vm"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "returns" : {
                           "items" : {
                              "properties" : {
                                 "sid" : {
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{sid}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     },
                     "POST" : {
                        "description" : "Create a new HA resource.",
                        "method" : "POST",
                        "name" : "create",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "comment" : {
                                 "description" : "Description.",
                                 "maxLength" : 4096,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "group" : {
                                 "description" : "The HA group identifier.",
                                 "format" : "pve-configid",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "max_relocate" : {
                                 "default" : 1,
                                 "description" : "Maximal number of service relocate tries when a service failes to start.",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "max_restart" : {
                                 "default" : 1,
                                 "description" : "Maximal number of tries to restart the service on a node after its start failed.",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "sid" : {
                                 "description" : "HA resource ID. This consists of a resource type followed by a resource specific name, separated with colon (example: vm:100 / ct:100). For virtual machines and containers, you can simply use the VM or CT id as a shortcut (example: 100).",
                                 "format" : "pve-ha-resource-or-vm-id",
                                 "type" : "string",
                                 "typetext" : "<type>:<name>"
                              },
                              "state" : {
                                 "default" : "enabled",
                                 "description" : "Resource state.",
                                 "enum" : [
                                    "enabled",
                                    "disabled"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "type" : {
                                 "description" : "Resource type.",
                                 "enum" : [
                                    "ct",
                                    "vm"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              }
                           },
                           "type" : "object"
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Console"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/cluster/ha/resources",
                  "text" : "resources"
               },
               {
                  "children" : [
                     {
                        "info" : {
                           "DELETE" : {
                              "description" : "Delete ha group configuration.",
                              "method" : "DELETE",
                              "name" : "delete",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "group" : {
                                       "description" : "The HA group identifier.",
                                       "format" : "pve-configid",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Console"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "returns" : {
                                 "type" : "null"
                              }
                           },
                           "GET" : {
                              "description" : "Read ha group configuration.",
                              "method" : "GET",
                              "name" : "read",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "group" : {
                                       "description" : "The HA group identifier.",
                                       "format" : "pve-configid",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "returns" : {}
                           },
                           "PUT" : {
                              "description" : "Update ha group configuration.",
                              "method" : "PUT",
                              "name" : "update",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "comment" : {
                                       "description" : "Description.",
                                       "maxLength" : 4096,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "delete" : {
                                       "description" : "A list of settings you want to delete.",
                                       "format" : "pve-configid-list",
                                       "maxLength" : 4096,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "digest" : {
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "maxLength" : 40,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "group" : {
                                       "description" : "The HA group identifier.",
                                       "format" : "pve-configid",
                                       "type" : "string"
                                    },
                                    "nodes" : {
                                       "description" : "List of cluster node names with optional priority. We use priority '0' as default. The CRM tries to run services on the node with highest priority (also see option 'nofailback').",
                                       "format" : "pve-ha-group-node-list",
                                       "optional" : 1,
                                       "type" : "string",
                                       "typetext" : "<node>[:<pri>]{,<node>[:<pri>]}*"
                                    },
                                    "nofailback" : {
                                       "default" : 0,
                                       "description" : "The CRM tries to run services on the node with the highest priority. If a node with higher priority comes online, the CRM migrates the service to that node. Enabling nofailback prevents that behavior.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "restricted" : {
                                       "default" : 0,
                                       "description" : "Services on unrestricted groups may run on any cluster members if all group members are offline. But they will migrate back as soon as a group member comes online. One can implement a 'preferred node' behavior using an unrestricted group with one member.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    }
                                 },
                                 "type" : "object"
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Console"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "returns" : {
                                 "type" : "null"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/cluster/ha/groups/{group}",
                        "text" : "{group}"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "Get HA groups.",
                        "method" : "GET",
                        "name" : "index",
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "returns" : {
                           "items" : {
                              "properties" : {
                                 "group" : {
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{group}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     },
                     "POST" : {
                        "description" : "Create a new HA group.",
                        "method" : "POST",
                        "name" : "create",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "comment" : {
                                 "description" : "Description.",
                                 "maxLength" : 4096,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "group" : {
                                 "description" : "The HA group identifier.",
                                 "format" : "pve-configid",
                                 "type" : "string"
                              },
                              "nodes" : {
                                 "description" : "List of cluster node names with optional priority. We use priority '0' as default. The CRM tries to run services on the node with highest priority (also see option 'nofailback').",
                                 "format" : "pve-ha-group-node-list",
                                 "optional" : 0,
                                 "type" : "string",
                                 "typetext" : "<node>[:<pri>]{,<node>[:<pri>]}*"
                              },
                              "nofailback" : {
                                 "default" : 0,
                                 "description" : "The CRM tries to run services on the node with the highest priority. If a node with higher priority comes online, the CRM migrates the service to that node. Enabling nofailback prevents that behavior.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "restricted" : {
                                 "default" : 0,
                                 "description" : "Services on unrestricted groups may run on any cluster members if all group members are offline. But they will migrate back as soon as a group member comes online. One can implement a 'preferred node' behavior using an unrestricted group with one member.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "type" : {
                                 "description" : "Group type.",
                                 "enum" : [
                                    "group"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              }
                           },
                           "type" : "object"
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Console"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/cluster/ha/groups",
                  "text" : "groups"
               },
               {
                  "children" : [
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Get HA manger status.",
                              "method" : "GET",
                              "name" : "status",
                              "parameters" : {
                                 "additionalProperties" : 0
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "returns" : {
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/cluster/ha/status/current",
                        "text" : "current"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Get full HA manger status, including LRM status.",
                              "method" : "GET",
                              "name" : "manager_status",
                              "parameters" : {
                                 "additionalProperties" : 0
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "returns" : {
                                 "type" : "object"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/cluster/ha/status/manager_status",
                        "text" : "manager_status"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "Directory index.",
                        "method" : "GET",
                        "name" : "index",
                        "parameters" : {
                           "additionalProperties" : 0
                        },
                        "permissions" : {
                           "user" : "all"
                        },
                        "returns" : {
                           "items" : {
                              "properties" : {},
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{name}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/cluster/ha/status",
                  "text" : "status"
               }
            ],
            "info" : {
               "GET" : {
                  "description" : "Directory index.",
                  "method" : "GET",
                  "name" : "index",
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/",
                        [
                           "Sys.Audit"
                        ]
                     ]
                  },
                  "returns" : {
                     "items" : {
                        "properties" : {
                           "id" : {
                              "type" : "string"
                           }
                        },
                        "type" : "object"
                     },
                     "links" : [
                        {
                           "href" : "{id}",
                           "rel" : "child"
                        }
                     ],
                     "type" : "array"
                  }
               }
            },
            "leaf" : 0,
            "path" : "/cluster/ha",
            "text" : "ha"
         },
         {
            "info" : {
               "GET" : {
                  "description" : "Read cluster log",
                  "method" : "GET",
                  "name" : "log",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "max" : {
                           "description" : "Maximum number of entries.",
                           "minimum" : 1,
                           "optional" : 1,
                           "type" : "integer",
                           "typetext" : "integer (1- N)"
                        }
                     }
                  },
                  "permissions" : {
                     "user" : "all"
                  },
                  "returns" : {
                     "items" : {
                        "properties" : {},
                        "type" : "object"
                     },
                     "type" : "array"
                  }
               }
            },
            "leaf" : 1,
            "path" : "/cluster/log",
            "text" : "log"
         },
         {
            "info" : {
               "GET" : {
                  "description" : "Resources index (cluster wide).",
                  "method" : "GET",
                  "name" : "resources",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "type" : {
                           "enum" : [
                              "vm",
                              "storage",
                              "node"
                           ],
                           "optional" : 1,
                           "type" : "string"
                        }
                     }
                  },
                  "permissions" : {
                     "user" : "all"
                  },
                  "returns" : {
                     "items" : {
                        "properties" : {},
                        "type" : "object"
                     },
                     "type" : "array"
                  }
               }
            },
            "leaf" : 1,
            "path" : "/cluster/resources",
            "text" : "resources"
         },
         {
            "info" : {
               "GET" : {
                  "description" : "List recent tasks (cluster wide).",
                  "method" : "GET",
                  "name" : "tasks",
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "permissions" : {
                     "user" : "all"
                  },
                  "returns" : {
                     "items" : {
                        "properties" : {
                           "upid" : {
                              "type" : "string"
                           }
                        },
                        "type" : "object"
                     },
                     "type" : "array"
                  }
               }
            },
            "leaf" : 1,
            "path" : "/cluster/tasks",
            "text" : "tasks"
         },
         {
            "info" : {
               "GET" : {
                  "description" : "Get datacenter options.",
                  "method" : "GET",
                  "name" : "get_options",
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/",
                        [
                           "Sys.Audit"
                        ]
                     ]
                  },
                  "returns" : {
                     "properties" : {},
                     "type" : "object"
                  }
               },
               "PUT" : {
                  "description" : "Set datacenter options.",
                  "method" : "PUT",
                  "name" : "set_options",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "console" : {
                           "description" : "Select the default Console viewer. You can either use the builtin java applet (VNC), an external virt-viewer comtatible application (SPICE), or an HTML5 based viewer (noVNC).",
                           "enum" : [
                              "applet",
                              "vv",
                              "html5"
                           ],
                           "optional" : 1,
                           "type" : "string"
                        },
                        "delete" : {
                           "description" : "A list of settings you want to delete.",
                           "format" : "pve-configid-list",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "email_from" : {
                           "description" : "Specify email address to send notification from (default is root@$hostname)",
                           "format" : "email-opt",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "fencing" : {
                           "default" : "watchdog",
                           "description" : "Set the fencing mode of the HA cluster. Hardware mode needs a valid configuration of fence devices in /etc/pve/ha/fence.cfg. With both all two modes are used.\n\nWARNING: 'hardware' and 'both' are EXPERIMENTAL & WIP",
                           "enum" : [
                              "watchdog",
                              "hardware",
                              "both"
                           ],
                           "optional" : 1,
                           "type" : "string"
                        },
                        "http_proxy" : {
                           "description" : "Specify external http proxy which is used for downloads (example: 'http://username:password@host:port/')",
                           "optional" : 1,
                           "pattern" : "http://.*",
                           "type" : "string"
                        },
                        "keyboard" : {
                           "description" : "Default keybord layout for vnc server.",
                           "enum" : [
                              "de",
                              "de-ch",
                              "da",
                              "en-gb",
                              "en-us",
                              "es",
                              "fi",
                              "fr",
                              "fr-be",
                              "fr-ca",
                              "fr-ch",
                              "hu",
                              "is",
                              "it",
                              "ja",
                              "lt",
                              "mk",
                              "nl",
                              "no",
                              "pl",
                              "pt",
                              "pt-br",
                              "sv",
                              "sl",
                              "tr"
                           ],
                           "optional" : 1,
                           "type" : "string"
                        },
                        "language" : {
                           "description" : "Default GUI language.",
                           "enum" : [
                              "en",
                              "de"
                           ],
                           "optional" : 1,
                           "type" : "string"
                        },
                        "mac_prefix" : {
                           "description" : "Prefix for autogenerated MAC addresses.",
                           "optional" : 1,
                           "pattern" : "(?^i:[a-f0-9]{2}(?::[a-f0-9]{2}){0,2}:?)",
                           "type" : "string"
                        },
                        "max_workers" : {
                           "description" : "Defines how many workers (per node) are maximal started  on actions like 'stopall VMs' or task from the ha-manager.",
                           "minimum" : 1,
                           "optional" : 1,
                           "type" : "integer",
                           "typetext" : "integer (1- N)"
                        },
                        "migration_unsecure" : {
                           "description" : "Migration is secure using SSH tunnel by default. For secure private networks you can disable it to speed up migration.",
                           "optional" : 1,
                           "type" : "boolean"
                        }
                     }
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/",
                        [
                           "Sys.Modify"
                        ]
                     ]
                  },
                  "protected" : 1,
                  "returns" : {
                     "type" : "null"
                  }
               }
            },
            "leaf" : 1,
            "path" : "/cluster/options",
            "text" : "options"
         },
         {
            "info" : {
               "GET" : {
                  "description" : "Get cluster status informations.",
                  "method" : "GET",
                  "name" : "get_status",
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/",
                        [
                           "Sys.Audit"
                        ]
                     ]
                  },
                  "protected" : 1,
                  "returns" : {
                     "items" : {
                        "properties" : {
                           "type" : {
                              "type" : "string"
                           }
                        },
                        "type" : "object"
                     },
                     "type" : "array"
                  }
               }
            },
            "leaf" : 1,
            "path" : "/cluster/status",
            "text" : "status"
         },
         {
            "info" : {
               "GET" : {
                  "description" : "Get next free VMID. If you pass an VMID it will raise an error if the ID is already used.",
                  "method" : "GET",
                  "name" : "nextid",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "vmid" : {
                           "description" : "The (unique) ID of the VM.",
                           "format" : "pve-vmid",
                           "minimum" : 1,
                           "optional" : 1,
                           "type" : "integer",
                           "typetext" : "integer (1- N)"
                        }
                     }
                  },
                  "permissions" : {
                     "user" : "all"
                  },
                  "returns" : {
                     "description" : "The next free VMID.",
                     "type" : "integer"
                  }
               }
            },
            "leaf" : 1,
            "path" : "/cluster/nextid",
            "text" : "nextid"
         }
      ],
      "info" : {
         "GET" : {
            "description" : "Cluster index.",
            "method" : "GET",
            "name" : "index",
            "parameters" : {
               "additionalProperties" : 0
            },
            "permissions" : {
               "user" : "all"
            },
            "returns" : {
               "items" : {
                  "properties" : {},
                  "type" : "object"
               },
               "links" : [
                  {
                     "href" : "{name}",
                     "rel" : "child"
                  }
               ],
               "type" : "array"
            }
         }
      },
      "leaf" : 0,
      "path" : "/cluster",
      "text" : "cluster"
   },
   {
      "children" : [
         {
            "children" : [
               {
                  "children" : [
                     {
                        "children" : [
                           {
                              "children" : [
                                 {
                                    "children" : [
                                       {
                                          "info" : {
                                             "DELETE" : {
                                                "description" : "Delete rule.",
                                                "method" : "DELETE",
                                                "name" : "delete_rule",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "digest" : {
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                         "maxLength" : 40,
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "pos" : {
                                                         "description" : "Update rule at position <pos>.",
                                                         "minimum" : 0,
                                                         "optional" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (0- N)"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "proxyto" : null,
                                                "returns" : {
                                                   "type" : "null"
                                                }
                                             },
                                             "GET" : {
                                                "description" : "Get single rule data.",
                                                "method" : "GET",
                                                "name" : "get_rule",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "pos" : {
                                                         "description" : "Update rule at position <pos>.",
                                                         "minimum" : 0,
                                                         "optional" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (0- N)"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Audit"
                                                      ]
                                                   ]
                                                },
                                                "proxyto" : null,
                                                "returns" : {
                                                   "properties" : {
                                                      "pos" : {
                                                         "type" : "integer"
                                                      }
                                                   },
                                                   "type" : "object"
                                                }
                                             },
                                             "PUT" : {
                                                "description" : "Modify rule data.",
                                                "method" : "PUT",
                                                "name" : "update_rule",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "action" : {
                                                         "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                                         "maxLength" : 20,
                                                         "minLength" : 2,
                                                         "optional" : 1,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "comment" : {
                                                         "description" : "Descriptive comment.",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "delete" : {
                                                         "description" : "A list of settings you want to delete.",
                                                         "format" : "pve-configid-list",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "dest" : {
                                                         "description" : "Restrict packet destination address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                                         "format" : "pve-fw-addr-spec",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "digest" : {
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                         "maxLength" : 40,
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "dport" : {
                                                         "description" : "Restrict TCP/UDP destination port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                                         "format" : "pve-fw-dport-spec",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "enable" : {
                                                         "description" : "Flag to enable/disable a rule.",
                                                         "minimum" : 0,
                                                         "optional" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (0- N)"
                                                      },
                                                      "iface" : {
                                                         "description" : "Network interface name. You have to use network configuration key names for VMs and containers ('net\\d+'). Host related rules can use arbitrary strings.",
                                                         "format" : "pve-iface",
                                                         "maxLength" : 20,
                                                         "minLength" : 2,
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "macro" : {
                                                         "description" : "Use predefined standard macro.",
                                                         "maxLength" : 128,
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "moveto" : {
                                                         "description" : "Move rule to new position <moveto>. Other arguments are ignored.",
                                                         "minimum" : 0,
                                                         "optional" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (0- N)"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "pos" : {
                                                         "description" : "Update rule at position <pos>.",
                                                         "minimum" : 0,
                                                         "optional" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (0- N)"
                                                      },
                                                      "proto" : {
                                                         "description" : "IP protocol. You can use protocol names ('tcp'/'udp') or simple numbers, as defined in '/etc/protocols'.",
                                                         "format" : "pve-fw-protocol-spec",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "source" : {
                                                         "description" : "Restrict packet source address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                                         "format" : "pve-fw-addr-spec",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "sport" : {
                                                         "description" : "Restrict TCP/UDP source port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                                         "format" : "pve-fw-sport-spec",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "type" : {
                                                         "description" : "Rule type.",
                                                         "enum" : [
                                                            "in",
                                                            "out",
                                                            "group"
                                                         ],
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "proxyto" : null,
                                                "returns" : {
                                                   "type" : "null"
                                                }
                                             }
                                          },
                                          "leaf" : 1,
                                          "path" : "/nodes/{node}/qemu/{vmid}/firewall/rules/{pos}",
                                          "text" : "{pos}"
                                       }
                                    ],
                                    "info" : {
                                       "GET" : {
                                          "description" : "List rules.",
                                          "method" : "GET",
                                          "name" : "get_rules",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "proxyto" : null,
                                          "returns" : {
                                             "items" : {
                                                "properties" : {
                                                   "pos" : {
                                                      "type" : "integer"
                                                   }
                                                },
                                                "type" : "object"
                                             },
                                             "links" : [
                                                {
                                                   "href" : "{pos}",
                                                   "rel" : "child"
                                                }
                                             ],
                                             "type" : "array"
                                          }
                                       },
                                       "POST" : {
                                          "description" : "Create new rule.",
                                          "method" : "POST",
                                          "name" : "create_rule",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "action" : {
                                                   "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                                   "maxLength" : 20,
                                                   "minLength" : 2,
                                                   "optional" : 0,
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "type" : "string"
                                                },
                                                "comment" : {
                                                   "description" : "Descriptive comment.",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "dest" : {
                                                   "description" : "Restrict packet destination address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                                   "format" : "pve-fw-addr-spec",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "digest" : {
                                                   "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                   "maxLength" : 40,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "dport" : {
                                                   "description" : "Restrict TCP/UDP destination port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                                   "format" : "pve-fw-dport-spec",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "enable" : {
                                                   "description" : "Flag to enable/disable a rule.",
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (0- N)"
                                                },
                                                "iface" : {
                                                   "description" : "Network interface name. You have to use network configuration key names for VMs and containers ('net\\d+'). Host related rules can use arbitrary strings.",
                                                   "format" : "pve-iface",
                                                   "maxLength" : 20,
                                                   "minLength" : 2,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "macro" : {
                                                   "description" : "Use predefined standard macro.",
                                                   "maxLength" : 128,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "pos" : {
                                                   "description" : "Update rule at position <pos>.",
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (0- N)"
                                                },
                                                "proto" : {
                                                   "description" : "IP protocol. You can use protocol names ('tcp'/'udp') or simple numbers, as defined in '/etc/protocols'.",
                                                   "format" : "pve-fw-protocol-spec",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "source" : {
                                                   "description" : "Restrict packet source address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                                   "format" : "pve-fw-addr-spec",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "sport" : {
                                                   "description" : "Restrict TCP/UDP source port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                                   "format" : "pve-fw-sport-spec",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "type" : {
                                                   "description" : "Rule type.",
                                                   "enum" : [
                                                      "in",
                                                      "out",
                                                      "group"
                                                   ],
                                                   "optional" : 0,
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : null,
                                          "returns" : {
                                             "type" : "null"
                                          }
                                       }
                                    },
                                    "leaf" : 0,
                                    "path" : "/nodes/{node}/qemu/{vmid}/firewall/rules",
                                    "text" : "rules"
                                 },
                                 {
                                    "children" : [
                                       {
                                          "info" : {
                                             "DELETE" : {
                                                "description" : "Remove IP or Network alias.",
                                                "method" : "DELETE",
                                                "name" : "remove_alias",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "digest" : {
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                         "maxLength" : 40,
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "name" : {
                                                         "description" : "Alias name.",
                                                         "maxLength" : 64,
                                                         "minLength" : 2,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "returns" : {
                                                   "type" : "null"
                                                }
                                             },
                                             "GET" : {
                                                "description" : "Read alias.",
                                                "method" : "GET",
                                                "name" : "read_alias",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "name" : {
                                                         "description" : "Alias name.",
                                                         "maxLength" : 64,
                                                         "minLength" : 2,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Audit"
                                                      ]
                                                   ]
                                                },
                                                "returns" : {
                                                   "type" : "object"
                                                }
                                             },
                                             "PUT" : {
                                                "description" : "Update IP or Network alias.",
                                                "method" : "PUT",
                                                "name" : "update_alias",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "cidr" : {
                                                         "description" : "Network/IP specification in CIDR format.",
                                                         "format" : "IPorCIDR",
                                                         "type" : "string"
                                                      },
                                                      "comment" : {
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "digest" : {
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                         "maxLength" : 40,
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "name" : {
                                                         "description" : "Alias name.",
                                                         "maxLength" : 64,
                                                         "minLength" : 2,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "rename" : {
                                                         "description" : "Rename an existing alias.",
                                                         "maxLength" : 64,
                                                         "minLength" : 2,
                                                         "optional" : 1,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "returns" : {
                                                   "type" : "null"
                                                }
                                             }
                                          },
                                          "leaf" : 1,
                                          "path" : "/nodes/{node}/qemu/{vmid}/firewall/aliases/{name}",
                                          "text" : "{name}"
                                       }
                                    ],
                                    "info" : {
                                       "GET" : {
                                          "description" : "List aliases",
                                          "method" : "GET",
                                          "name" : "get_aliases",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "returns" : {
                                             "items" : {
                                                "properties" : {
                                                   "cidr" : {
                                                      "type" : "string"
                                                   },
                                                   "comment" : {
                                                      "optional" : 1,
                                                      "type" : "string"
                                                   },
                                                   "digest" : {
                                                      "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                      "maxLength" : 40,
                                                      "optional" : 0,
                                                      "type" : "string"
                                                   },
                                                   "name" : {
                                                      "type" : "string"
                                                   }
                                                },
                                                "type" : "object"
                                             },
                                             "links" : [
                                                {
                                                   "href" : "{name}",
                                                   "rel" : "child"
                                                }
                                             ],
                                             "type" : "array"
                                          }
                                       },
                                       "POST" : {
                                          "description" : "Create IP or Network Alias.",
                                          "method" : "POST",
                                          "name" : "create_alias",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "cidr" : {
                                                   "description" : "Network/IP specification in CIDR format.",
                                                   "format" : "IPorCIDR",
                                                   "type" : "string"
                                                },
                                                "comment" : {
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "name" : {
                                                   "description" : "Alias name.",
                                                   "maxLength" : 64,
                                                   "minLength" : 2,
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "type" : "string"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "returns" : {
                                             "type" : "null"
                                          }
                                       }
                                    },
                                    "leaf" : 0,
                                    "path" : "/nodes/{node}/qemu/{vmid}/firewall/aliases",
                                    "text" : "aliases"
                                 },
                                 {
                                    "children" : [
                                       {
                                          "children" : [
                                             {
                                                "info" : {
                                                   "DELETE" : {
                                                      "description" : "Remove IP or Network from IPSet.",
                                                      "method" : "DELETE",
                                                      "name" : "remove_ip",
                                                      "parameters" : {
                                                         "additionalProperties" : 0,
                                                         "properties" : {
                                                            "cidr" : {
                                                               "description" : "Network/IP specification in CIDR format.",
                                                               "format" : "IPorCIDRorAlias",
                                                               "type" : "string"
                                                            },
                                                            "digest" : {
                                                               "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                               "maxLength" : 40,
                                                               "optional" : 1,
                                                               "type" : "string"
                                                            },
                                                            "name" : {
                                                               "description" : "IP set name.",
                                                               "maxLength" : 64,
                                                               "minLength" : 2,
                                                               "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                               "type" : "string"
                                                            },
                                                            "node" : {
                                                               "description" : "The cluster node name.",
                                                               "format" : "pve-node",
                                                               "type" : "string"
                                                            },
                                                            "vmid" : {
                                                               "description" : "The (unique) ID of the VM.",
                                                               "format" : "pve-vmid",
                                                               "minimum" : 1,
                                                               "type" : "integer",
                                                               "typetext" : "integer (1- N)"
                                                            }
                                                         }
                                                      },
                                                      "permissions" : {
                                                         "check" : [
                                                            "perm",
                                                            "/vms/{vmid}",
                                                            [
                                                               "VM.Config.Network"
                                                            ]
                                                         ]
                                                      },
                                                      "protected" : 1,
                                                      "returns" : {
                                                         "type" : "null"
                                                      }
                                                   },
                                                   "GET" : {
                                                      "description" : "Read IP or Network settings from IPSet.",
                                                      "method" : "GET",
                                                      "name" : "read_ip",
                                                      "parameters" : {
                                                         "additionalProperties" : 0,
                                                         "properties" : {
                                                            "cidr" : {
                                                               "description" : "Network/IP specification in CIDR format.",
                                                               "format" : "IPorCIDRorAlias",
                                                               "type" : "string"
                                                            },
                                                            "name" : {
                                                               "description" : "IP set name.",
                                                               "maxLength" : 64,
                                                               "minLength" : 2,
                                                               "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                               "type" : "string"
                                                            },
                                                            "node" : {
                                                               "description" : "The cluster node name.",
                                                               "format" : "pve-node",
                                                               "type" : "string"
                                                            },
                                                            "vmid" : {
                                                               "description" : "The (unique) ID of the VM.",
                                                               "format" : "pve-vmid",
                                                               "minimum" : 1,
                                                               "type" : "integer",
                                                               "typetext" : "integer (1- N)"
                                                            }
                                                         }
                                                      },
                                                      "permissions" : {
                                                         "check" : [
                                                            "perm",
                                                            "/vms/{vmid}",
                                                            [
                                                               "VM.Audit"
                                                            ]
                                                         ]
                                                      },
                                                      "protected" : 1,
                                                      "returns" : {
                                                         "type" : "object"
                                                      }
                                                   },
                                                   "PUT" : {
                                                      "description" : "Update IP or Network settings",
                                                      "method" : "PUT",
                                                      "name" : "update_ip",
                                                      "parameters" : {
                                                         "additionalProperties" : 0,
                                                         "properties" : {
                                                            "cidr" : {
                                                               "description" : "Network/IP specification in CIDR format.",
                                                               "format" : "IPorCIDRorAlias",
                                                               "type" : "string"
                                                            },
                                                            "comment" : {
                                                               "optional" : 1,
                                                               "type" : "string"
                                                            },
                                                            "digest" : {
                                                               "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                               "maxLength" : 40,
                                                               "optional" : 1,
                                                               "type" : "string"
                                                            },
                                                            "name" : {
                                                               "description" : "IP set name.",
                                                               "maxLength" : 64,
                                                               "minLength" : 2,
                                                               "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                               "type" : "string"
                                                            },
                                                            "node" : {
                                                               "description" : "The cluster node name.",
                                                               "format" : "pve-node",
                                                               "type" : "string"
                                                            },
                                                            "nomatch" : {
                                                               "optional" : 1,
                                                               "type" : "boolean"
                                                            },
                                                            "vmid" : {
                                                               "description" : "The (unique) ID of the VM.",
                                                               "format" : "pve-vmid",
                                                               "minimum" : 1,
                                                               "type" : "integer",
                                                               "typetext" : "integer (1- N)"
                                                            }
                                                         }
                                                      },
                                                      "permissions" : {
                                                         "check" : [
                                                            "perm",
                                                            "/vms/{vmid}",
                                                            [
                                                               "VM.Config.Network"
                                                            ]
                                                         ]
                                                      },
                                                      "protected" : 1,
                                                      "returns" : {
                                                         "type" : "null"
                                                      }
                                                   }
                                                },
                                                "leaf" : 1,
                                                "path" : "/nodes/{node}/qemu/{vmid}/firewall/ipset/{name}/{cidr}",
                                                "text" : "{cidr}"
                                             }
                                          ],
                                          "info" : {
                                             "DELETE" : {
                                                "description" : "Delete IPSet",
                                                "method" : "DELETE",
                                                "name" : "delete_ipset",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "name" : {
                                                         "description" : "IP set name.",
                                                         "maxLength" : 64,
                                                         "minLength" : 2,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "returns" : {
                                                   "type" : "null"
                                                }
                                             },
                                             "GET" : {
                                                "description" : "List IPSet content",
                                                "method" : "GET",
                                                "name" : "get_ipset",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "name" : {
                                                         "description" : "IP set name.",
                                                         "maxLength" : 64,
                                                         "minLength" : 2,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Audit"
                                                      ]
                                                   ]
                                                },
                                                "returns" : {
                                                   "items" : {
                                                      "properties" : {
                                                         "cidr" : {
                                                            "type" : "string"
                                                         },
                                                         "comment" : {
                                                            "optional" : 1,
                                                            "type" : "string"
                                                         },
                                                         "digest" : {
                                                            "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                            "maxLength" : 40,
                                                            "optional" : 0,
                                                            "type" : "string"
                                                         },
                                                         "nomatch" : {
                                                            "optional" : 1,
                                                            "type" : "boolean"
                                                         }
                                                      },
                                                      "type" : "object"
                                                   },
                                                   "links" : [
                                                      {
                                                         "href" : "{cidr}",
                                                         "rel" : "child"
                                                      }
                                                   ],
                                                   "type" : "array"
                                                }
                                             },
                                             "POST" : {
                                                "description" : "Add IP or Network to IPSet.",
                                                "method" : "POST",
                                                "name" : "create_ip",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "cidr" : {
                                                         "description" : "Network/IP specification in CIDR format.",
                                                         "format" : "IPorCIDRorAlias",
                                                         "type" : "string"
                                                      },
                                                      "comment" : {
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "name" : {
                                                         "description" : "IP set name.",
                                                         "maxLength" : 64,
                                                         "minLength" : 2,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "nomatch" : {
                                                         "optional" : 1,
                                                         "type" : "boolean"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "returns" : {
                                                   "type" : "null"
                                                }
                                             }
                                          },
                                          "leaf" : 0,
                                          "path" : "/nodes/{node}/qemu/{vmid}/firewall/ipset/{name}",
                                          "text" : "{name}"
                                       }
                                    ],
                                    "info" : {
                                       "GET" : {
                                          "description" : "List IPSets",
                                          "method" : "GET",
                                          "name" : "ipset_index",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "returns" : {
                                             "items" : {
                                                "properties" : {
                                                   "comment" : {
                                                      "optional" : 1,
                                                      "type" : "string"
                                                   },
                                                   "digest" : {
                                                      "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                      "maxLength" : 40,
                                                      "optional" : 0,
                                                      "type" : "string"
                                                   },
                                                   "name" : {
                                                      "description" : "IP set name.",
                                                      "maxLength" : 64,
                                                      "minLength" : 2,
                                                      "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                      "type" : "string"
                                                   }
                                                },
                                                "type" : "object"
                                             },
                                             "links" : [
                                                {
                                                   "href" : "{name}",
                                                   "rel" : "child"
                                                }
                                             ],
                                             "type" : "array"
                                          }
                                       },
                                       "POST" : {
                                          "description" : "Create new IPSet",
                                          "method" : "POST",
                                          "name" : "create_ipset",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "comment" : {
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "digest" : {
                                                   "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                   "maxLength" : 40,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "name" : {
                                                   "description" : "IP set name.",
                                                   "maxLength" : 64,
                                                   "minLength" : 2,
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "type" : "string"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "rename" : {
                                                   "description" : "Rename an existing IPSet. You can set 'rename' to the same value as 'name' to update the 'comment' of an existing IPSet.",
                                                   "maxLength" : 64,
                                                   "minLength" : 2,
                                                   "optional" : 1,
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "returns" : {
                                             "type" : "null"
                                          }
                                       }
                                    },
                                    "leaf" : 0,
                                    "path" : "/nodes/{node}/qemu/{vmid}/firewall/ipset",
                                    "text" : "ipset"
                                 },
                                 {
                                    "info" : {
                                       "GET" : {
                                          "description" : "Get VM firewall options.",
                                          "method" : "GET",
                                          "name" : "get_options",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "proxyto" : "node",
                                          "returns" : {
                                             "properties" : {
                                                "dhcp" : {
                                                   "description" : "Enable DHCP.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "enable" : {
                                                   "description" : "Enable/disable firewall rules.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "ipfilter" : {
                                                   "description" : "Enable default IP filters. This is equivalent to adding an empty ipfilter-net<id> ipset for every interface. Such ipsets implicitly contain sane default restrictions such as restricting IPv6 link local addresses to the one derived from the interface's MAC address. For containers the configured IP addresses will be implicitly added.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "log_level_in" : {
                                                   "description" : "Log level for incoming traffic.",
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "log_level_out" : {
                                                   "description" : "Log level for outgoing traffic.",
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "macfilter" : {
                                                   "description" : "Enable/disable MAC address filter.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "ndp" : {
                                                   "description" : "Enable NDP.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "policy_in" : {
                                                   "description" : "Input policy.",
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "policy_out" : {
                                                   "description" : "Output policy.",
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "radv" : {
                                                   "description" : "Allow sending Router Advertisement.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                }
                                             },
                                             "type" : "object"
                                          }
                                       },
                                       "PUT" : {
                                          "description" : "Set Firewall options.",
                                          "method" : "PUT",
                                          "name" : "set_options",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "delete" : {
                                                   "description" : "A list of settings you want to delete.",
                                                   "format" : "pve-configid-list",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "dhcp" : {
                                                   "description" : "Enable DHCP.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "digest" : {
                                                   "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                   "maxLength" : 40,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "enable" : {
                                                   "description" : "Enable/disable firewall rules.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "ipfilter" : {
                                                   "description" : "Enable default IP filters. This is equivalent to adding an empty ipfilter-net<id> ipset for every interface. Such ipsets implicitly contain sane default restrictions such as restricting IPv6 link local addresses to the one derived from the interface's MAC address. For containers the configured IP addresses will be implicitly added.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "log_level_in" : {
                                                   "description" : "Log level for incoming traffic.",
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "log_level_out" : {
                                                   "description" : "Log level for outgoing traffic.",
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "macfilter" : {
                                                   "description" : "Enable/disable MAC address filter.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "ndp" : {
                                                   "description" : "Enable NDP.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "policy_in" : {
                                                   "description" : "Input policy.",
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "policy_out" : {
                                                   "description" : "Output policy.",
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "radv" : {
                                                   "description" : "Allow sending Router Advertisement.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "null"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/qemu/{vmid}/firewall/options",
                                    "text" : "options"
                                 },
                                 {
                                    "info" : {
                                       "GET" : {
                                          "description" : "Read firewall log",
                                          "method" : "GET",
                                          "name" : "log",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "limit" : {
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (0- N)"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "start" : {
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (0- N)"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Console"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "items" : {
                                                "properties" : {
                                                   "n" : {
                                                      "description" : "Line number",
                                                      "type" : "integer"
                                                   },
                                                   "t" : {
                                                      "description" : "Line text",
                                                      "type" : "string"
                                                   }
                                                },
                                                "type" : "object"
                                             },
                                             "type" : "array"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/qemu/{vmid}/firewall/log",
                                    "text" : "log"
                                 },
                                 {
                                    "info" : {
                                       "GET" : {
                                          "description" : "Lists possible IPSet/Alias reference which are allowed in source/dest properties.",
                                          "method" : "GET",
                                          "name" : "refs",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "type" : {
                                                   "description" : "Only list references of specified type.",
                                                   "enum" : [
                                                      "alias",
                                                      "ipset"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "returns" : {
                                             "items" : {
                                                "properties" : {
                                                   "comment" : {
                                                      "optional" : 1,
                                                      "type" : "string"
                                                   },
                                                   "name" : {
                                                      "type" : "string"
                                                   },
                                                   "type" : {
                                                      "enum" : [
                                                         "alias",
                                                         "ipset"
                                                      ],
                                                      "type" : "string"
                                                   }
                                                },
                                                "type" : "object"
                                             },
                                             "type" : "array"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/qemu/{vmid}/firewall/refs",
                                    "text" : "refs"
                                 }
                              ],
                              "info" : {
                                 "GET" : {
                                    "description" : "Directory index.",
                                    "method" : "GET",
                                    "name" : "index",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "user" : "all"
                                    },
                                    "returns" : {
                                       "items" : {
                                          "properties" : {},
                                          "type" : "object"
                                       },
                                       "links" : [
                                          {
                                             "href" : "{name}",
                                             "rel" : "child"
                                          }
                                       ],
                                       "type" : "array"
                                    }
                                 }
                              },
                              "leaf" : 0,
                              "path" : "/nodes/{node}/qemu/{vmid}/firewall",
                              "text" : "firewall"
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Read VM RRD statistics (returns PNG)",
                                    "method" : "GET",
                                    "name" : "rrd",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "cf" : {
                                             "description" : "The RRD consolidation function",
                                             "enum" : [
                                                "AVERAGE",
                                                "MAX"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "ds" : {
                                             "description" : "The list of datasources you want to display.",
                                             "format" : "pve-configid-list",
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "timeframe" : {
                                             "description" : "Specify the time frame you are interested in.",
                                             "enum" : [
                                                "hour",
                                                "day",
                                                "week",
                                                "month",
                                                "year"
                                             ],
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "returns" : {
                                       "properties" : {
                                          "filename" : {
                                             "type" : "string"
                                          }
                                       },
                                       "type" : "object"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/rrd",
                              "text" : "rrd"
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Read VM RRD statistics",
                                    "method" : "GET",
                                    "name" : "rrddata",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "cf" : {
                                             "description" : "The RRD consolidation function",
                                             "enum" : [
                                                "AVERAGE",
                                                "MAX"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "timeframe" : {
                                             "description" : "Specify the time frame you are interested in.",
                                             "enum" : [
                                                "hour",
                                                "day",
                                                "week",
                                                "month",
                                                "year"
                                             ],
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "returns" : {
                                       "items" : {
                                          "properties" : {},
                                          "type" : "object"
                                       },
                                       "type" : "array"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/rrddata",
                              "text" : "rrddata"
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Get current virtual machine configuration. This does not include pending configuration changes (see 'pending' API).",
                                    "method" : "GET",
                                    "name" : "vm_config",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "current" : {
                                             "default" : 0,
                                             "description" : "Get current values (instead of pending values).",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "proxyto" : "node",
                                    "returns" : {
                                       "properties" : {
                                          "digest" : {
                                             "description" : "SHA1 digest of configuration file. This can be used to prevent concurrent modifications.",
                                             "type" : "string"
                                          }
                                       },
                                       "type" : "object"
                                    }
                                 },
                                 "POST" : {
                                    "description" : "Set virtual machine options (asynchrounous API).",
                                    "method" : "POST",
                                    "name" : "update_vm_async",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "acpi" : {
                                             "default" : 1,
                                             "description" : "Enable/disable ACPI.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "agent" : {
                                             "default" : 0,
                                             "description" : "Enable/disable Qemu GuestAgent.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "args" : {
                                             "description" : "Arbitrary arguments passed to kvm.",
                                             "optional" : 1,
                                             "type" : "string",
                                             "verbose_description" : "Arbitrary arguments passed to kvm, for example:\n\nargs: -no-reboot -no-hpet\n\nNOTE: this option is for experts only.\n"
                                          },
                                          "autostart" : {
                                             "default" : 0,
                                             "description" : "Automatic restart after crash (currently ignored).",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "background_delay" : {
                                             "description" : "Time to wait for the task to finish. We return 'null' if the task finish within that time.",
                                             "maximum" : 30,
                                             "minimum" : 1,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1-30)"
                                          },
                                          "balloon" : {
                                             "description" : "Amount of target RAM for the VM in MB. Using zero disables the ballon driver.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          },
                                          "bios" : {
                                             "default" : "seabios",
                                             "description" : "Select BIOS implementation.",
                                             "enum" : [
                                                "seabios",
                                                "ovmf"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "boot" : {
                                             "default" : "cdn",
                                             "description" : "Boot on floppy (a), hard disk (c), CD-ROM (d), or network (n).",
                                             "optional" : 1,
                                             "pattern" : "[acdn]{1,4}",
                                             "type" : "string"
                                          },
                                          "bootdisk" : {
                                             "description" : "Enable booting from specified disk.",
                                             "format" : "pve-qm-bootdisk",
                                             "optional" : 1,
                                             "pattern" : "(ide|sata|scsi|virtio)\\d+",
                                             "type" : "string"
                                          },
                                          "cdrom" : {
                                             "description" : "This is an alias for option -ide2",
                                             "format" : "pve-qm-drive",
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "volume"
                                          },
                                          "cores" : {
                                             "default" : 1,
                                             "description" : "The number of cores per socket.",
                                             "minimum" : 1,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "cpu" : {
                                             "description" : "Emulated CPU type.",
                                             "format" : {
                                                "cputype" : {
                                                   "default" : "kvm64",
                                                   "default_key" : 1,
                                                   "description" : "Emulated CPU type.",
                                                   "enum" : [
                                                      "486",
                                                      "athlon",
                                                      "Broadwell",
                                                      "Broadwell-noTSX",
                                                      "Conroe",
                                                      "core2duo",
                                                      "coreduo",
                                                      "Haswell",
                                                      "Haswell-noTSX",
                                                      "host",
                                                      "IvyBridge",
                                                      "kvm32",
                                                      "kvm64",
                                                      "Nehalem",
                                                      "Opteron_G1",
                                                      "Opteron_G2",
                                                      "Opteron_G3",
                                                      "Opteron_G4",
                                                      "Opteron_G5",
                                                      "Penryn",
                                                      "pentium",
                                                      "pentium2",
                                                      "pentium3",
                                                      "phenom",
                                                      "qemu32",
                                                      "qemu64",
                                                      "SandyBridge",
                                                      "Westmere"
                                                   ],
                                                   "format_description" : "cputype",
                                                   "type" : "string"
                                                },
                                                "hidden" : {
                                                   "default" : 0,
                                                   "description" : "Do not identify as a KVM virtual machine.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[cputype=]<cputype> [,hidden=<1|0>]"
                                          },
                                          "cpulimit" : {
                                             "default" : 0,
                                             "description" : "Limit of CPU usage.",
                                             "maximum" : 128,
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "number",
                                             "typetext" : "number (0-128)",
                                             "verbose_description" : "Limit of CPU usage.\n\nNOTE: If the computer has 2 CPUs, it has total of '2' CPU time. Value '0' indicates no CPU limit."
                                          },
                                          "cpuunits" : {
                                             "default" : 1000,
                                             "description" : "CPU weight for a VM.",
                                             "maximum" : 500000,
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0-500000)",
                                             "verbose_description" : "CPU weight for a VM. Argument is used in the kernel fair scheduler. The larger the number is, the more CPU time this VM gets. Number is relative to weights of all the other running VMs.\n\nNOTE: You can disable fair-scheduler configuration by setting this to 0."
                                          },
                                          "delete" : {
                                             "description" : "A list of settings you want to delete.",
                                             "format" : "pve-configid-list",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "description" : {
                                             "description" : "Description for the VM. Only used on the configuration web interface. This is saved as comment inside the configuration file.",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "digest" : {
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "force" : {
                                             "description" : "Force physical removal. Without this, we simple remove the disk from the config file and create an additional configuration entry called 'unused[n]', which contains the volume ID. Unlink of unused[n] always cause physical removal.",
                                             "optional" : 1,
                                             "requires" : "delete",
                                             "type" : "boolean"
                                          },
                                          "freeze" : {
                                             "description" : "Freeze CPU at startup (use 'c' monitor command to start execution).",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "hostpci[n]" : {
                                             "description" : "Map host PCI devices into guest.",
                                             "format" : "pve-qm-hostpci",
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[host=]<HOSTPCIID[;HOSTPCIID2...]> [,pcie=<1|0>] [,rombar=<1|0>] [,x-vga=<1|0>]",
                                             "verbose_description" : "Map host PCI devices into guest.\n\nNOTE: This option allows direct access to host hardware. So it is no longer \npossible to migrate such machines - use with special care.\n\nCAUTION: Experimental! User reported problems with this option.\n"
                                          },
                                          "hotplug" : {
                                             "default" : "network,disk,usb",
                                             "description" : "Selectively enable hotplug features. This is a comma separated list of hotplug features: 'network', 'disk', 'cpu', 'memory' and 'usb'. Use '0' to disable hotplug completely. Value '1' is an alias for the default 'network,disk,usb'.",
                                             "format" : "pve-hotplug-features",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "hugepages" : {
                                             "description" : "Enable/disable hugepages memory.",
                                             "enum" : [
                                                "any",
                                                "2",
                                                "1024"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "ide[n]" : {
                                             "description" : "Use volume as IDE hard disk or CD-ROM (n is 0 to 3).",
                                             "format" : {
                                                "aio" : {
                                                   "description" : "AIO type to use.",
                                                   "enum" : [
                                                      "native",
                                                      "threads"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "backup" : {
                                                   "description" : "Whether the drive should be included when making backups.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "bps" : {
                                                   "description" : "Maximum r/w speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_rd" : {
                                                   "description" : "Maximum read speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_wr" : {
                                                   "description" : "Maximum write speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "cache" : {
                                                   "description" : "The drive's cache mode",
                                                   "enum" : [
                                                      "none",
                                                      "writethrough",
                                                      "writeback",
                                                      "unsafe",
                                                      "directsync"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "cyls" : {
                                                   "description" : "Force the drive's physical geometry to have a specific cylinder count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "detect_zeroes" : {
                                                   "description" : "Controls whether to detect and try to optimize writes of zeroes.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "discard" : {
                                                   "description" : "Controls whether to pass discard/trim requests to the underlying storage.",
                                                   "enum" : [
                                                      "ignore",
                                                      "on"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "file" : {
                                                   "default_key" : 1,
                                                   "description" : "The drive's backing volume.",
                                                   "format" : "pve-volume-id-or-qm-path",
                                                   "format_description" : "volume",
                                                   "type" : "string"
                                                },
                                                "format" : {
                                                   "description" : "The drive's backing file's data format.",
                                                   "enum" : [
                                                      "raw",
                                                      "cow",
                                                      "qcow",
                                                      "qed",
                                                      "qcow2",
                                                      "vmdk",
                                                      "cloop"
                                                   ],
                                                   "format_description" : "image format",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "heads" : {
                                                   "description" : "Force the drive's physical geometry to have a specific head count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops" : {
                                                   "description" : "Maximum r/w I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_max" : {
                                                   "description" : "Maximum unthrottled r/w I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd" : {
                                                   "description" : "Maximum read I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd_max" : {
                                                   "description" : "Maximum unthrottled read I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr" : {
                                                   "description" : "Maximum write I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr_max" : {
                                                   "description" : "Maximum unthrottled write I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "mbps" : {
                                                   "description" : "Maximum r/w speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_max" : {
                                                   "description" : "Maximum unthrottled r/w pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd" : {
                                                   "description" : "Maximum read speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd_max" : {
                                                   "description" : "Maximum unthrottled read pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr" : {
                                                   "description" : "Maximum write speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr_max" : {
                                                   "description" : "Maximum unthrottled write pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "media" : {
                                                   "default" : "disk",
                                                   "description" : "The drive's media type.",
                                                   "enum" : [
                                                      "cdrom",
                                                      "disk"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "model" : {
                                                   "description" : "The drive's reported model name, url-encoded, up to 40 bytes long.",
                                                   "format" : "urlencoded",
                                                   "format_description" : "model",
                                                   "maxLength" : 120,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "rerror" : {
                                                   "description" : "Read error action.",
                                                   "enum" : [
                                                      "ignore",
                                                      "report",
                                                      "stop"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "secs" : {
                                                   "description" : "Force the drive's physical geometry to have a specific sector count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "serial" : {
                                                   "description" : "The drive's reported serial number, url-encoded, up to 20 bytes long.",
                                                   "format" : "urlencoded",
                                                   "format_description" : "serial",
                                                   "maxLength" : 60,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "size" : {
                                                   "description" : "Disk size. This is purely informational and has no effect.",
                                                   "format" : "disk-size",
                                                   "format_description" : "DiskSize",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "snapshot" : {
                                                   "description" : "Whether the drive should be included when making snapshots.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "trans" : {
                                                   "description" : "Force disk geometry bios translation mode.",
                                                   "enum" : [
                                                      "none",
                                                      "lba",
                                                      "auto"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "volume" : {
                                                   "alias" : "file"
                                                },
                                                "werror" : {
                                                   "description" : "Write error action.",
                                                   "enum" : [
                                                      "enospc",
                                                      "ignore",
                                                      "report",
                                                      "stop"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[file=]<volume> [,aio=<native|threads>] [,backup=<1|0>] [,bps=<bps>] [,bps_rd=<bps>] [,bps_wr=<bps>] [,cache=<none|writethrough|writeback|unsafe|directsync>] [,cyls=<integer>] [,detect_zeroes=<1|0>] [,discard=<ignore|on>] [,format=<image format>] [,heads=<integer>] [,iops=<iops>] [,iops_max=<iops>] [,iops_rd=<iops>] [,iops_rd_max=<iops>] [,iops_wr=<iops>] [,iops_wr_max=<iops>] [,mbps=<mbps>] [,mbps_max=<mbps>] [,mbps_rd=<mbps>] [,mbps_rd_max=<mbps>] [,mbps_wr=<mbps>] [,mbps_wr_max=<mbps>] [,media=<cdrom|disk>] [,model=<model>] [,rerror=<ignore|report|stop>] [,secs=<integer>] [,serial=<serial>] [,size=<DiskSize>] [,snapshot=<1|0>] [,trans=<none|lba|auto>] [,werror=<enospc|ignore|report|stop>]"
                                          },
                                          "keyboard" : {
                                             "default" : "en-us",
                                             "description" : "Keybord layout for vnc server. Default is read from the '/etc/pve/datacenter.conf' configuration file.",
                                             "enum" : [
                                                "de",
                                                "de-ch",
                                                "da",
                                                "en-gb",
                                                "en-us",
                                                "es",
                                                "fi",
                                                "fr",
                                                "fr-be",
                                                "fr-ca",
                                                "fr-ch",
                                                "hu",
                                                "is",
                                                "it",
                                                "ja",
                                                "lt",
                                                "mk",
                                                "nl",
                                                "no",
                                                "pl",
                                                "pt",
                                                "pt-br",
                                                "sv",
                                                "sl",
                                                "tr"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "kvm" : {
                                             "default" : 1,
                                             "description" : "Enable/disable KVM hardware virtualization.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "localtime" : {
                                             "description" : "Set the real time clock to local time. This is enabled by default if ostype indicates a Microsoft OS.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "lock" : {
                                             "description" : "Lock/unlock the VM.",
                                             "enum" : [
                                                "migrate",
                                                "backup",
                                                "snapshot",
                                                "rollback"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "machine" : {
                                             "description" : "Specific the Qemu machine type.",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "pattern" : "(pc|pc(-i440fx)?-\\d+\\.\\d+(\\.pxe)?|q35|pc-q35-\\d+\\.\\d+(\\.pxe)?)",
                                             "type" : "string"
                                          },
                                          "memory" : {
                                             "default" : 512,
                                             "description" : "Amount of RAM for the VM in MB. This is the maximum available memory when you use the balloon device.",
                                             "minimum" : 16,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (16- N)"
                                          },
                                          "migrate_downtime" : {
                                             "default" : 0.1,
                                             "description" : "Set maximum tolerated downtime (in seconds) for migrations.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "number",
                                             "typetext" : "number (0- N)"
                                          },
                                          "migrate_speed" : {
                                             "default" : 0,
                                             "description" : "Set maximum speed (in MB/s) for migrations. Value 0 is no limit.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          },
                                          "name" : {
                                             "description" : "Set a name for the VM. Only used on the configuration web interface.",
                                             "format" : "dns-name",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "net[n]" : {
                                             "description" : "Specify network devices.",
                                             "format" : {
                                                "bridge" : {
                                                   "description" : "Bridge to attach the network device to. The Proxmox VE standard bridge\nis called 'vmbr0'.\n\nIf you do not specify a bridge, we create a kvm user (NATed) network\ndevice, which provides DHCP and DNS services. The following addresses\nare used:\n\n 10.0.2.2   Gateway\n 10.0.2.3   DNS Server\n 10.0.2.4   SMB Server\n\nThe DHCP server assign addresses to the guest starting from 10.0.2.15.\n",
                                                   "format_description" : "bridge",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "e1000" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "e1000-82540em" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "e1000-82544gc" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "e1000-82545em" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "firewall" : {
                                                   "description" : "Whether this interface should be protected by the firewall.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "i82551" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "i82557b" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "i82559er" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "link_down" : {
                                                   "description" : "Whether this interface should be disconnected (like pulling the plug).",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "macaddr" : {
                                                   "description" : "MAC address. That address must be unique withing your network. This is automatically generated if not specified.",
                                                   "format_description" : "XX:XX:XX:XX:XX:XX",
                                                   "optional" : 1,
                                                   "pattern" : "(?^i:[0-9a-f]{2}(?::[0-9a-f]{2}){5})",
                                                   "type" : "string"
                                                },
                                                "model" : {
                                                   "default_key" : 1,
                                                   "description" : "Network Card Model. The 'virtio' model provides the best performance with very low CPU overhead. If your guest does not support this driver, it is usually best to use 'e1000'.",
                                                   "enum" : [
                                                      "rtl8139",
                                                      "ne2k_pci",
                                                      "e1000",
                                                      "pcnet",
                                                      "virtio",
                                                      "ne2k_isa",
                                                      "i82551",
                                                      "i82557b",
                                                      "i82559er",
                                                      "vmxnet3",
                                                      "e1000-82540em",
                                                      "e1000-82544gc",
                                                      "e1000-82545em"
                                                   ],
                                                   "format_description" : "model",
                                                   "type" : "string"
                                                },
                                                "ne2k_isa" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "ne2k_pci" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "pcnet" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "queues" : {
                                                   "description" : "Number of packet queues to be used on the device.",
                                                   "maximum" : 16,
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "rate" : {
                                                   "description" : "Rate limit in mbps (megabytes per second) as floating point number.",
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "rtl8139" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "tag" : {
                                                   "description" : "VLAN tag to apply to packets on this interface.",
                                                   "maximum" : 4094,
                                                   "minimum" : 1,
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "trunks" : {
                                                   "description" : "VLAN trunks to pass through this interface.",
                                                   "format_description" : "vlanid[;vlanid...]",
                                                   "optional" : 1,
                                                   "pattern" : "(?^:\\d+(?:-\\d+)?(?:;\\d+(?:-\\d+)?)*)",
                                                   "type" : "string"
                                                },
                                                "virtio" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "vmxnet3" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[model=]<model> [,bridge=<bridge>] [,firewall=<1|0>] [,link_down=<1|0>] [,macaddr=<XX:XX:XX:XX:XX:XX>] [,queues=<integer>] [,rate=<number>] [,tag=<integer>] [,trunks=<vlanid[;vlanid...]>] [,<model>=<macaddr>]"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "numa" : {
                                             "default" : 0,
                                             "description" : "Enable/disable NUMA.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "numa[n]" : {
                                             "description" : "NUMA topology.",
                                             "format" : {
                                                "cpus" : {
                                                   "description" : "CPUs accessing this NUMA node.",
                                                   "format_description" : "id[-id];...",
                                                   "pattern" : "(?^:\\d+(?:-\\d+)?(?:;\\d+(?:-\\d+)?)*)",
                                                   "type" : "string"
                                                },
                                                "hostnodes" : {
                                                   "description" : "Host NUMA nodes to use.",
                                                   "format_description" : "id[-id];...",
                                                   "optional" : 1,
                                                   "pattern" : "(?^:\\d+(?:-\\d+)?(?:;\\d+(?:-\\d+)?)*)",
                                                   "type" : "string"
                                                },
                                                "memory" : {
                                                   "description" : "Amount of memory this NUMA node provides.",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "policy" : {
                                                   "description" : "NUMA allocation policy.",
                                                   "enum" : [
                                                      "preferred",
                                                      "bind",
                                                      "interleave"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "cpus=<id[-id];...> [,hostnodes=<id[-id];...>] [,memory=<number>] [,policy=<preferred|bind|interleave>]"
                                          },
                                          "onboot" : {
                                             "default" : 0,
                                             "description" : "Specifies whether a VM will be started during system bootup.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "ostype" : {
                                             "description" : "Specify guest operating system.",
                                             "enum" : [
                                                "other",
                                                "wxp",
                                                "w2k",
                                                "w2k3",
                                                "w2k8",
                                                "wvista",
                                                "win7",
                                                "win8",
                                                "l24",
                                                "l26",
                                                "solaris"
                                             ],
                                             "optional" : 1,
                                             "type" : "string",
                                             "verbose_description" : "Specify guest operating system. This is used to enable special\noptimization/features for specific operating systems:\n\n[horizontal]\nother;; unspecified OS\nwxp;; Microsoft Windows XP\nw2k;; Microsoft Windows 2000\nw2k3;; Microsoft Windows 2003\nw2k8;; Microsoft Windows 2008\nwvista;; Microsoft Windows Vista\nwin7;; Microsoft Windows 7\nwin8;; Microsoft Windows 8/2012\nl24;; Linux 2.4 Kernel\nl26;; Linux 2.6/3.X Kernel\nsolaris;; Solaris/OpenSolaris/OpenIndiania kernel\n"
                                          },
                                          "parallel[n]" : {
                                             "description" : "Map host parallel devices (n is 0 to 2).",
                                             "optional" : 1,
                                             "pattern" : "/dev/parport\\d+|/dev/usb/lp\\d+",
                                             "type" : "string",
                                             "verbose_description" : "Map host parallel devices (n is 0 to 2).\n\nNOTE: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nCAUTION: Experimental! User reported problems with this option.\n"
                                          },
                                          "protection" : {
                                             "default" : 0,
                                             "description" : "Sets the protection flag of the VM. This will disable the remove VM and remove disk operations.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "reboot" : {
                                             "default" : 1,
                                             "description" : "Allow reboot. If set to '0' the VM exit on reboot.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "revert" : {
                                             "description" : "Revert a pending change.",
                                             "format" : "pve-configid-list",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "sata[n]" : {
                                             "description" : "Use volume as SATA hard disk or CD-ROM (n is 0 to 5).",
                                             "format" : {
                                                "aio" : {
                                                   "description" : "AIO type to use.",
                                                   "enum" : [
                                                      "native",
                                                      "threads"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "backup" : {
                                                   "description" : "Whether the drive should be included when making backups.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "bps" : {
                                                   "description" : "Maximum r/w speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_rd" : {
                                                   "description" : "Maximum read speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_wr" : {
                                                   "description" : "Maximum write speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "cache" : {
                                                   "description" : "The drive's cache mode",
                                                   "enum" : [
                                                      "none",
                                                      "writethrough",
                                                      "writeback",
                                                      "unsafe",
                                                      "directsync"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "cyls" : {
                                                   "description" : "Force the drive's physical geometry to have a specific cylinder count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "detect_zeroes" : {
                                                   "description" : "Controls whether to detect and try to optimize writes of zeroes.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "discard" : {
                                                   "description" : "Controls whether to pass discard/trim requests to the underlying storage.",
                                                   "enum" : [
                                                      "ignore",
                                                      "on"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "file" : {
                                                   "default_key" : 1,
                                                   "description" : "The drive's backing volume.",
                                                   "format" : "pve-volume-id-or-qm-path",
                                                   "format_description" : "volume",
                                                   "type" : "string"
                                                },
                                                "format" : {
                                                   "description" : "The drive's backing file's data format.",
                                                   "enum" : [
                                                      "raw",
                                                      "cow",
                                                      "qcow",
                                                      "qed",
                                                      "qcow2",
                                                      "vmdk",
                                                      "cloop"
                                                   ],
                                                   "format_description" : "image format",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "heads" : {
                                                   "description" : "Force the drive's physical geometry to have a specific head count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops" : {
                                                   "description" : "Maximum r/w I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_max" : {
                                                   "description" : "Maximum unthrottled r/w I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd" : {
                                                   "description" : "Maximum read I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd_max" : {
                                                   "description" : "Maximum unthrottled read I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr" : {
                                                   "description" : "Maximum write I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr_max" : {
                                                   "description" : "Maximum unthrottled write I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "mbps" : {
                                                   "description" : "Maximum r/w speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_max" : {
                                                   "description" : "Maximum unthrottled r/w pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd" : {
                                                   "description" : "Maximum read speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd_max" : {
                                                   "description" : "Maximum unthrottled read pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr" : {
                                                   "description" : "Maximum write speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr_max" : {
                                                   "description" : "Maximum unthrottled write pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "media" : {
                                                   "default" : "disk",
                                                   "description" : "The drive's media type.",
                                                   "enum" : [
                                                      "cdrom",
                                                      "disk"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "rerror" : {
                                                   "description" : "Read error action.",
                                                   "enum" : [
                                                      "ignore",
                                                      "report",
                                                      "stop"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "secs" : {
                                                   "description" : "Force the drive's physical geometry to have a specific sector count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "serial" : {
                                                   "description" : "The drive's reported serial number, url-encoded, up to 20 bytes long.",
                                                   "format" : "urlencoded",
                                                   "format_description" : "serial",
                                                   "maxLength" : 60,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "size" : {
                                                   "description" : "Disk size. This is purely informational and has no effect.",
                                                   "format" : "disk-size",
                                                   "format_description" : "DiskSize",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "snapshot" : {
                                                   "description" : "Whether the drive should be included when making snapshots.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "trans" : {
                                                   "description" : "Force disk geometry bios translation mode.",
                                                   "enum" : [
                                                      "none",
                                                      "lba",
                                                      "auto"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "volume" : {
                                                   "alias" : "file"
                                                },
                                                "werror" : {
                                                   "description" : "Write error action.",
                                                   "enum" : [
                                                      "enospc",
                                                      "ignore",
                                                      "report",
                                                      "stop"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[file=]<volume> [,aio=<native|threads>] [,backup=<1|0>] [,bps=<bps>] [,bps_rd=<bps>] [,bps_wr=<bps>] [,cache=<none|writethrough|writeback|unsafe|directsync>] [,cyls=<integer>] [,detect_zeroes=<1|0>] [,discard=<ignore|on>] [,format=<image format>] [,heads=<integer>] [,iops=<iops>] [,iops_max=<iops>] [,iops_rd=<iops>] [,iops_rd_max=<iops>] [,iops_wr=<iops>] [,iops_wr_max=<iops>] [,mbps=<mbps>] [,mbps_max=<mbps>] [,mbps_rd=<mbps>] [,mbps_rd_max=<mbps>] [,mbps_wr=<mbps>] [,mbps_wr_max=<mbps>] [,media=<cdrom|disk>] [,rerror=<ignore|report|stop>] [,secs=<integer>] [,serial=<serial>] [,size=<DiskSize>] [,snapshot=<1|0>] [,trans=<none|lba|auto>] [,werror=<enospc|ignore|report|stop>]"
                                          },
                                          "scsi[n]" : {
                                             "description" : "Use volume as SCSI hard disk or CD-ROM (n is 0 to 13).",
                                             "format" : {
                                                "aio" : {
                                                   "description" : "AIO type to use.",
                                                   "enum" : [
                                                      "native",
                                                      "threads"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "backup" : {
                                                   "description" : "Whether the drive should be included when making backups.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "bps" : {
                                                   "description" : "Maximum r/w speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_rd" : {
                                                   "description" : "Maximum read speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_wr" : {
                                                   "description" : "Maximum write speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "cache" : {
                                                   "description" : "The drive's cache mode",
                                                   "enum" : [
                                                      "none",
                                                      "writethrough",
                                                      "writeback",
                                                      "unsafe",
                                                      "directsync"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "cyls" : {
                                                   "description" : "Force the drive's physical geometry to have a specific cylinder count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "detect_zeroes" : {
                                                   "description" : "Controls whether to detect and try to optimize writes of zeroes.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "discard" : {
                                                   "description" : "Controls whether to pass discard/trim requests to the underlying storage.",
                                                   "enum" : [
                                                      "ignore",
                                                      "on"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "file" : {
                                                   "default_key" : 1,
                                                   "description" : "The drive's backing volume.",
                                                   "format" : "pve-volume-id-or-qm-path",
                                                   "format_description" : "volume",
                                                   "type" : "string"
                                                },
                                                "format" : {
                                                   "description" : "The drive's backing file's data format.",
                                                   "enum" : [
                                                      "raw",
                                                      "cow",
                                                      "qcow",
                                                      "qed",
                                                      "qcow2",
                                                      "vmdk",
                                                      "cloop"
                                                   ],
                                                   "format_description" : "image format",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "heads" : {
                                                   "description" : "Force the drive's physical geometry to have a specific head count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops" : {
                                                   "description" : "Maximum r/w I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_max" : {
                                                   "description" : "Maximum unthrottled r/w I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd" : {
                                                   "description" : "Maximum read I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd_max" : {
                                                   "description" : "Maximum unthrottled read I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr" : {
                                                   "description" : "Maximum write I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr_max" : {
                                                   "description" : "Maximum unthrottled write I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iothread" : {
                                                   "description" : "Whether to use iothreads for this drive",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "mbps" : {
                                                   "description" : "Maximum r/w speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_max" : {
                                                   "description" : "Maximum unthrottled r/w pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd" : {
                                                   "description" : "Maximum read speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd_max" : {
                                                   "description" : "Maximum unthrottled read pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr" : {
                                                   "description" : "Maximum write speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr_max" : {
                                                   "description" : "Maximum unthrottled write pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "media" : {
                                                   "default" : "disk",
                                                   "description" : "The drive's media type.",
                                                   "enum" : [
                                                      "cdrom",
                                                      "disk"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "queues" : {
                                                   "description" : "Number of queues.",
                                                   "minimum" : 2,
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "secs" : {
                                                   "description" : "Force the drive's physical geometry to have a specific sector count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "serial" : {
                                                   "description" : "The drive's reported serial number, url-encoded, up to 20 bytes long.",
                                                   "format" : "urlencoded",
                                                   "format_description" : "serial",
                                                   "maxLength" : 60,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "size" : {
                                                   "description" : "Disk size. This is purely informational and has no effect.",
                                                   "format" : "disk-size",
                                                   "format_description" : "DiskSize",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "snapshot" : {
                                                   "description" : "Whether the drive should be included when making snapshots.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "trans" : {
                                                   "description" : "Force disk geometry bios translation mode.",
                                                   "enum" : [
                                                      "none",
                                                      "lba",
                                                      "auto"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "volume" : {
                                                   "alias" : "file"
                                                },
                                                "werror" : {
                                                   "description" : "Write error action.",
                                                   "enum" : [
                                                      "enospc",
                                                      "ignore",
                                                      "report",
                                                      "stop"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[file=]<volume> [,aio=<native|threads>] [,backup=<1|0>] [,bps=<bps>] [,bps_rd=<bps>] [,bps_wr=<bps>] [,cache=<none|writethrough|writeback|unsafe|directsync>] [,cyls=<integer>] [,detect_zeroes=<1|0>] [,discard=<ignore|on>] [,format=<image format>] [,heads=<integer>] [,iops=<iops>] [,iops_max=<iops>] [,iops_rd=<iops>] [,iops_rd_max=<iops>] [,iops_wr=<iops>] [,iops_wr_max=<iops>] [,iothread=<1|0>] [,mbps=<mbps>] [,mbps_max=<mbps>] [,mbps_rd=<mbps>] [,mbps_rd_max=<mbps>] [,mbps_wr=<mbps>] [,mbps_wr_max=<mbps>] [,media=<cdrom|disk>] [,queues=<integer>] [,secs=<integer>] [,serial=<serial>] [,size=<DiskSize>] [,snapshot=<1|0>] [,trans=<none|lba|auto>] [,werror=<enospc|ignore|report|stop>]"
                                          },
                                          "scsihw" : {
                                             "default" : "lsi",
                                             "description" : "SCSI controller model",
                                             "enum" : [
                                                "lsi",
                                                "lsi53c810",
                                                "virtio-scsi-pci",
                                                "virtio-scsi-single",
                                                "megasas",
                                                "pvscsi"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "serial[n]" : {
                                             "description" : "Create a serial device inside the VM (n is 0 to 3)",
                                             "optional" : 1,
                                             "pattern" : "(/dev/.+|socket)",
                                             "type" : "string",
                                             "verbose_description" : "Create a serial device inside the VM (n is 0 to 3), and pass through a\nhost serial device (i.e. /dev/ttyS0), or create a unix socket on the\nhost side (use 'qm terminal' to open a terminal connection).\n\nNOTE: If you pass through a host serial device, it is no longer possible to migrate such machines - use with special care.\n\nCAUTION: Experimental! User reported problems with this option.\n"
                                          },
                                          "shares" : {
                                             "default" : 1000,
                                             "description" : "Amount of memory shares for auto-ballooning. The larger the number is, the more memory this VM gets. Number is relative to weights of all other running VMs. Using zero disables auto-ballooning",
                                             "maximum" : 50000,
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0-50000)"
                                          },
                                          "skiplock" : {
                                             "description" : "Ignore locks - only root is allowed to use this option.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "smbios1" : {
                                             "description" : "Specify SMBIOS type 1 fields.",
                                             "format" : "pve-qm-smbios1",
                                             "maxLength" : 256,
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[family=<string>] [,manufacturer=<string>] [,product=<string>] [,serial=<string>] [,sku=<string>] [,uuid=<UUID>] [,version=<string>]"
                                          },
                                          "smp" : {
                                             "default" : 1,
                                             "description" : "The number of CPUs. Please use option -sockets instead.",
                                             "minimum" : 1,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "sockets" : {
                                             "default" : 1,
                                             "description" : "The number of CPU sockets.",
                                             "minimum" : 1,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "startdate" : {
                                             "default" : "now",
                                             "description" : "Set the initial date of the real time clock. Valid format for date are: 'now' or '2006-06-17T16:01:21' or '2006-06-17'.",
                                             "optional" : 1,
                                             "pattern" : "(now|\\d{4}-\\d{1,2}-\\d{1,2}(T\\d{1,2}:\\d{1,2}:\\d{1,2})?)",
                                             "type" : "string",
                                             "typetext" : "(now | YYYY-MM-DD | YYYY-MM-DDTHH:MM:SS)"
                                          },
                                          "startup" : {
                                             "description" : "Startup and shutdown behavior. Order is a non-negative number defining the general startup order. Shutdown in done with reverse ordering. Additionally you can set the 'up' or 'down' delay in seconds, which specifies a delay to wait before the next VM is started or stopped.",
                                             "format" : "pve-startup-order",
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[[order=]\\d+] [,up=\\d+] [,down=\\d+] "
                                          },
                                          "tablet" : {
                                             "default" : 1,
                                             "description" : "Enable/disable the USB tablet device.",
                                             "optional" : 1,
                                             "type" : "boolean",
                                             "verbose_description" : "Enable/disable the USB tablet device. This device is usually needed to allow absolute mouse positioning with VNC. Else the mouse runs out of sync with normal VNC clients. If you're running lots of console-only guests on one host, you may consider disabling this to save some context switches. This is turned off by default if you use spice (-vga=qxl)."
                                          },
                                          "tdf" : {
                                             "default" : 0,
                                             "description" : "Enable/disable time drift fix.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "template" : {
                                             "default" : 0,
                                             "description" : "Enable/disable Template.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "unused[n]" : {
                                             "description" : "Reference to unused volumes. This is used internally, and should not be modified manually.",
                                             "format" : "pve-volume-id",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "usb[n]" : {
                                             "description" : "Configure an USB device (n is 0 to 4).",
                                             "format" : {
                                                "host" : {
                                                   "default_key" : 1,
                                                   "description" : "The Host USB device or port or the value 'spice'. HOSTUSBDEVICE syntax is:\n\n 'bus-port(.port)*' (decimal numbers) or\n 'vendor_id:product_id' (hexadeciaml numbers) or\n 'spice'\n\nYou can use the 'lsusb -t' command to list existing usb devices.\n\nNOTE: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nThe value 'spice' can be used to add a usb redirection devices for spice.\n",
                                                   "format" : "pve-qm-usb-device",
                                                   "format_description" : "HOSTUSBDEVICE|spice",
                                                   "type" : "string"
                                                },
                                                "usb3" : {
                                                   "default" : 0,
                                                   "description" : "Specifies whether if given host option is a USB3 device or port (this does currently not work reliably with spice redirection and is then ignored).",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[host=]<HOSTUSBDEVICE|spice> [,usb3=<1|0>]"
                                          },
                                          "vcpus" : {
                                             "default" : 0,
                                             "description" : "Number of hotplugged vcpus.",
                                             "minimum" : 1,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "vga" : {
                                             "description" : "Select the VGA type.",
                                             "enum" : [
                                                "std",
                                                "cirrus",
                                                "vmware",
                                                "qxl",
                                                "serial0",
                                                "serial1",
                                                "serial2",
                                                "serial3",
                                                "qxl2",
                                                "qxl3",
                                                "qxl4"
                                             ],
                                             "optional" : 1,
                                             "type" : "string",
                                             "verbose_description" : "Select the VGA type. If you want to use high resolution modes (>= 1280x1024x16) then you should use the options 'std' or 'vmware'. Default is 'std' for win8/win7/w2k8, and 'cirrus' for other OS types. The 'qxl' option enables the SPICE display sever. For win* OS you can select how many independent displays you want, Linux guests can add displays them self. You can also run without any graphic card, using a serial device as terminal."
                                          },
                                          "virtio[n]" : {
                                             "description" : "Use volume as VIRTIO hard disk (n is 0 to 15).",
                                             "format" : {
                                                "aio" : {
                                                   "description" : "AIO type to use.",
                                                   "enum" : [
                                                      "native",
                                                      "threads"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "backup" : {
                                                   "description" : "Whether the drive should be included when making backups.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "bps" : {
                                                   "description" : "Maximum r/w speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_rd" : {
                                                   "description" : "Maximum read speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_wr" : {
                                                   "description" : "Maximum write speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "cache" : {
                                                   "description" : "The drive's cache mode",
                                                   "enum" : [
                                                      "none",
                                                      "writethrough",
                                                      "writeback",
                                                      "unsafe",
                                                      "directsync"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "cyls" : {
                                                   "description" : "Force the drive's physical geometry to have a specific cylinder count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "detect_zeroes" : {
                                                   "description" : "Controls whether to detect and try to optimize writes of zeroes.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "discard" : {
                                                   "description" : "Controls whether to pass discard/trim requests to the underlying storage.",
                                                   "enum" : [
                                                      "ignore",
                                                      "on"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "file" : {
                                                   "default_key" : 1,
                                                   "description" : "The drive's backing volume.",
                                                   "format" : "pve-volume-id-or-qm-path",
                                                   "format_description" : "volume",
                                                   "type" : "string"
                                                },
                                                "format" : {
                                                   "description" : "The drive's backing file's data format.",
                                                   "enum" : [
                                                      "raw",
                                                      "cow",
                                                      "qcow",
                                                      "qed",
                                                      "qcow2",
                                                      "vmdk",
                                                      "cloop"
                                                   ],
                                                   "format_description" : "image format",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "heads" : {
                                                   "description" : "Force the drive's physical geometry to have a specific head count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops" : {
                                                   "description" : "Maximum r/w I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_max" : {
                                                   "description" : "Maximum unthrottled r/w I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd" : {
                                                   "description" : "Maximum read I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd_max" : {
                                                   "description" : "Maximum unthrottled read I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr" : {
                                                   "description" : "Maximum write I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr_max" : {
                                                   "description" : "Maximum unthrottled write I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iothread" : {
                                                   "description" : "Whether to use iothreads for this drive",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "mbps" : {
                                                   "description" : "Maximum r/w speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_max" : {
                                                   "description" : "Maximum unthrottled r/w pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd" : {
                                                   "description" : "Maximum read speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd_max" : {
                                                   "description" : "Maximum unthrottled read pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr" : {
                                                   "description" : "Maximum write speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr_max" : {
                                                   "description" : "Maximum unthrottled write pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "media" : {
                                                   "default" : "disk",
                                                   "description" : "The drive's media type.",
                                                   "enum" : [
                                                      "cdrom",
                                                      "disk"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "rerror" : {
                                                   "description" : "Read error action.",
                                                   "enum" : [
                                                      "ignore",
                                                      "report",
                                                      "stop"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "secs" : {
                                                   "description" : "Force the drive's physical geometry to have a specific sector count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "serial" : {
                                                   "description" : "The drive's reported serial number, url-encoded, up to 20 bytes long.",
                                                   "format" : "urlencoded",
                                                   "format_description" : "serial",
                                                   "maxLength" : 60,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "size" : {
                                                   "description" : "Disk size. This is purely informational and has no effect.",
                                                   "format" : "disk-size",
                                                   "format_description" : "DiskSize",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "snapshot" : {
                                                   "description" : "Whether the drive should be included when making snapshots.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "trans" : {
                                                   "description" : "Force disk geometry bios translation mode.",
                                                   "enum" : [
                                                      "none",
                                                      "lba",
                                                      "auto"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "volume" : {
                                                   "alias" : "file"
                                                },
                                                "werror" : {
                                                   "description" : "Write error action.",
                                                   "enum" : [
                                                      "enospc",
                                                      "ignore",
                                                      "report",
                                                      "stop"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[file=]<volume> [,aio=<native|threads>] [,backup=<1|0>] [,bps=<bps>] [,bps_rd=<bps>] [,bps_wr=<bps>] [,cache=<none|writethrough|writeback|unsafe|directsync>] [,cyls=<integer>] [,detect_zeroes=<1|0>] [,discard=<ignore|on>] [,format=<image format>] [,heads=<integer>] [,iops=<iops>] [,iops_max=<iops>] [,iops_rd=<iops>] [,iops_rd_max=<iops>] [,iops_wr=<iops>] [,iops_wr_max=<iops>] [,iothread=<1|0>] [,mbps=<mbps>] [,mbps_max=<mbps>] [,mbps_rd=<mbps>] [,mbps_rd_max=<mbps>] [,mbps_wr=<mbps>] [,mbps_wr_max=<mbps>] [,media=<cdrom|disk>] [,rerror=<ignore|report|stop>] [,secs=<integer>] [,serial=<serial>] [,size=<DiskSize>] [,snapshot=<1|0>] [,trans=<none|lba|auto>] [,werror=<enospc|ignore|report|stop>]"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "watchdog" : {
                                             "description" : "Create a virtual hardware watchdog device.",
                                             "format" : "pve-qm-watchdog",
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[[model=]<i6300esb|ib700>] [,action=<reset|shutdown|poweroff|pause|debug|none>]",
                                             "verbose_description" : "Create a virtual hardware watchdog device. Once enabled (by a guest action), the watchdog must be periodically polled by an agent inside the guest or else the watchdog will reset the guest (or execute the respective action specified)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Config.Disk",
                                             "VM.Config.CDROM",
                                             "VM.Config.CPU",
                                             "VM.Config.Memory",
                                             "VM.Config.Network",
                                             "VM.Config.HWType",
                                             "VM.Config.Options"
                                          ],
                                          "any",
                                          1
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "optional" : 1,
                                       "type" : "string"
                                    }
                                 },
                                 "PUT" : {
                                    "description" : "Set virtual machine options (synchrounous API) - You should consider using the POST method instead for any actions involving hotplug or storage allocation.",
                                    "method" : "PUT",
                                    "name" : "update_vm",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "acpi" : {
                                             "default" : 1,
                                             "description" : "Enable/disable ACPI.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "agent" : {
                                             "default" : 0,
                                             "description" : "Enable/disable Qemu GuestAgent.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "args" : {
                                             "description" : "Arbitrary arguments passed to kvm.",
                                             "optional" : 1,
                                             "type" : "string",
                                             "verbose_description" : "Arbitrary arguments passed to kvm, for example:\n\nargs: -no-reboot -no-hpet\n\nNOTE: this option is for experts only.\n"
                                          },
                                          "autostart" : {
                                             "default" : 0,
                                             "description" : "Automatic restart after crash (currently ignored).",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "balloon" : {
                                             "description" : "Amount of target RAM for the VM in MB. Using zero disables the ballon driver.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          },
                                          "bios" : {
                                             "default" : "seabios",
                                             "description" : "Select BIOS implementation.",
                                             "enum" : [
                                                "seabios",
                                                "ovmf"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "boot" : {
                                             "default" : "cdn",
                                             "description" : "Boot on floppy (a), hard disk (c), CD-ROM (d), or network (n).",
                                             "optional" : 1,
                                             "pattern" : "[acdn]{1,4}",
                                             "type" : "string"
                                          },
                                          "bootdisk" : {
                                             "description" : "Enable booting from specified disk.",
                                             "format" : "pve-qm-bootdisk",
                                             "optional" : 1,
                                             "pattern" : "(ide|sata|scsi|virtio)\\d+",
                                             "type" : "string"
                                          },
                                          "cdrom" : {
                                             "description" : "This is an alias for option -ide2",
                                             "format" : "pve-qm-drive",
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "volume"
                                          },
                                          "cores" : {
                                             "default" : 1,
                                             "description" : "The number of cores per socket.",
                                             "minimum" : 1,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "cpu" : {
                                             "description" : "Emulated CPU type.",
                                             "format" : {
                                                "cputype" : {
                                                   "default" : "kvm64",
                                                   "default_key" : 1,
                                                   "description" : "Emulated CPU type.",
                                                   "enum" : [
                                                      "486",
                                                      "athlon",
                                                      "Broadwell",
                                                      "Broadwell-noTSX",
                                                      "Conroe",
                                                      "core2duo",
                                                      "coreduo",
                                                      "Haswell",
                                                      "Haswell-noTSX",
                                                      "host",
                                                      "IvyBridge",
                                                      "kvm32",
                                                      "kvm64",
                                                      "Nehalem",
                                                      "Opteron_G1",
                                                      "Opteron_G2",
                                                      "Opteron_G3",
                                                      "Opteron_G4",
                                                      "Opteron_G5",
                                                      "Penryn",
                                                      "pentium",
                                                      "pentium2",
                                                      "pentium3",
                                                      "phenom",
                                                      "qemu32",
                                                      "qemu64",
                                                      "SandyBridge",
                                                      "Westmere"
                                                   ],
                                                   "format_description" : "cputype",
                                                   "type" : "string"
                                                },
                                                "hidden" : {
                                                   "default" : 0,
                                                   "description" : "Do not identify as a KVM virtual machine.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[cputype=]<cputype> [,hidden=<1|0>]"
                                          },
                                          "cpulimit" : {
                                             "default" : 0,
                                             "description" : "Limit of CPU usage.",
                                             "maximum" : 128,
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "number",
                                             "typetext" : "number (0-128)",
                                             "verbose_description" : "Limit of CPU usage.\n\nNOTE: If the computer has 2 CPUs, it has total of '2' CPU time. Value '0' indicates no CPU limit."
                                          },
                                          "cpuunits" : {
                                             "default" : 1000,
                                             "description" : "CPU weight for a VM.",
                                             "maximum" : 500000,
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0-500000)",
                                             "verbose_description" : "CPU weight for a VM. Argument is used in the kernel fair scheduler. The larger the number is, the more CPU time this VM gets. Number is relative to weights of all the other running VMs.\n\nNOTE: You can disable fair-scheduler configuration by setting this to 0."
                                          },
                                          "delete" : {
                                             "description" : "A list of settings you want to delete.",
                                             "format" : "pve-configid-list",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "description" : {
                                             "description" : "Description for the VM. Only used on the configuration web interface. This is saved as comment inside the configuration file.",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "digest" : {
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "force" : {
                                             "description" : "Force physical removal. Without this, we simple remove the disk from the config file and create an additional configuration entry called 'unused[n]', which contains the volume ID. Unlink of unused[n] always cause physical removal.",
                                             "optional" : 1,
                                             "requires" : "delete",
                                             "type" : "boolean"
                                          },
                                          "freeze" : {
                                             "description" : "Freeze CPU at startup (use 'c' monitor command to start execution).",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "hostpci[n]" : {
                                             "description" : "Map host PCI devices into guest.",
                                             "format" : "pve-qm-hostpci",
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[host=]<HOSTPCIID[;HOSTPCIID2...]> [,pcie=<1|0>] [,rombar=<1|0>] [,x-vga=<1|0>]",
                                             "verbose_description" : "Map host PCI devices into guest.\n\nNOTE: This option allows direct access to host hardware. So it is no longer \npossible to migrate such machines - use with special care.\n\nCAUTION: Experimental! User reported problems with this option.\n"
                                          },
                                          "hotplug" : {
                                             "default" : "network,disk,usb",
                                             "description" : "Selectively enable hotplug features. This is a comma separated list of hotplug features: 'network', 'disk', 'cpu', 'memory' and 'usb'. Use '0' to disable hotplug completely. Value '1' is an alias for the default 'network,disk,usb'.",
                                             "format" : "pve-hotplug-features",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "hugepages" : {
                                             "description" : "Enable/disable hugepages memory.",
                                             "enum" : [
                                                "any",
                                                "2",
                                                "1024"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "ide[n]" : {
                                             "description" : "Use volume as IDE hard disk or CD-ROM (n is 0 to 3).",
                                             "format" : {
                                                "aio" : {
                                                   "description" : "AIO type to use.",
                                                   "enum" : [
                                                      "native",
                                                      "threads"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "backup" : {
                                                   "description" : "Whether the drive should be included when making backups.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "bps" : {
                                                   "description" : "Maximum r/w speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_rd" : {
                                                   "description" : "Maximum read speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_wr" : {
                                                   "description" : "Maximum write speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "cache" : {
                                                   "description" : "The drive's cache mode",
                                                   "enum" : [
                                                      "none",
                                                      "writethrough",
                                                      "writeback",
                                                      "unsafe",
                                                      "directsync"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "cyls" : {
                                                   "description" : "Force the drive's physical geometry to have a specific cylinder count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "detect_zeroes" : {
                                                   "description" : "Controls whether to detect and try to optimize writes of zeroes.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "discard" : {
                                                   "description" : "Controls whether to pass discard/trim requests to the underlying storage.",
                                                   "enum" : [
                                                      "ignore",
                                                      "on"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "file" : {
                                                   "default_key" : 1,
                                                   "description" : "The drive's backing volume.",
                                                   "format" : "pve-volume-id-or-qm-path",
                                                   "format_description" : "volume",
                                                   "type" : "string"
                                                },
                                                "format" : {
                                                   "description" : "The drive's backing file's data format.",
                                                   "enum" : [
                                                      "raw",
                                                      "cow",
                                                      "qcow",
                                                      "qed",
                                                      "qcow2",
                                                      "vmdk",
                                                      "cloop"
                                                   ],
                                                   "format_description" : "image format",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "heads" : {
                                                   "description" : "Force the drive's physical geometry to have a specific head count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops" : {
                                                   "description" : "Maximum r/w I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_max" : {
                                                   "description" : "Maximum unthrottled r/w I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd" : {
                                                   "description" : "Maximum read I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd_max" : {
                                                   "description" : "Maximum unthrottled read I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr" : {
                                                   "description" : "Maximum write I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr_max" : {
                                                   "description" : "Maximum unthrottled write I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "mbps" : {
                                                   "description" : "Maximum r/w speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_max" : {
                                                   "description" : "Maximum unthrottled r/w pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd" : {
                                                   "description" : "Maximum read speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd_max" : {
                                                   "description" : "Maximum unthrottled read pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr" : {
                                                   "description" : "Maximum write speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr_max" : {
                                                   "description" : "Maximum unthrottled write pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "media" : {
                                                   "default" : "disk",
                                                   "description" : "The drive's media type.",
                                                   "enum" : [
                                                      "cdrom",
                                                      "disk"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "model" : {
                                                   "description" : "The drive's reported model name, url-encoded, up to 40 bytes long.",
                                                   "format" : "urlencoded",
                                                   "format_description" : "model",
                                                   "maxLength" : 120,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "rerror" : {
                                                   "description" : "Read error action.",
                                                   "enum" : [
                                                      "ignore",
                                                      "report",
                                                      "stop"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "secs" : {
                                                   "description" : "Force the drive's physical geometry to have a specific sector count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "serial" : {
                                                   "description" : "The drive's reported serial number, url-encoded, up to 20 bytes long.",
                                                   "format" : "urlencoded",
                                                   "format_description" : "serial",
                                                   "maxLength" : 60,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "size" : {
                                                   "description" : "Disk size. This is purely informational and has no effect.",
                                                   "format" : "disk-size",
                                                   "format_description" : "DiskSize",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "snapshot" : {
                                                   "description" : "Whether the drive should be included when making snapshots.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "trans" : {
                                                   "description" : "Force disk geometry bios translation mode.",
                                                   "enum" : [
                                                      "none",
                                                      "lba",
                                                      "auto"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "volume" : {
                                                   "alias" : "file"
                                                },
                                                "werror" : {
                                                   "description" : "Write error action.",
                                                   "enum" : [
                                                      "enospc",
                                                      "ignore",
                                                      "report",
                                                      "stop"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[file=]<volume> [,aio=<native|threads>] [,backup=<1|0>] [,bps=<bps>] [,bps_rd=<bps>] [,bps_wr=<bps>] [,cache=<none|writethrough|writeback|unsafe|directsync>] [,cyls=<integer>] [,detect_zeroes=<1|0>] [,discard=<ignore|on>] [,format=<image format>] [,heads=<integer>] [,iops=<iops>] [,iops_max=<iops>] [,iops_rd=<iops>] [,iops_rd_max=<iops>] [,iops_wr=<iops>] [,iops_wr_max=<iops>] [,mbps=<mbps>] [,mbps_max=<mbps>] [,mbps_rd=<mbps>] [,mbps_rd_max=<mbps>] [,mbps_wr=<mbps>] [,mbps_wr_max=<mbps>] [,media=<cdrom|disk>] [,model=<model>] [,rerror=<ignore|report|stop>] [,secs=<integer>] [,serial=<serial>] [,size=<DiskSize>] [,snapshot=<1|0>] [,trans=<none|lba|auto>] [,werror=<enospc|ignore|report|stop>]"
                                          },
                                          "keyboard" : {
                                             "default" : "en-us",
                                             "description" : "Keybord layout for vnc server. Default is read from the '/etc/pve/datacenter.conf' configuration file.",
                                             "enum" : [
                                                "de",
                                                "de-ch",
                                                "da",
                                                "en-gb",
                                                "en-us",
                                                "es",
                                                "fi",
                                                "fr",
                                                "fr-be",
                                                "fr-ca",
                                                "fr-ch",
                                                "hu",
                                                "is",
                                                "it",
                                                "ja",
                                                "lt",
                                                "mk",
                                                "nl",
                                                "no",
                                                "pl",
                                                "pt",
                                                "pt-br",
                                                "sv",
                                                "sl",
                                                "tr"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "kvm" : {
                                             "default" : 1,
                                             "description" : "Enable/disable KVM hardware virtualization.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "localtime" : {
                                             "description" : "Set the real time clock to local time. This is enabled by default if ostype indicates a Microsoft OS.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "lock" : {
                                             "description" : "Lock/unlock the VM.",
                                             "enum" : [
                                                "migrate",
                                                "backup",
                                                "snapshot",
                                                "rollback"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "machine" : {
                                             "description" : "Specific the Qemu machine type.",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "pattern" : "(pc|pc(-i440fx)?-\\d+\\.\\d+(\\.pxe)?|q35|pc-q35-\\d+\\.\\d+(\\.pxe)?)",
                                             "type" : "string"
                                          },
                                          "memory" : {
                                             "default" : 512,
                                             "description" : "Amount of RAM for the VM in MB. This is the maximum available memory when you use the balloon device.",
                                             "minimum" : 16,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (16- N)"
                                          },
                                          "migrate_downtime" : {
                                             "default" : 0.1,
                                             "description" : "Set maximum tolerated downtime (in seconds) for migrations.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "number",
                                             "typetext" : "number (0- N)"
                                          },
                                          "migrate_speed" : {
                                             "default" : 0,
                                             "description" : "Set maximum speed (in MB/s) for migrations. Value 0 is no limit.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          },
                                          "name" : {
                                             "description" : "Set a name for the VM. Only used on the configuration web interface.",
                                             "format" : "dns-name",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "net[n]" : {
                                             "description" : "Specify network devices.",
                                             "format" : {
                                                "bridge" : {
                                                   "description" : "Bridge to attach the network device to. The Proxmox VE standard bridge\nis called 'vmbr0'.\n\nIf you do not specify a bridge, we create a kvm user (NATed) network\ndevice, which provides DHCP and DNS services. The following addresses\nare used:\n\n 10.0.2.2   Gateway\n 10.0.2.3   DNS Server\n 10.0.2.4   SMB Server\n\nThe DHCP server assign addresses to the guest starting from 10.0.2.15.\n",
                                                   "format_description" : "bridge",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "e1000" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "e1000-82540em" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "e1000-82544gc" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "e1000-82545em" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "firewall" : {
                                                   "description" : "Whether this interface should be protected by the firewall.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "i82551" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "i82557b" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "i82559er" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "link_down" : {
                                                   "description" : "Whether this interface should be disconnected (like pulling the plug).",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "macaddr" : {
                                                   "description" : "MAC address. That address must be unique withing your network. This is automatically generated if not specified.",
                                                   "format_description" : "XX:XX:XX:XX:XX:XX",
                                                   "optional" : 1,
                                                   "pattern" : "(?^i:[0-9a-f]{2}(?::[0-9a-f]{2}){5})",
                                                   "type" : "string"
                                                },
                                                "model" : {
                                                   "default_key" : 1,
                                                   "description" : "Network Card Model. The 'virtio' model provides the best performance with very low CPU overhead. If your guest does not support this driver, it is usually best to use 'e1000'.",
                                                   "enum" : [
                                                      "rtl8139",
                                                      "ne2k_pci",
                                                      "e1000",
                                                      "pcnet",
                                                      "virtio",
                                                      "ne2k_isa",
                                                      "i82551",
                                                      "i82557b",
                                                      "i82559er",
                                                      "vmxnet3",
                                                      "e1000-82540em",
                                                      "e1000-82544gc",
                                                      "e1000-82545em"
                                                   ],
                                                   "format_description" : "model",
                                                   "type" : "string"
                                                },
                                                "ne2k_isa" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "ne2k_pci" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "pcnet" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "queues" : {
                                                   "description" : "Number of packet queues to be used on the device.",
                                                   "maximum" : 16,
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "rate" : {
                                                   "description" : "Rate limit in mbps (megabytes per second) as floating point number.",
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "rtl8139" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "tag" : {
                                                   "description" : "VLAN tag to apply to packets on this interface.",
                                                   "maximum" : 4094,
                                                   "minimum" : 1,
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "trunks" : {
                                                   "description" : "VLAN trunks to pass through this interface.",
                                                   "format_description" : "vlanid[;vlanid...]",
                                                   "optional" : 1,
                                                   "pattern" : "(?^:\\d+(?:-\\d+)?(?:;\\d+(?:-\\d+)?)*)",
                                                   "type" : "string"
                                                },
                                                "virtio" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                },
                                                "vmxnet3" : {
                                                   "alias" : "macaddr",
                                                   "keyAlias" : "model"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[model=]<model> [,bridge=<bridge>] [,firewall=<1|0>] [,link_down=<1|0>] [,macaddr=<XX:XX:XX:XX:XX:XX>] [,queues=<integer>] [,rate=<number>] [,tag=<integer>] [,trunks=<vlanid[;vlanid...]>] [,<model>=<macaddr>]"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "numa" : {
                                             "default" : 0,
                                             "description" : "Enable/disable NUMA.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "numa[n]" : {
                                             "description" : "NUMA topology.",
                                             "format" : {
                                                "cpus" : {
                                                   "description" : "CPUs accessing this NUMA node.",
                                                   "format_description" : "id[-id];...",
                                                   "pattern" : "(?^:\\d+(?:-\\d+)?(?:;\\d+(?:-\\d+)?)*)",
                                                   "type" : "string"
                                                },
                                                "hostnodes" : {
                                                   "description" : "Host NUMA nodes to use.",
                                                   "format_description" : "id[-id];...",
                                                   "optional" : 1,
                                                   "pattern" : "(?^:\\d+(?:-\\d+)?(?:;\\d+(?:-\\d+)?)*)",
                                                   "type" : "string"
                                                },
                                                "memory" : {
                                                   "description" : "Amount of memory this NUMA node provides.",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "policy" : {
                                                   "description" : "NUMA allocation policy.",
                                                   "enum" : [
                                                      "preferred",
                                                      "bind",
                                                      "interleave"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "cpus=<id[-id];...> [,hostnodes=<id[-id];...>] [,memory=<number>] [,policy=<preferred|bind|interleave>]"
                                          },
                                          "onboot" : {
                                             "default" : 0,
                                             "description" : "Specifies whether a VM will be started during system bootup.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "ostype" : {
                                             "description" : "Specify guest operating system.",
                                             "enum" : [
                                                "other",
                                                "wxp",
                                                "w2k",
                                                "w2k3",
                                                "w2k8",
                                                "wvista",
                                                "win7",
                                                "win8",
                                                "l24",
                                                "l26",
                                                "solaris"
                                             ],
                                             "optional" : 1,
                                             "type" : "string",
                                             "verbose_description" : "Specify guest operating system. This is used to enable special\noptimization/features for specific operating systems:\n\n[horizontal]\nother;; unspecified OS\nwxp;; Microsoft Windows XP\nw2k;; Microsoft Windows 2000\nw2k3;; Microsoft Windows 2003\nw2k8;; Microsoft Windows 2008\nwvista;; Microsoft Windows Vista\nwin7;; Microsoft Windows 7\nwin8;; Microsoft Windows 8/2012\nl24;; Linux 2.4 Kernel\nl26;; Linux 2.6/3.X Kernel\nsolaris;; Solaris/OpenSolaris/OpenIndiania kernel\n"
                                          },
                                          "parallel[n]" : {
                                             "description" : "Map host parallel devices (n is 0 to 2).",
                                             "optional" : 1,
                                             "pattern" : "/dev/parport\\d+|/dev/usb/lp\\d+",
                                             "type" : "string",
                                             "verbose_description" : "Map host parallel devices (n is 0 to 2).\n\nNOTE: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nCAUTION: Experimental! User reported problems with this option.\n"
                                          },
                                          "protection" : {
                                             "default" : 0,
                                             "description" : "Sets the protection flag of the VM. This will disable the remove VM and remove disk operations.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "reboot" : {
                                             "default" : 1,
                                             "description" : "Allow reboot. If set to '0' the VM exit on reboot.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "revert" : {
                                             "description" : "Revert a pending change.",
                                             "format" : "pve-configid-list",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "sata[n]" : {
                                             "description" : "Use volume as SATA hard disk or CD-ROM (n is 0 to 5).",
                                             "format" : {
                                                "aio" : {
                                                   "description" : "AIO type to use.",
                                                   "enum" : [
                                                      "native",
                                                      "threads"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "backup" : {
                                                   "description" : "Whether the drive should be included when making backups.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "bps" : {
                                                   "description" : "Maximum r/w speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_rd" : {
                                                   "description" : "Maximum read speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_wr" : {
                                                   "description" : "Maximum write speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "cache" : {
                                                   "description" : "The drive's cache mode",
                                                   "enum" : [
                                                      "none",
                                                      "writethrough",
                                                      "writeback",
                                                      "unsafe",
                                                      "directsync"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "cyls" : {
                                                   "description" : "Force the drive's physical geometry to have a specific cylinder count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "detect_zeroes" : {
                                                   "description" : "Controls whether to detect and try to optimize writes of zeroes.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "discard" : {
                                                   "description" : "Controls whether to pass discard/trim requests to the underlying storage.",
                                                   "enum" : [
                                                      "ignore",
                                                      "on"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "file" : {
                                                   "default_key" : 1,
                                                   "description" : "The drive's backing volume.",
                                                   "format" : "pve-volume-id-or-qm-path",
                                                   "format_description" : "volume",
                                                   "type" : "string"
                                                },
                                                "format" : {
                                                   "description" : "The drive's backing file's data format.",
                                                   "enum" : [
                                                      "raw",
                                                      "cow",
                                                      "qcow",
                                                      "qed",
                                                      "qcow2",
                                                      "vmdk",
                                                      "cloop"
                                                   ],
                                                   "format_description" : "image format",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "heads" : {
                                                   "description" : "Force the drive's physical geometry to have a specific head count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops" : {
                                                   "description" : "Maximum r/w I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_max" : {
                                                   "description" : "Maximum unthrottled r/w I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd" : {
                                                   "description" : "Maximum read I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd_max" : {
                                                   "description" : "Maximum unthrottled read I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr" : {
                                                   "description" : "Maximum write I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr_max" : {
                                                   "description" : "Maximum unthrottled write I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "mbps" : {
                                                   "description" : "Maximum r/w speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_max" : {
                                                   "description" : "Maximum unthrottled r/w pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd" : {
                                                   "description" : "Maximum read speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd_max" : {
                                                   "description" : "Maximum unthrottled read pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr" : {
                                                   "description" : "Maximum write speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr_max" : {
                                                   "description" : "Maximum unthrottled write pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "media" : {
                                                   "default" : "disk",
                                                   "description" : "The drive's media type.",
                                                   "enum" : [
                                                      "cdrom",
                                                      "disk"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "rerror" : {
                                                   "description" : "Read error action.",
                                                   "enum" : [
                                                      "ignore",
                                                      "report",
                                                      "stop"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "secs" : {
                                                   "description" : "Force the drive's physical geometry to have a specific sector count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "serial" : {
                                                   "description" : "The drive's reported serial number, url-encoded, up to 20 bytes long.",
                                                   "format" : "urlencoded",
                                                   "format_description" : "serial",
                                                   "maxLength" : 60,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "size" : {
                                                   "description" : "Disk size. This is purely informational and has no effect.",
                                                   "format" : "disk-size",
                                                   "format_description" : "DiskSize",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "snapshot" : {
                                                   "description" : "Whether the drive should be included when making snapshots.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "trans" : {
                                                   "description" : "Force disk geometry bios translation mode.",
                                                   "enum" : [
                                                      "none",
                                                      "lba",
                                                      "auto"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "volume" : {
                                                   "alias" : "file"
                                                },
                                                "werror" : {
                                                   "description" : "Write error action.",
                                                   "enum" : [
                                                      "enospc",
                                                      "ignore",
                                                      "report",
                                                      "stop"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[file=]<volume> [,aio=<native|threads>] [,backup=<1|0>] [,bps=<bps>] [,bps_rd=<bps>] [,bps_wr=<bps>] [,cache=<none|writethrough|writeback|unsafe|directsync>] [,cyls=<integer>] [,detect_zeroes=<1|0>] [,discard=<ignore|on>] [,format=<image format>] [,heads=<integer>] [,iops=<iops>] [,iops_max=<iops>] [,iops_rd=<iops>] [,iops_rd_max=<iops>] [,iops_wr=<iops>] [,iops_wr_max=<iops>] [,mbps=<mbps>] [,mbps_max=<mbps>] [,mbps_rd=<mbps>] [,mbps_rd_max=<mbps>] [,mbps_wr=<mbps>] [,mbps_wr_max=<mbps>] [,media=<cdrom|disk>] [,rerror=<ignore|report|stop>] [,secs=<integer>] [,serial=<serial>] [,size=<DiskSize>] [,snapshot=<1|0>] [,trans=<none|lba|auto>] [,werror=<enospc|ignore|report|stop>]"
                                          },
                                          "scsi[n]" : {
                                             "description" : "Use volume as SCSI hard disk or CD-ROM (n is 0 to 13).",
                                             "format" : {
                                                "aio" : {
                                                   "description" : "AIO type to use.",
                                                   "enum" : [
                                                      "native",
                                                      "threads"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "backup" : {
                                                   "description" : "Whether the drive should be included when making backups.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "bps" : {
                                                   "description" : "Maximum r/w speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_rd" : {
                                                   "description" : "Maximum read speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_wr" : {
                                                   "description" : "Maximum write speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "cache" : {
                                                   "description" : "The drive's cache mode",
                                                   "enum" : [
                                                      "none",
                                                      "writethrough",
                                                      "writeback",
                                                      "unsafe",
                                                      "directsync"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "cyls" : {
                                                   "description" : "Force the drive's physical geometry to have a specific cylinder count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "detect_zeroes" : {
                                                   "description" : "Controls whether to detect and try to optimize writes of zeroes.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "discard" : {
                                                   "description" : "Controls whether to pass discard/trim requests to the underlying storage.",
                                                   "enum" : [
                                                      "ignore",
                                                      "on"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "file" : {
                                                   "default_key" : 1,
                                                   "description" : "The drive's backing volume.",
                                                   "format" : "pve-volume-id-or-qm-path",
                                                   "format_description" : "volume",
                                                   "type" : "string"
                                                },
                                                "format" : {
                                                   "description" : "The drive's backing file's data format.",
                                                   "enum" : [
                                                      "raw",
                                                      "cow",
                                                      "qcow",
                                                      "qed",
                                                      "qcow2",
                                                      "vmdk",
                                                      "cloop"
                                                   ],
                                                   "format_description" : "image format",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "heads" : {
                                                   "description" : "Force the drive's physical geometry to have a specific head count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops" : {
                                                   "description" : "Maximum r/w I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_max" : {
                                                   "description" : "Maximum unthrottled r/w I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd" : {
                                                   "description" : "Maximum read I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd_max" : {
                                                   "description" : "Maximum unthrottled read I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr" : {
                                                   "description" : "Maximum write I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr_max" : {
                                                   "description" : "Maximum unthrottled write I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iothread" : {
                                                   "description" : "Whether to use iothreads for this drive",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "mbps" : {
                                                   "description" : "Maximum r/w speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_max" : {
                                                   "description" : "Maximum unthrottled r/w pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd" : {
                                                   "description" : "Maximum read speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd_max" : {
                                                   "description" : "Maximum unthrottled read pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr" : {
                                                   "description" : "Maximum write speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr_max" : {
                                                   "description" : "Maximum unthrottled write pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "media" : {
                                                   "default" : "disk",
                                                   "description" : "The drive's media type.",
                                                   "enum" : [
                                                      "cdrom",
                                                      "disk"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "queues" : {
                                                   "description" : "Number of queues.",
                                                   "minimum" : 2,
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "secs" : {
                                                   "description" : "Force the drive's physical geometry to have a specific sector count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "serial" : {
                                                   "description" : "The drive's reported serial number, url-encoded, up to 20 bytes long.",
                                                   "format" : "urlencoded",
                                                   "format_description" : "serial",
                                                   "maxLength" : 60,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "size" : {
                                                   "description" : "Disk size. This is purely informational and has no effect.",
                                                   "format" : "disk-size",
                                                   "format_description" : "DiskSize",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "snapshot" : {
                                                   "description" : "Whether the drive should be included when making snapshots.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "trans" : {
                                                   "description" : "Force disk geometry bios translation mode.",
                                                   "enum" : [
                                                      "none",
                                                      "lba",
                                                      "auto"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "volume" : {
                                                   "alias" : "file"
                                                },
                                                "werror" : {
                                                   "description" : "Write error action.",
                                                   "enum" : [
                                                      "enospc",
                                                      "ignore",
                                                      "report",
                                                      "stop"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[file=]<volume> [,aio=<native|threads>] [,backup=<1|0>] [,bps=<bps>] [,bps_rd=<bps>] [,bps_wr=<bps>] [,cache=<none|writethrough|writeback|unsafe|directsync>] [,cyls=<integer>] [,detect_zeroes=<1|0>] [,discard=<ignore|on>] [,format=<image format>] [,heads=<integer>] [,iops=<iops>] [,iops_max=<iops>] [,iops_rd=<iops>] [,iops_rd_max=<iops>] [,iops_wr=<iops>] [,iops_wr_max=<iops>] [,iothread=<1|0>] [,mbps=<mbps>] [,mbps_max=<mbps>] [,mbps_rd=<mbps>] [,mbps_rd_max=<mbps>] [,mbps_wr=<mbps>] [,mbps_wr_max=<mbps>] [,media=<cdrom|disk>] [,queues=<integer>] [,secs=<integer>] [,serial=<serial>] [,size=<DiskSize>] [,snapshot=<1|0>] [,trans=<none|lba|auto>] [,werror=<enospc|ignore|report|stop>]"
                                          },
                                          "scsihw" : {
                                             "default" : "lsi",
                                             "description" : "SCSI controller model",
                                             "enum" : [
                                                "lsi",
                                                "lsi53c810",
                                                "virtio-scsi-pci",
                                                "virtio-scsi-single",
                                                "megasas",
                                                "pvscsi"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "serial[n]" : {
                                             "description" : "Create a serial device inside the VM (n is 0 to 3)",
                                             "optional" : 1,
                                             "pattern" : "(/dev/.+|socket)",
                                             "type" : "string",
                                             "verbose_description" : "Create a serial device inside the VM (n is 0 to 3), and pass through a\nhost serial device (i.e. /dev/ttyS0), or create a unix socket on the\nhost side (use 'qm terminal' to open a terminal connection).\n\nNOTE: If you pass through a host serial device, it is no longer possible to migrate such machines - use with special care.\n\nCAUTION: Experimental! User reported problems with this option.\n"
                                          },
                                          "shares" : {
                                             "default" : 1000,
                                             "description" : "Amount of memory shares for auto-ballooning. The larger the number is, the more memory this VM gets. Number is relative to weights of all other running VMs. Using zero disables auto-ballooning",
                                             "maximum" : 50000,
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0-50000)"
                                          },
                                          "skiplock" : {
                                             "description" : "Ignore locks - only root is allowed to use this option.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "smbios1" : {
                                             "description" : "Specify SMBIOS type 1 fields.",
                                             "format" : "pve-qm-smbios1",
                                             "maxLength" : 256,
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[family=<string>] [,manufacturer=<string>] [,product=<string>] [,serial=<string>] [,sku=<string>] [,uuid=<UUID>] [,version=<string>]"
                                          },
                                          "smp" : {
                                             "default" : 1,
                                             "description" : "The number of CPUs. Please use option -sockets instead.",
                                             "minimum" : 1,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "sockets" : {
                                             "default" : 1,
                                             "description" : "The number of CPU sockets.",
                                             "minimum" : 1,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "startdate" : {
                                             "default" : "now",
                                             "description" : "Set the initial date of the real time clock. Valid format for date are: 'now' or '2006-06-17T16:01:21' or '2006-06-17'.",
                                             "optional" : 1,
                                             "pattern" : "(now|\\d{4}-\\d{1,2}-\\d{1,2}(T\\d{1,2}:\\d{1,2}:\\d{1,2})?)",
                                             "type" : "string",
                                             "typetext" : "(now | YYYY-MM-DD | YYYY-MM-DDTHH:MM:SS)"
                                          },
                                          "startup" : {
                                             "description" : "Startup and shutdown behavior. Order is a non-negative number defining the general startup order. Shutdown in done with reverse ordering. Additionally you can set the 'up' or 'down' delay in seconds, which specifies a delay to wait before the next VM is started or stopped.",
                                             "format" : "pve-startup-order",
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[[order=]\\d+] [,up=\\d+] [,down=\\d+] "
                                          },
                                          "tablet" : {
                                             "default" : 1,
                                             "description" : "Enable/disable the USB tablet device.",
                                             "optional" : 1,
                                             "type" : "boolean",
                                             "verbose_description" : "Enable/disable the USB tablet device. This device is usually needed to allow absolute mouse positioning with VNC. Else the mouse runs out of sync with normal VNC clients. If you're running lots of console-only guests on one host, you may consider disabling this to save some context switches. This is turned off by default if you use spice (-vga=qxl)."
                                          },
                                          "tdf" : {
                                             "default" : 0,
                                             "description" : "Enable/disable time drift fix.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "template" : {
                                             "default" : 0,
                                             "description" : "Enable/disable Template.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "unused[n]" : {
                                             "description" : "Reference to unused volumes. This is used internally, and should not be modified manually.",
                                             "format" : "pve-volume-id",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "usb[n]" : {
                                             "description" : "Configure an USB device (n is 0 to 4).",
                                             "format" : {
                                                "host" : {
                                                   "default_key" : 1,
                                                   "description" : "The Host USB device or port or the value 'spice'. HOSTUSBDEVICE syntax is:\n\n 'bus-port(.port)*' (decimal numbers) or\n 'vendor_id:product_id' (hexadeciaml numbers) or\n 'spice'\n\nYou can use the 'lsusb -t' command to list existing usb devices.\n\nNOTE: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nThe value 'spice' can be used to add a usb redirection devices for spice.\n",
                                                   "format" : "pve-qm-usb-device",
                                                   "format_description" : "HOSTUSBDEVICE|spice",
                                                   "type" : "string"
                                                },
                                                "usb3" : {
                                                   "default" : 0,
                                                   "description" : "Specifies whether if given host option is a USB3 device or port (this does currently not work reliably with spice redirection and is then ignored).",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[host=]<HOSTUSBDEVICE|spice> [,usb3=<1|0>]"
                                          },
                                          "vcpus" : {
                                             "default" : 0,
                                             "description" : "Number of hotplugged vcpus.",
                                             "minimum" : 1,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "vga" : {
                                             "description" : "Select the VGA type.",
                                             "enum" : [
                                                "std",
                                                "cirrus",
                                                "vmware",
                                                "qxl",
                                                "serial0",
                                                "serial1",
                                                "serial2",
                                                "serial3",
                                                "qxl2",
                                                "qxl3",
                                                "qxl4"
                                             ],
                                             "optional" : 1,
                                             "type" : "string",
                                             "verbose_description" : "Select the VGA type. If you want to use high resolution modes (>= 1280x1024x16) then you should use the options 'std' or 'vmware'. Default is 'std' for win8/win7/w2k8, and 'cirrus' for other OS types. The 'qxl' option enables the SPICE display sever. For win* OS you can select how many independent displays you want, Linux guests can add displays them self. You can also run without any graphic card, using a serial device as terminal."
                                          },
                                          "virtio[n]" : {
                                             "description" : "Use volume as VIRTIO hard disk (n is 0 to 15).",
                                             "format" : {
                                                "aio" : {
                                                   "description" : "AIO type to use.",
                                                   "enum" : [
                                                      "native",
                                                      "threads"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "backup" : {
                                                   "description" : "Whether the drive should be included when making backups.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "bps" : {
                                                   "description" : "Maximum r/w speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_rd" : {
                                                   "description" : "Maximum read speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "bps_wr" : {
                                                   "description" : "Maximum write speed speed in bytes per second.",
                                                   "format_description" : "bps",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "cache" : {
                                                   "description" : "The drive's cache mode",
                                                   "enum" : [
                                                      "none",
                                                      "writethrough",
                                                      "writeback",
                                                      "unsafe",
                                                      "directsync"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "cyls" : {
                                                   "description" : "Force the drive's physical geometry to have a specific cylinder count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "detect_zeroes" : {
                                                   "description" : "Controls whether to detect and try to optimize writes of zeroes.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "discard" : {
                                                   "description" : "Controls whether to pass discard/trim requests to the underlying storage.",
                                                   "enum" : [
                                                      "ignore",
                                                      "on"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "file" : {
                                                   "default_key" : 1,
                                                   "description" : "The drive's backing volume.",
                                                   "format" : "pve-volume-id-or-qm-path",
                                                   "format_description" : "volume",
                                                   "type" : "string"
                                                },
                                                "format" : {
                                                   "description" : "The drive's backing file's data format.",
                                                   "enum" : [
                                                      "raw",
                                                      "cow",
                                                      "qcow",
                                                      "qed",
                                                      "qcow2",
                                                      "vmdk",
                                                      "cloop"
                                                   ],
                                                   "format_description" : "image format",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "heads" : {
                                                   "description" : "Force the drive's physical geometry to have a specific head count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops" : {
                                                   "description" : "Maximum r/w I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_max" : {
                                                   "description" : "Maximum unthrottled r/w I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd" : {
                                                   "description" : "Maximum read I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_rd_max" : {
                                                   "description" : "Maximum unthrottled read I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr" : {
                                                   "description" : "Maximum write I/O speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iops_wr_max" : {
                                                   "description" : "Maximum unthrottled write I/O pool speed in operations per second.",
                                                   "format_description" : "iops",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "iothread" : {
                                                   "description" : "Whether to use iothreads for this drive",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "mbps" : {
                                                   "description" : "Maximum r/w speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_max" : {
                                                   "description" : "Maximum unthrottled r/w pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd" : {
                                                   "description" : "Maximum read speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_rd_max" : {
                                                   "description" : "Maximum unthrottled read pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr" : {
                                                   "description" : "Maximum write speed speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "mbps_wr_max" : {
                                                   "description" : "Maximum unthrottled write pool speed in megabytes per second.",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "media" : {
                                                   "default" : "disk",
                                                   "description" : "The drive's media type.",
                                                   "enum" : [
                                                      "cdrom",
                                                      "disk"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "rerror" : {
                                                   "description" : "Read error action.",
                                                   "enum" : [
                                                      "ignore",
                                                      "report",
                                                      "stop"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "secs" : {
                                                   "description" : "Force the drive's physical geometry to have a specific sector count.",
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "serial" : {
                                                   "description" : "The drive's reported serial number, url-encoded, up to 20 bytes long.",
                                                   "format" : "urlencoded",
                                                   "format_description" : "serial",
                                                   "maxLength" : 60,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "size" : {
                                                   "description" : "Disk size. This is purely informational and has no effect.",
                                                   "format" : "disk-size",
                                                   "format_description" : "DiskSize",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "snapshot" : {
                                                   "description" : "Whether the drive should be included when making snapshots.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "trans" : {
                                                   "description" : "Force disk geometry bios translation mode.",
                                                   "enum" : [
                                                      "none",
                                                      "lba",
                                                      "auto"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "volume" : {
                                                   "alias" : "file"
                                                },
                                                "werror" : {
                                                   "description" : "Write error action.",
                                                   "enum" : [
                                                      "enospc",
                                                      "ignore",
                                                      "report",
                                                      "stop"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[file=]<volume> [,aio=<native|threads>] [,backup=<1|0>] [,bps=<bps>] [,bps_rd=<bps>] [,bps_wr=<bps>] [,cache=<none|writethrough|writeback|unsafe|directsync>] [,cyls=<integer>] [,detect_zeroes=<1|0>] [,discard=<ignore|on>] [,format=<image format>] [,heads=<integer>] [,iops=<iops>] [,iops_max=<iops>] [,iops_rd=<iops>] [,iops_rd_max=<iops>] [,iops_wr=<iops>] [,iops_wr_max=<iops>] [,iothread=<1|0>] [,mbps=<mbps>] [,mbps_max=<mbps>] [,mbps_rd=<mbps>] [,mbps_rd_max=<mbps>] [,mbps_wr=<mbps>] [,mbps_wr_max=<mbps>] [,media=<cdrom|disk>] [,rerror=<ignore|report|stop>] [,secs=<integer>] [,serial=<serial>] [,size=<DiskSize>] [,snapshot=<1|0>] [,trans=<none|lba|auto>] [,werror=<enospc|ignore|report|stop>]"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "watchdog" : {
                                             "description" : "Create a virtual hardware watchdog device.",
                                             "format" : "pve-qm-watchdog",
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[[model=]<i6300esb|ib700>] [,action=<reset|shutdown|poweroff|pause|debug|none>]",
                                             "verbose_description" : "Create a virtual hardware watchdog device. Once enabled (by a guest action), the watchdog must be periodically polled by an agent inside the guest or else the watchdog will reset the guest (or execute the respective action specified)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Config.Disk",
                                             "VM.Config.CDROM",
                                             "VM.Config.CPU",
                                             "VM.Config.Memory",
                                             "VM.Config.Network",
                                             "VM.Config.HWType",
                                             "VM.Config.Options"
                                          ],
                                          "any",
                                          1
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/config",
                              "text" : "config"
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Get virtual machine configuration, including pending changes.",
                                    "method" : "GET",
                                    "name" : "vm_pending",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "proxyto" : "node",
                                    "returns" : {
                                       "items" : {
                                          "properties" : {
                                             "delete" : {
                                                "description" : "Indicates a pending delete request if present and not 0. The value 2 indicates a force-delete request.",
                                                "maximum" : 2,
                                                "minimum" : 0,
                                                "optional" : 1,
                                                "type" : "integer"
                                             },
                                             "key" : {
                                                "description" : "Configuration option name.",
                                                "type" : "string"
                                             },
                                             "pending" : {
                                                "description" : "Pending value.",
                                                "optional" : 1,
                                                "type" : "string"
                                             },
                                             "value" : {
                                                "description" : "Current value.",
                                                "optional" : 1,
                                                "type" : "string"
                                             }
                                          },
                                          "type" : "object"
                                       },
                                       "type" : "array"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/pending",
                              "text" : "pending"
                           },
                           {
                              "info" : {
                                 "PUT" : {
                                    "description" : "Unlink/delete disk images.",
                                    "method" : "PUT",
                                    "name" : "unlink",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "force" : {
                                             "description" : "Force physical removal. Without this, we simple remove the disk from the config file and create an additional configuration entry called 'unused[n]', which contains the volume ID. Unlink of unused[n] always cause physical removal.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "idlist" : {
                                             "description" : "A list of disk IDs you want to delete.",
                                             "format" : "pve-configid-list",
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Config.Disk"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/unlink",
                              "text" : "unlink"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Creates a TCP VNC proxy connections.",
                                    "method" : "POST",
                                    "name" : "vncproxy",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "websocket" : {
                                             "description" : "starts websockify instead of vncproxy",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Console"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "returns" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "cert" : {
                                             "type" : "string"
                                          },
                                          "port" : {
                                             "type" : "integer"
                                          },
                                          "ticket" : {
                                             "type" : "string"
                                          },
                                          "upid" : {
                                             "type" : "string"
                                          },
                                          "user" : {
                                             "type" : "string"
                                          }
                                       }
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/vncproxy",
                              "text" : "vncproxy"
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Opens a weksocket for VNC traffic.",
                                    "method" : "GET",
                                    "name" : "vncwebsocket",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "port" : {
                                             "description" : "Port number returned by previous vncproxy call.",
                                             "maximum" : 5999,
                                             "minimum" : 5900,
                                             "type" : "integer",
                                             "typetext" : "integer (5900-5999)"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "vncticket" : {
                                             "description" : "Ticket from previous call to vncproxy.",
                                             "maxLength" : 512,
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Console"
                                          ]
                                       ],
                                       "description" : "You also need to pass a valid ticket (vncticket)."
                                    },
                                    "returns" : {
                                       "properties" : {
                                          "port" : {
                                             "type" : "string"
                                          }
                                       },
                                       "type" : "object"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/vncwebsocket",
                              "text" : "vncwebsocket"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Returns a SPICE configuration to connect to the VM.",
                                    "method" : "POST",
                                    "name" : "spiceproxy",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "proxy" : {
                                             "description" : "SPICE proxy server. This can be used by the client to specify the proxy server. All nodes in a cluster runs 'spiceproxy', so it is up to the client to choose one. By default, we return the node where the VM is currently running. As resonable setting is to use same node you use to connect to the API (This is window.location.hostname for the JS GUI).",
                                             "format" : "address",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Console"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "additionalProperties" : 1,
                                       "description" : "Returned values can be directly passed to the 'remote-viewer' application.",
                                       "properties" : {
                                          "host" : {
                                             "type" : "string"
                                          },
                                          "password" : {
                                             "type" : "string"
                                          },
                                          "proxy" : {
                                             "type" : "string"
                                          },
                                          "tls-port" : {
                                             "type" : "integer"
                                          },
                                          "type" : {
                                             "type" : "string"
                                          }
                                       }
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/spiceproxy",
                              "text" : "spiceproxy"
                           },
                           {
                              "children" : [
                                 {
                                    "info" : {
                                       "GET" : {
                                          "description" : "Get virtual machine status.",
                                          "method" : "GET",
                                          "name" : "vm_status",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "object"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/qemu/{vmid}/status/current",
                                    "text" : "current"
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "description" : "Start virtual machine.",
                                          "method" : "POST",
                                          "name" : "vm_start",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "machine" : {
                                                   "description" : "Specific the Qemu machine type.",
                                                   "maxLength" : 40,
                                                   "optional" : 1,
                                                   "pattern" : "(pc|pc(-i440fx)?-\\d+\\.\\d+(\\.pxe)?|q35|pc-q35-\\d+\\.\\d+(\\.pxe)?)",
                                                   "type" : "string"
                                                },
                                                "migratedfrom" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "skiplock" : {
                                                   "description" : "Ignore locks - only root is allowed to use this option.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "stateuri" : {
                                                   "description" : "Some command save/restore state from this location.",
                                                   "maxLength" : 128,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/qemu/{vmid}/status/start",
                                    "text" : "start"
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "description" : "Stop virtual machine. The qemu process will exit immediately. Thisis akin to pulling the power plug of a running computer and may damage the VM data",
                                          "method" : "POST",
                                          "name" : "vm_stop",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "keepActive" : {
                                                   "default" : 0,
                                                   "description" : "Do not decativate storage volumes.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "migratedfrom" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "skiplock" : {
                                                   "description" : "Ignore locks - only root is allowed to use this option.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "timeout" : {
                                                   "description" : "Wait maximal timeout seconds.",
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (0- N)"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/qemu/{vmid}/status/stop",
                                    "text" : "stop"
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "description" : "Reset virtual machine.",
                                          "method" : "POST",
                                          "name" : "vm_reset",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "skiplock" : {
                                                   "description" : "Ignore locks - only root is allowed to use this option.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/qemu/{vmid}/status/reset",
                                    "text" : "reset"
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "description" : "Shutdown virtual machine. This is similar to pressing the power button on a physical machine.This will send an ACPI event for the guest OS, which should then proceed to a clean shutdown.",
                                          "method" : "POST",
                                          "name" : "vm_shutdown",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "forceStop" : {
                                                   "default" : 0,
                                                   "description" : "Make sure the VM stops.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "keepActive" : {
                                                   "default" : 0,
                                                   "description" : "Do not decativate storage volumes.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "skiplock" : {
                                                   "description" : "Ignore locks - only root is allowed to use this option.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "timeout" : {
                                                   "description" : "Wait maximal timeout seconds.",
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (0- N)"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/qemu/{vmid}/status/shutdown",
                                    "text" : "shutdown"
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "description" : "Suspend virtual machine.",
                                          "method" : "POST",
                                          "name" : "vm_suspend",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "skiplock" : {
                                                   "description" : "Ignore locks - only root is allowed to use this option.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/qemu/{vmid}/status/suspend",
                                    "text" : "suspend"
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "description" : "Resume virtual machine.",
                                          "method" : "POST",
                                          "name" : "vm_resume",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "nocheck" : {
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "skiplock" : {
                                                   "description" : "Ignore locks - only root is allowed to use this option.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/qemu/{vmid}/status/resume",
                                    "text" : "resume"
                                 }
                              ],
                              "info" : {
                                 "GET" : {
                                    "description" : "Directory index",
                                    "method" : "GET",
                                    "name" : "vmcmdidx",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "user" : "all"
                                    },
                                    "proxyto" : "node",
                                    "returns" : {
                                       "items" : {
                                          "properties" : {
                                             "subdir" : {
                                                "type" : "string"
                                             }
                                          },
                                          "type" : "object"
                                       },
                                       "links" : [
                                          {
                                             "href" : "{subdir}",
                                             "rel" : "child"
                                          }
                                       ],
                                       "type" : "array"
                                    }
                                 }
                              },
                              "leaf" : 0,
                              "path" : "/nodes/{node}/qemu/{vmid}/status",
                              "text" : "status"
                           },
                           {
                              "info" : {
                                 "PUT" : {
                                    "description" : "Send key event to virtual machine.",
                                    "method" : "PUT",
                                    "name" : "vm_sendkey",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "key" : {
                                             "description" : "The key (qemu monitor encoding).",
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "skiplock" : {
                                             "description" : "Ignore locks - only root is allowed to use this option.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Console"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/sendkey",
                              "text" : "sendkey"
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Check if feature for virtual machine is available.",
                                    "method" : "GET",
                                    "name" : "vm_feature",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "feature" : {
                                             "description" : "Feature to check.",
                                             "enum" : [
                                                "snapshot",
                                                "clone",
                                                "copy"
                                             ],
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "snapname" : {
                                             "description" : "The name of the snapshot.",
                                             "format" : "pve-configid",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "properties" : {
                                          "hasFeature" : {
                                             "type" : "boolean"
                                          },
                                          "nodes" : {
                                             "items" : {
                                                "type" : "string"
                                             },
                                             "type" : "array"
                                          }
                                       },
                                       "type" : "object"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/feature",
                              "text" : "feature"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Create a copy of virtual machine/template.",
                                    "method" : "POST",
                                    "name" : "clone_vm",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "description" : {
                                             "description" : "Description for the new VM.",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "format" : {
                                             "description" : "Target format for file storage.",
                                             "enum" : [
                                                "raw",
                                                "qcow2",
                                                "vmdk"
                                             ],
                                             "optional" : 1,
                                             "requires" : "full",
                                             "type" : "string"
                                          },
                                          "full" : {
                                             "default" : 0,
                                             "description" : "Create a full copy of all disk. This is always done when you clone a normal VM. For VM templates, we try to create a linked clone by default.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "name" : {
                                             "description" : "Set a name for the new VM.",
                                             "format" : "dns-name",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "newid" : {
                                             "description" : "VMID for the clone.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "pool" : {
                                             "description" : "Add the new VM to the specified pool.",
                                             "format" : "pve-poolid",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "snapname" : {
                                             "description" : "The name of the snapshot.",
                                             "format" : "pve-configid",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "storage" : {
                                             "description" : "Target storage for full clone.",
                                             "format" : "pve-storage-id",
                                             "optional" : 1,
                                             "requires" : "full",
                                             "type" : "string"
                                          },
                                          "target" : {
                                             "description" : "Target node. Only allowed if the original VM is on shared storage.",
                                             "format" : "pve-node",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "and",
                                          [
                                             "perm",
                                             "/vms/{vmid}",
                                             [
                                                "VM.Clone"
                                             ]
                                          ],
                                          [
                                             "or",
                                             [
                                                "perm",
                                                "/vms/{newid}",
                                                [
                                                   "VM.Allocate"
                                                ]
                                             ],
                                             [
                                                "perm",
                                                "/pool/{pool}",
                                                [
                                                   "VM.Allocate"
                                                ],
                                                "require_param",
                                                "pool"
                                             ]
                                          ]
                                       ],
                                       "description" : "You need 'VM.Clone' permissions on /vms/{vmid}, and 'VM.Allocate' permissions on /vms/{newid} (or on the VM pool /pool/{pool}). You also need 'Datastore.AllocateSpace' on any used storage."
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/clone",
                              "text" : "clone"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Move volume to different storage.",
                                    "method" : "POST",
                                    "name" : "move_vm_disk",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "delete" : {
                                             "default" : 0,
                                             "description" : "Delete the original disk after successful copy. By default the original disk is kept as unused disk.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "digest" : {
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "disk" : {
                                             "description" : "The disk you want to move.",
                                             "enum" : [
                                                "ide0",
                                                "ide1",
                                                "ide2",
                                                "ide3",
                                                "scsi0",
                                                "scsi1",
                                                "scsi2",
                                                "scsi3",
                                                "scsi4",
                                                "scsi5",
                                                "scsi6",
                                                "scsi7",
                                                "scsi8",
                                                "scsi9",
                                                "scsi10",
                                                "scsi11",
                                                "scsi12",
                                                "scsi13",
                                                "virtio0",
                                                "virtio1",
                                                "virtio2",
                                                "virtio3",
                                                "virtio4",
                                                "virtio5",
                                                "virtio6",
                                                "virtio7",
                                                "virtio8",
                                                "virtio9",
                                                "virtio10",
                                                "virtio11",
                                                "virtio12",
                                                "virtio13",
                                                "virtio14",
                                                "virtio15",
                                                "sata0",
                                                "sata1",
                                                "sata2",
                                                "sata3",
                                                "sata4",
                                                "sata5"
                                             ],
                                             "type" : "string"
                                          },
                                          "format" : {
                                             "description" : "Target Format.",
                                             "enum" : [
                                                "raw",
                                                "qcow2",
                                                "vmdk"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "storage" : {
                                             "description" : "Target storage.",
                                             "format" : "pve-storage-id",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "and",
                                          [
                                             "perm",
                                             "/vms/{vmid}",
                                             [
                                                "VM.Config.Disk"
                                             ]
                                          ],
                                          [
                                             "perm",
                                             "/storage/{storage}",
                                             [
                                                "Datastore.AllocateSpace"
                                             ]
                                          ]
                                       ],
                                       "description" : "You need 'VM.Config.Disk' permissions on /vms/{vmid}, and 'Datastore.AllocateSpace' permissions on the storage."
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "description" : "the task ID.",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/move_disk",
                              "text" : "move_disk"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Migrate virtual machine. Creates a new migration task.",
                                    "method" : "POST",
                                    "name" : "migrate_vm",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "force" : {
                                             "description" : "Allow to migrate VMs which use local devices. Only root may use this option.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "online" : {
                                             "description" : "Use online/live migration.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "target" : {
                                             "description" : "Target node.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Migrate"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "description" : "the task ID.",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/migrate",
                              "text" : "migrate"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Execute Qemu monitor commands.",
                                    "method" : "POST",
                                    "name" : "monitor",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "command" : {
                                             "description" : "The monitor command.",
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Monitor"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/monitor",
                              "text" : "monitor"
                           },
                           {
                              "info" : {
                                 "PUT" : {
                                    "description" : "Extend volume size.",
                                    "method" : "PUT",
                                    "name" : "resize_vm",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "digest" : {
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "disk" : {
                                             "description" : "The disk you want to resize.",
                                             "enum" : [
                                                "ide0",
                                                "ide1",
                                                "ide2",
                                                "ide3",
                                                "scsi0",
                                                "scsi1",
                                                "scsi2",
                                                "scsi3",
                                                "scsi4",
                                                "scsi5",
                                                "scsi6",
                                                "scsi7",
                                                "scsi8",
                                                "scsi9",
                                                "scsi10",
                                                "scsi11",
                                                "scsi12",
                                                "scsi13",
                                                "virtio0",
                                                "virtio1",
                                                "virtio2",
                                                "virtio3",
                                                "virtio4",
                                                "virtio5",
                                                "virtio6",
                                                "virtio7",
                                                "virtio8",
                                                "virtio9",
                                                "virtio10",
                                                "virtio11",
                                                "virtio12",
                                                "virtio13",
                                                "virtio14",
                                                "virtio15",
                                                "sata0",
                                                "sata1",
                                                "sata2",
                                                "sata3",
                                                "sata4",
                                                "sata5"
                                             ],
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "size" : {
                                             "description" : "The new size. With the '+' sign the value is added to the actual size of the volume and without it, the value is taken as an absolute one. Shrinking disk size is not supported.",
                                             "pattern" : "\\+?\\d+(\\.\\d+)?[KMGT]?",
                                             "type" : "string"
                                          },
                                          "skiplock" : {
                                             "description" : "Ignore locks - only root is allowed to use this option.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Config.Disk"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/resize",
                              "text" : "resize"
                           },
                           {
                              "children" : [
                                 {
                                    "children" : [
                                       {
                                          "info" : {
                                             "GET" : {
                                                "description" : "Get snapshot configuration",
                                                "method" : "GET",
                                                "name" : "get_snapshot_config",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "snapname" : {
                                                         "description" : "The name of the snapshot.",
                                                         "format" : "pve-configid",
                                                         "maxLength" : 40,
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Snapshot"
                                                      ]
                                                   ]
                                                },
                                                "proxyto" : "node",
                                                "returns" : {
                                                   "type" : "object"
                                                }
                                             },
                                             "PUT" : {
                                                "description" : "Update snapshot metadata.",
                                                "method" : "PUT",
                                                "name" : "update_snapshot_config",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "description" : {
                                                         "description" : "A textual description or comment.",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "snapname" : {
                                                         "description" : "The name of the snapshot.",
                                                         "format" : "pve-configid",
                                                         "maxLength" : 40,
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Snapshot"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "proxyto" : "node",
                                                "returns" : {
                                                   "type" : "null"
                                                }
                                             }
                                          },
                                          "leaf" : 1,
                                          "path" : "/nodes/{node}/qemu/{vmid}/snapshot/{snapname}/config",
                                          "text" : "config"
                                       },
                                       {
                                          "info" : {
                                             "POST" : {
                                                "description" : "Rollback VM state to specified snapshot.",
                                                "method" : "POST",
                                                "name" : "rollback",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "snapname" : {
                                                         "description" : "The name of the snapshot.",
                                                         "format" : "pve-configid",
                                                         "maxLength" : 40,
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Snapshot"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "proxyto" : "node",
                                                "returns" : {
                                                   "description" : "the task ID.",
                                                   "type" : "string"
                                                }
                                             }
                                          },
                                          "leaf" : 1,
                                          "path" : "/nodes/{node}/qemu/{vmid}/snapshot/{snapname}/rollback",
                                          "text" : "rollback"
                                       }
                                    ],
                                    "info" : {
                                       "DELETE" : {
                                          "description" : "Delete a VM snapshot.",
                                          "method" : "DELETE",
                                          "name" : "delsnapshot",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "force" : {
                                                   "description" : "For removal from config file, even if removing disk snapshots fails.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "snapname" : {
                                                   "description" : "The name of the snapshot.",
                                                   "format" : "pve-configid",
                                                   "maxLength" : 40,
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Snapshot"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "description" : "the task ID.",
                                             "type" : "string"
                                          }
                                       },
                                       "GET" : {
                                          "description" : "",
                                          "method" : "GET",
                                          "name" : "snapshot_cmd_idx",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "snapname" : {
                                                   "description" : "The name of the snapshot.",
                                                   "format" : "pve-configid",
                                                   "maxLength" : 40,
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "user" : "all"
                                          },
                                          "returns" : {
                                             "items" : {
                                                "properties" : {},
                                                "type" : "object"
                                             },
                                             "links" : [
                                                {
                                                   "href" : "{cmd}",
                                                   "rel" : "child"
                                                }
                                             ],
                                             "type" : "array"
                                          }
                                       }
                                    },
                                    "leaf" : 0,
                                    "path" : "/nodes/{node}/qemu/{vmid}/snapshot/{snapname}",
                                    "text" : "{snapname}"
                                 }
                              ],
                              "info" : {
                                 "GET" : {
                                    "description" : "List all snapshots.",
                                    "method" : "GET",
                                    "name" : "snapshot_list",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "items" : {
                                          "properties" : {},
                                          "type" : "object"
                                       },
                                       "links" : [
                                          {
                                             "href" : "{name}",
                                             "rel" : "child"
                                          }
                                       ],
                                       "type" : "array"
                                    }
                                 },
                                 "POST" : {
                                    "description" : "Snapshot a VM.",
                                    "method" : "POST",
                                    "name" : "snapshot",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "description" : {
                                             "description" : "A textual description or comment.",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "snapname" : {
                                             "description" : "The name of the snapshot.",
                                             "format" : "pve-configid",
                                             "maxLength" : 40,
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "vmstate" : {
                                             "description" : "Save the vmstate",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Snapshot"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "description" : "the task ID.",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 0,
                              "path" : "/nodes/{node}/qemu/{vmid}/snapshot",
                              "text" : "snapshot"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Create a Template.",
                                    "method" : "POST",
                                    "name" : "template",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "disk" : {
                                             "description" : "If you want to convert only 1 disk to base image.",
                                             "enum" : [
                                                "ide0",
                                                "ide1",
                                                "ide2",
                                                "ide3",
                                                "scsi0",
                                                "scsi1",
                                                "scsi2",
                                                "scsi3",
                                                "scsi4",
                                                "scsi5",
                                                "scsi6",
                                                "scsi7",
                                                "scsi8",
                                                "scsi9",
                                                "scsi10",
                                                "scsi11",
                                                "scsi12",
                                                "scsi13",
                                                "virtio0",
                                                "virtio1",
                                                "virtio2",
                                                "virtio3",
                                                "virtio4",
                                                "virtio5",
                                                "virtio6",
                                                "virtio7",
                                                "virtio8",
                                                "virtio9",
                                                "virtio10",
                                                "virtio11",
                                                "virtio12",
                                                "virtio13",
                                                "virtio14",
                                                "virtio15",
                                                "sata0",
                                                "sata1",
                                                "sata2",
                                                "sata3",
                                                "sata4",
                                                "sata5"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Allocate"
                                          ]
                                       ],
                                       "description" : "You need 'VM.Allocate' permissions on /vms/{vmid}"
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/qemu/{vmid}/template",
                              "text" : "template"
                           }
                        ],
                        "info" : {
                           "DELETE" : {
                              "description" : "Destroy the vm (also delete all used/owned volumes).",
                              "method" : "DELETE",
                              "name" : "destroy_vm",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "skiplock" : {
                                       "description" : "Ignore locks - only root is allowed to use this option.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "vmid" : {
                                       "description" : "The (unique) ID of the VM.",
                                       "format" : "pve-vmid",
                                       "minimum" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (1- N)"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/vms/{vmid}",
                                    [
                                       "VM.Allocate"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "string"
                              }
                           },
                           "GET" : {
                              "description" : "Directory index",
                              "method" : "GET",
                              "name" : "vmdiridx",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "vmid" : {
                                       "description" : "The (unique) ID of the VM.",
                                       "format" : "pve-vmid",
                                       "minimum" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (1- N)"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "user" : "all"
                              },
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "subdir" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "links" : [
                                    {
                                       "href" : "{subdir}",
                                       "rel" : "child"
                                    }
                                 ],
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 0,
                        "path" : "/nodes/{node}/qemu/{vmid}",
                        "text" : "{vmid}"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "Virtual machine index (per node).",
                        "method" : "GET",
                        "name" : "vmlist",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "full" : {
                                 "description" : "Determine the full status of active VMs.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "description" : "Only list VMs where you have VM.Audit permissons on /vms/<vmid>.",
                           "user" : "all"
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "items" : {
                              "properties" : {},
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{vmid}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     },
                     "POST" : {
                        "description" : "Create or restore a virtual machine.",
                        "method" : "POST",
                        "name" : "create_vm",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "acpi" : {
                                 "default" : 1,
                                 "description" : "Enable/disable ACPI.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "agent" : {
                                 "default" : 0,
                                 "description" : "Enable/disable Qemu GuestAgent.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "archive" : {
                                 "description" : "The backup file.",
                                 "maxLength" : 255,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "args" : {
                                 "description" : "Arbitrary arguments passed to kvm.",
                                 "optional" : 1,
                                 "type" : "string",
                                 "verbose_description" : "Arbitrary arguments passed to kvm, for example:\n\nargs: -no-reboot -no-hpet\n\nNOTE: this option is for experts only.\n"
                              },
                              "autostart" : {
                                 "default" : 0,
                                 "description" : "Automatic restart after crash (currently ignored).",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "balloon" : {
                                 "description" : "Amount of target RAM for the VM in MB. Using zero disables the ballon driver.",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "bios" : {
                                 "default" : "seabios",
                                 "description" : "Select BIOS implementation.",
                                 "enum" : [
                                    "seabios",
                                    "ovmf"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "boot" : {
                                 "default" : "cdn",
                                 "description" : "Boot on floppy (a), hard disk (c), CD-ROM (d), or network (n).",
                                 "optional" : 1,
                                 "pattern" : "[acdn]{1,4}",
                                 "type" : "string"
                              },
                              "bootdisk" : {
                                 "description" : "Enable booting from specified disk.",
                                 "format" : "pve-qm-bootdisk",
                                 "optional" : 1,
                                 "pattern" : "(ide|sata|scsi|virtio)\\d+",
                                 "type" : "string"
                              },
                              "cdrom" : {
                                 "description" : "This is an alias for option -ide2",
                                 "format" : "pve-qm-drive",
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "volume"
                              },
                              "cores" : {
                                 "default" : 1,
                                 "description" : "The number of cores per socket.",
                                 "minimum" : 1,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (1- N)"
                              },
                              "cpu" : {
                                 "description" : "Emulated CPU type.",
                                 "format" : {
                                    "cputype" : {
                                       "default" : "kvm64",
                                       "default_key" : 1,
                                       "description" : "Emulated CPU type.",
                                       "enum" : [
                                          "486",
                                          "athlon",
                                          "Broadwell",
                                          "Broadwell-noTSX",
                                          "Conroe",
                                          "core2duo",
                                          "coreduo",
                                          "Haswell",
                                          "Haswell-noTSX",
                                          "host",
                                          "IvyBridge",
                                          "kvm32",
                                          "kvm64",
                                          "Nehalem",
                                          "Opteron_G1",
                                          "Opteron_G2",
                                          "Opteron_G3",
                                          "Opteron_G4",
                                          "Opteron_G5",
                                          "Penryn",
                                          "pentium",
                                          "pentium2",
                                          "pentium3",
                                          "phenom",
                                          "qemu32",
                                          "qemu64",
                                          "SandyBridge",
                                          "Westmere"
                                       ],
                                       "format_description" : "cputype",
                                       "type" : "string"
                                    },
                                    "hidden" : {
                                       "default" : 0,
                                       "description" : "Do not identify as a KVM virtual machine.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    }
                                 },
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "[cputype=]<cputype> [,hidden=<1|0>]"
                              },
                              "cpulimit" : {
                                 "default" : 0,
                                 "description" : "Limit of CPU usage.",
                                 "maximum" : 128,
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "number",
                                 "typetext" : "number (0-128)",
                                 "verbose_description" : "Limit of CPU usage.\n\nNOTE: If the computer has 2 CPUs, it has total of '2' CPU time. Value '0' indicates no CPU limit."
                              },
                              "cpuunits" : {
                                 "default" : 1000,
                                 "description" : "CPU weight for a VM.",
                                 "maximum" : 500000,
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0-500000)",
                                 "verbose_description" : "CPU weight for a VM. Argument is used in the kernel fair scheduler. The larger the number is, the more CPU time this VM gets. Number is relative to weights of all the other running VMs.\n\nNOTE: You can disable fair-scheduler configuration by setting this to 0."
                              },
                              "description" : {
                                 "description" : "Description for the VM. Only used on the configuration web interface. This is saved as comment inside the configuration file.",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "force" : {
                                 "description" : "Allow to overwrite existing VM.",
                                 "optional" : 1,
                                 "requires" : "archive",
                                 "type" : "boolean"
                              },
                              "freeze" : {
                                 "description" : "Freeze CPU at startup (use 'c' monitor command to start execution).",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "hostpci[n]" : {
                                 "description" : "Map host PCI devices into guest.",
                                 "format" : "pve-qm-hostpci",
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "[host=]<HOSTPCIID[;HOSTPCIID2...]> [,pcie=<1|0>] [,rombar=<1|0>] [,x-vga=<1|0>]",
                                 "verbose_description" : "Map host PCI devices into guest.\n\nNOTE: This option allows direct access to host hardware. So it is no longer \npossible to migrate such machines - use with special care.\n\nCAUTION: Experimental! User reported problems with this option.\n"
                              },
                              "hotplug" : {
                                 "default" : "network,disk,usb",
                                 "description" : "Selectively enable hotplug features. This is a comma separated list of hotplug features: 'network', 'disk', 'cpu', 'memory' and 'usb'. Use '0' to disable hotplug completely. Value '1' is an alias for the default 'network,disk,usb'.",
                                 "format" : "pve-hotplug-features",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "hugepages" : {
                                 "description" : "Enable/disable hugepages memory.",
                                 "enum" : [
                                    "any",
                                    "2",
                                    "1024"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "ide[n]" : {
                                 "description" : "Use volume as IDE hard disk or CD-ROM (n is 0 to 3).",
                                 "format" : {
                                    "aio" : {
                                       "description" : "AIO type to use.",
                                       "enum" : [
                                          "native",
                                          "threads"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "backup" : {
                                       "description" : "Whether the drive should be included when making backups.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "bps" : {
                                       "description" : "Maximum r/w speed speed in bytes per second.",
                                       "format_description" : "bps",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "bps_rd" : {
                                       "description" : "Maximum read speed speed in bytes per second.",
                                       "format_description" : "bps",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "bps_wr" : {
                                       "description" : "Maximum write speed speed in bytes per second.",
                                       "format_description" : "bps",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "cache" : {
                                       "description" : "The drive's cache mode",
                                       "enum" : [
                                          "none",
                                          "writethrough",
                                          "writeback",
                                          "unsafe",
                                          "directsync"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "cyls" : {
                                       "description" : "Force the drive's physical geometry to have a specific cylinder count.",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "detect_zeroes" : {
                                       "description" : "Controls whether to detect and try to optimize writes of zeroes.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "discard" : {
                                       "description" : "Controls whether to pass discard/trim requests to the underlying storage.",
                                       "enum" : [
                                          "ignore",
                                          "on"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "file" : {
                                       "default_key" : 1,
                                       "description" : "The drive's backing volume.",
                                       "format" : "pve-volume-id-or-qm-path",
                                       "format_description" : "volume",
                                       "type" : "string"
                                    },
                                    "format" : {
                                       "description" : "The drive's backing file's data format.",
                                       "enum" : [
                                          "raw",
                                          "cow",
                                          "qcow",
                                          "qed",
                                          "qcow2",
                                          "vmdk",
                                          "cloop"
                                       ],
                                       "format_description" : "image format",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "heads" : {
                                       "description" : "Force the drive's physical geometry to have a specific head count.",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops" : {
                                       "description" : "Maximum r/w I/O speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_max" : {
                                       "description" : "Maximum unthrottled r/w I/O pool speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_rd" : {
                                       "description" : "Maximum read I/O speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_rd_max" : {
                                       "description" : "Maximum unthrottled read I/O pool speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_wr" : {
                                       "description" : "Maximum write I/O speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_wr_max" : {
                                       "description" : "Maximum unthrottled write I/O pool speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "mbps" : {
                                       "description" : "Maximum r/w speed speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_max" : {
                                       "description" : "Maximum unthrottled r/w pool speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_rd" : {
                                       "description" : "Maximum read speed speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_rd_max" : {
                                       "description" : "Maximum unthrottled read pool speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_wr" : {
                                       "description" : "Maximum write speed speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_wr_max" : {
                                       "description" : "Maximum unthrottled write pool speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "media" : {
                                       "default" : "disk",
                                       "description" : "The drive's media type.",
                                       "enum" : [
                                          "cdrom",
                                          "disk"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "model" : {
                                       "description" : "The drive's reported model name, url-encoded, up to 40 bytes long.",
                                       "format" : "urlencoded",
                                       "format_description" : "model",
                                       "maxLength" : 120,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "rerror" : {
                                       "description" : "Read error action.",
                                       "enum" : [
                                          "ignore",
                                          "report",
                                          "stop"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "secs" : {
                                       "description" : "Force the drive's physical geometry to have a specific sector count.",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "serial" : {
                                       "description" : "The drive's reported serial number, url-encoded, up to 20 bytes long.",
                                       "format" : "urlencoded",
                                       "format_description" : "serial",
                                       "maxLength" : 60,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "size" : {
                                       "description" : "Disk size. This is purely informational and has no effect.",
                                       "format" : "disk-size",
                                       "format_description" : "DiskSize",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "snapshot" : {
                                       "description" : "Whether the drive should be included when making snapshots.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "trans" : {
                                       "description" : "Force disk geometry bios translation mode.",
                                       "enum" : [
                                          "none",
                                          "lba",
                                          "auto"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "volume" : {
                                       "alias" : "file"
                                    },
                                    "werror" : {
                                       "description" : "Write error action.",
                                       "enum" : [
                                          "enospc",
                                          "ignore",
                                          "report",
                                          "stop"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    }
                                 },
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "[file=]<volume> [,aio=<native|threads>] [,backup=<1|0>] [,bps=<bps>] [,bps_rd=<bps>] [,bps_wr=<bps>] [,cache=<none|writethrough|writeback|unsafe|directsync>] [,cyls=<integer>] [,detect_zeroes=<1|0>] [,discard=<ignore|on>] [,format=<image format>] [,heads=<integer>] [,iops=<iops>] [,iops_max=<iops>] [,iops_rd=<iops>] [,iops_rd_max=<iops>] [,iops_wr=<iops>] [,iops_wr_max=<iops>] [,mbps=<mbps>] [,mbps_max=<mbps>] [,mbps_rd=<mbps>] [,mbps_rd_max=<mbps>] [,mbps_wr=<mbps>] [,mbps_wr_max=<mbps>] [,media=<cdrom|disk>] [,model=<model>] [,rerror=<ignore|report|stop>] [,secs=<integer>] [,serial=<serial>] [,size=<DiskSize>] [,snapshot=<1|0>] [,trans=<none|lba|auto>] [,werror=<enospc|ignore|report|stop>]"
                              },
                              "keyboard" : {
                                 "default" : "en-us",
                                 "description" : "Keybord layout for vnc server. Default is read from the '/etc/pve/datacenter.conf' configuration file.",
                                 "enum" : [
                                    "de",
                                    "de-ch",
                                    "da",
                                    "en-gb",
                                    "en-us",
                                    "es",
                                    "fi",
                                    "fr",
                                    "fr-be",
                                    "fr-ca",
                                    "fr-ch",
                                    "hu",
                                    "is",
                                    "it",
                                    "ja",
                                    "lt",
                                    "mk",
                                    "nl",
                                    "no",
                                    "pl",
                                    "pt",
                                    "pt-br",
                                    "sv",
                                    "sl",
                                    "tr"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "kvm" : {
                                 "default" : 1,
                                 "description" : "Enable/disable KVM hardware virtualization.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "localtime" : {
                                 "description" : "Set the real time clock to local time. This is enabled by default if ostype indicates a Microsoft OS.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "lock" : {
                                 "description" : "Lock/unlock the VM.",
                                 "enum" : [
                                    "migrate",
                                    "backup",
                                    "snapshot",
                                    "rollback"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "machine" : {
                                 "description" : "Specific the Qemu machine type.",
                                 "maxLength" : 40,
                                 "optional" : 1,
                                 "pattern" : "(pc|pc(-i440fx)?-\\d+\\.\\d+(\\.pxe)?|q35|pc-q35-\\d+\\.\\d+(\\.pxe)?)",
                                 "type" : "string"
                              },
                              "memory" : {
                                 "default" : 512,
                                 "description" : "Amount of RAM for the VM in MB. This is the maximum available memory when you use the balloon device.",
                                 "minimum" : 16,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (16- N)"
                              },
                              "migrate_downtime" : {
                                 "default" : 0.1,
                                 "description" : "Set maximum tolerated downtime (in seconds) for migrations.",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "number",
                                 "typetext" : "number (0- N)"
                              },
                              "migrate_speed" : {
                                 "default" : 0,
                                 "description" : "Set maximum speed (in MB/s) for migrations. Value 0 is no limit.",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "name" : {
                                 "description" : "Set a name for the VM. Only used on the configuration web interface.",
                                 "format" : "dns-name",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "net[n]" : {
                                 "description" : "Specify network devices.",
                                 "format" : {
                                    "bridge" : {
                                       "description" : "Bridge to attach the network device to. The Proxmox VE standard bridge\nis called 'vmbr0'.\n\nIf you do not specify a bridge, we create a kvm user (NATed) network\ndevice, which provides DHCP and DNS services. The following addresses\nare used:\n\n 10.0.2.2   Gateway\n 10.0.2.3   DNS Server\n 10.0.2.4   SMB Server\n\nThe DHCP server assign addresses to the guest starting from 10.0.2.15.\n",
                                       "format_description" : "bridge",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "e1000" : {
                                       "alias" : "macaddr",
                                       "keyAlias" : "model"
                                    },
                                    "e1000-82540em" : {
                                       "alias" : "macaddr",
                                       "keyAlias" : "model"
                                    },
                                    "e1000-82544gc" : {
                                       "alias" : "macaddr",
                                       "keyAlias" : "model"
                                    },
                                    "e1000-82545em" : {
                                       "alias" : "macaddr",
                                       "keyAlias" : "model"
                                    },
                                    "firewall" : {
                                       "description" : "Whether this interface should be protected by the firewall.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "i82551" : {
                                       "alias" : "macaddr",
                                       "keyAlias" : "model"
                                    },
                                    "i82557b" : {
                                       "alias" : "macaddr",
                                       "keyAlias" : "model"
                                    },
                                    "i82559er" : {
                                       "alias" : "macaddr",
                                       "keyAlias" : "model"
                                    },
                                    "link_down" : {
                                       "description" : "Whether this interface should be disconnected (like pulling the plug).",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "macaddr" : {
                                       "description" : "MAC address. That address must be unique withing your network. This is automatically generated if not specified.",
                                       "format_description" : "XX:XX:XX:XX:XX:XX",
                                       "optional" : 1,
                                       "pattern" : "(?^i:[0-9a-f]{2}(?::[0-9a-f]{2}){5})",
                                       "type" : "string"
                                    },
                                    "model" : {
                                       "default_key" : 1,
                                       "description" : "Network Card Model. The 'virtio' model provides the best performance with very low CPU overhead. If your guest does not support this driver, it is usually best to use 'e1000'.",
                                       "enum" : [
                                          "rtl8139",
                                          "ne2k_pci",
                                          "e1000",
                                          "pcnet",
                                          "virtio",
                                          "ne2k_isa",
                                          "i82551",
                                          "i82557b",
                                          "i82559er",
                                          "vmxnet3",
                                          "e1000-82540em",
                                          "e1000-82544gc",
                                          "e1000-82545em"
                                       ],
                                       "format_description" : "model",
                                       "type" : "string"
                                    },
                                    "ne2k_isa" : {
                                       "alias" : "macaddr",
                                       "keyAlias" : "model"
                                    },
                                    "ne2k_pci" : {
                                       "alias" : "macaddr",
                                       "keyAlias" : "model"
                                    },
                                    "pcnet" : {
                                       "alias" : "macaddr",
                                       "keyAlias" : "model"
                                    },
                                    "queues" : {
                                       "description" : "Number of packet queues to be used on the device.",
                                       "maximum" : 16,
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "rate" : {
                                       "description" : "Rate limit in mbps (megabytes per second) as floating point number.",
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "rtl8139" : {
                                       "alias" : "macaddr",
                                       "keyAlias" : "model"
                                    },
                                    "tag" : {
                                       "description" : "VLAN tag to apply to packets on this interface.",
                                       "maximum" : 4094,
                                       "minimum" : 1,
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "trunks" : {
                                       "description" : "VLAN trunks to pass through this interface.",
                                       "format_description" : "vlanid[;vlanid...]",
                                       "optional" : 1,
                                       "pattern" : "(?^:\\d+(?:-\\d+)?(?:;\\d+(?:-\\d+)?)*)",
                                       "type" : "string"
                                    },
                                    "virtio" : {
                                       "alias" : "macaddr",
                                       "keyAlias" : "model"
                                    },
                                    "vmxnet3" : {
                                       "alias" : "macaddr",
                                       "keyAlias" : "model"
                                    }
                                 },
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "[model=]<model> [,bridge=<bridge>] [,firewall=<1|0>] [,link_down=<1|0>] [,macaddr=<XX:XX:XX:XX:XX:XX>] [,queues=<integer>] [,rate=<number>] [,tag=<integer>] [,trunks=<vlanid[;vlanid...]>] [,<model>=<macaddr>]"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "numa" : {
                                 "default" : 0,
                                 "description" : "Enable/disable NUMA.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "numa[n]" : {
                                 "description" : "NUMA topology.",
                                 "format" : {
                                    "cpus" : {
                                       "description" : "CPUs accessing this NUMA node.",
                                       "format_description" : "id[-id];...",
                                       "pattern" : "(?^:\\d+(?:-\\d+)?(?:;\\d+(?:-\\d+)?)*)",
                                       "type" : "string"
                                    },
                                    "hostnodes" : {
                                       "description" : "Host NUMA nodes to use.",
                                       "format_description" : "id[-id];...",
                                       "optional" : 1,
                                       "pattern" : "(?^:\\d+(?:-\\d+)?(?:;\\d+(?:-\\d+)?)*)",
                                       "type" : "string"
                                    },
                                    "memory" : {
                                       "description" : "Amount of memory this NUMA node provides.",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "policy" : {
                                       "description" : "NUMA allocation policy.",
                                       "enum" : [
                                          "preferred",
                                          "bind",
                                          "interleave"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    }
                                 },
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "cpus=<id[-id];...> [,hostnodes=<id[-id];...>] [,memory=<number>] [,policy=<preferred|bind|interleave>]"
                              },
                              "onboot" : {
                                 "default" : 0,
                                 "description" : "Specifies whether a VM will be started during system bootup.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "ostype" : {
                                 "description" : "Specify guest operating system.",
                                 "enum" : [
                                    "other",
                                    "wxp",
                                    "w2k",
                                    "w2k3",
                                    "w2k8",
                                    "wvista",
                                    "win7",
                                    "win8",
                                    "l24",
                                    "l26",
                                    "solaris"
                                 ],
                                 "optional" : 1,
                                 "type" : "string",
                                 "verbose_description" : "Specify guest operating system. This is used to enable special\noptimization/features for specific operating systems:\n\n[horizontal]\nother;; unspecified OS\nwxp;; Microsoft Windows XP\nw2k;; Microsoft Windows 2000\nw2k3;; Microsoft Windows 2003\nw2k8;; Microsoft Windows 2008\nwvista;; Microsoft Windows Vista\nwin7;; Microsoft Windows 7\nwin8;; Microsoft Windows 8/2012\nl24;; Linux 2.4 Kernel\nl26;; Linux 2.6/3.X Kernel\nsolaris;; Solaris/OpenSolaris/OpenIndiania kernel\n"
                              },
                              "parallel[n]" : {
                                 "description" : "Map host parallel devices (n is 0 to 2).",
                                 "optional" : 1,
                                 "pattern" : "/dev/parport\\d+|/dev/usb/lp\\d+",
                                 "type" : "string",
                                 "verbose_description" : "Map host parallel devices (n is 0 to 2).\n\nNOTE: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nCAUTION: Experimental! User reported problems with this option.\n"
                              },
                              "pool" : {
                                 "description" : "Add the VM to the specified pool.",
                                 "format" : "pve-poolid",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "protection" : {
                                 "default" : 0,
                                 "description" : "Sets the protection flag of the VM. This will disable the remove VM and remove disk operations.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "reboot" : {
                                 "default" : 1,
                                 "description" : "Allow reboot. If set to '0' the VM exit on reboot.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "sata[n]" : {
                                 "description" : "Use volume as SATA hard disk or CD-ROM (n is 0 to 5).",
                                 "format" : {
                                    "aio" : {
                                       "description" : "AIO type to use.",
                                       "enum" : [
                                          "native",
                                          "threads"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "backup" : {
                                       "description" : "Whether the drive should be included when making backups.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "bps" : {
                                       "description" : "Maximum r/w speed speed in bytes per second.",
                                       "format_description" : "bps",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "bps_rd" : {
                                       "description" : "Maximum read speed speed in bytes per second.",
                                       "format_description" : "bps",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "bps_wr" : {
                                       "description" : "Maximum write speed speed in bytes per second.",
                                       "format_description" : "bps",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "cache" : {
                                       "description" : "The drive's cache mode",
                                       "enum" : [
                                          "none",
                                          "writethrough",
                                          "writeback",
                                          "unsafe",
                                          "directsync"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "cyls" : {
                                       "description" : "Force the drive's physical geometry to have a specific cylinder count.",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "detect_zeroes" : {
                                       "description" : "Controls whether to detect and try to optimize writes of zeroes.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "discard" : {
                                       "description" : "Controls whether to pass discard/trim requests to the underlying storage.",
                                       "enum" : [
                                          "ignore",
                                          "on"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "file" : {
                                       "default_key" : 1,
                                       "description" : "The drive's backing volume.",
                                       "format" : "pve-volume-id-or-qm-path",
                                       "format_description" : "volume",
                                       "type" : "string"
                                    },
                                    "format" : {
                                       "description" : "The drive's backing file's data format.",
                                       "enum" : [
                                          "raw",
                                          "cow",
                                          "qcow",
                                          "qed",
                                          "qcow2",
                                          "vmdk",
                                          "cloop"
                                       ],
                                       "format_description" : "image format",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "heads" : {
                                       "description" : "Force the drive's physical geometry to have a specific head count.",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops" : {
                                       "description" : "Maximum r/w I/O speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_max" : {
                                       "description" : "Maximum unthrottled r/w I/O pool speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_rd" : {
                                       "description" : "Maximum read I/O speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_rd_max" : {
                                       "description" : "Maximum unthrottled read I/O pool speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_wr" : {
                                       "description" : "Maximum write I/O speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_wr_max" : {
                                       "description" : "Maximum unthrottled write I/O pool speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "mbps" : {
                                       "description" : "Maximum r/w speed speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_max" : {
                                       "description" : "Maximum unthrottled r/w pool speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_rd" : {
                                       "description" : "Maximum read speed speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_rd_max" : {
                                       "description" : "Maximum unthrottled read pool speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_wr" : {
                                       "description" : "Maximum write speed speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_wr_max" : {
                                       "description" : "Maximum unthrottled write pool speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "media" : {
                                       "default" : "disk",
                                       "description" : "The drive's media type.",
                                       "enum" : [
                                          "cdrom",
                                          "disk"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "rerror" : {
                                       "description" : "Read error action.",
                                       "enum" : [
                                          "ignore",
                                          "report",
                                          "stop"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "secs" : {
                                       "description" : "Force the drive's physical geometry to have a specific sector count.",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "serial" : {
                                       "description" : "The drive's reported serial number, url-encoded, up to 20 bytes long.",
                                       "format" : "urlencoded",
                                       "format_description" : "serial",
                                       "maxLength" : 60,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "size" : {
                                       "description" : "Disk size. This is purely informational and has no effect.",
                                       "format" : "disk-size",
                                       "format_description" : "DiskSize",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "snapshot" : {
                                       "description" : "Whether the drive should be included when making snapshots.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "trans" : {
                                       "description" : "Force disk geometry bios translation mode.",
                                       "enum" : [
                                          "none",
                                          "lba",
                                          "auto"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "volume" : {
                                       "alias" : "file"
                                    },
                                    "werror" : {
                                       "description" : "Write error action.",
                                       "enum" : [
                                          "enospc",
                                          "ignore",
                                          "report",
                                          "stop"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    }
                                 },
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "[file=]<volume> [,aio=<native|threads>] [,backup=<1|0>] [,bps=<bps>] [,bps_rd=<bps>] [,bps_wr=<bps>] [,cache=<none|writethrough|writeback|unsafe|directsync>] [,cyls=<integer>] [,detect_zeroes=<1|0>] [,discard=<ignore|on>] [,format=<image format>] [,heads=<integer>] [,iops=<iops>] [,iops_max=<iops>] [,iops_rd=<iops>] [,iops_rd_max=<iops>] [,iops_wr=<iops>] [,iops_wr_max=<iops>] [,mbps=<mbps>] [,mbps_max=<mbps>] [,mbps_rd=<mbps>] [,mbps_rd_max=<mbps>] [,mbps_wr=<mbps>] [,mbps_wr_max=<mbps>] [,media=<cdrom|disk>] [,rerror=<ignore|report|stop>] [,secs=<integer>] [,serial=<serial>] [,size=<DiskSize>] [,snapshot=<1|0>] [,trans=<none|lba|auto>] [,werror=<enospc|ignore|report|stop>]"
                              },
                              "scsi[n]" : {
                                 "description" : "Use volume as SCSI hard disk or CD-ROM (n is 0 to 13).",
                                 "format" : {
                                    "aio" : {
                                       "description" : "AIO type to use.",
                                       "enum" : [
                                          "native",
                                          "threads"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "backup" : {
                                       "description" : "Whether the drive should be included when making backups.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "bps" : {
                                       "description" : "Maximum r/w speed speed in bytes per second.",
                                       "format_description" : "bps",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "bps_rd" : {
                                       "description" : "Maximum read speed speed in bytes per second.",
                                       "format_description" : "bps",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "bps_wr" : {
                                       "description" : "Maximum write speed speed in bytes per second.",
                                       "format_description" : "bps",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "cache" : {
                                       "description" : "The drive's cache mode",
                                       "enum" : [
                                          "none",
                                          "writethrough",
                                          "writeback",
                                          "unsafe",
                                          "directsync"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "cyls" : {
                                       "description" : "Force the drive's physical geometry to have a specific cylinder count.",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "detect_zeroes" : {
                                       "description" : "Controls whether to detect and try to optimize writes of zeroes.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "discard" : {
                                       "description" : "Controls whether to pass discard/trim requests to the underlying storage.",
                                       "enum" : [
                                          "ignore",
                                          "on"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "file" : {
                                       "default_key" : 1,
                                       "description" : "The drive's backing volume.",
                                       "format" : "pve-volume-id-or-qm-path",
                                       "format_description" : "volume",
                                       "type" : "string"
                                    },
                                    "format" : {
                                       "description" : "The drive's backing file's data format.",
                                       "enum" : [
                                          "raw",
                                          "cow",
                                          "qcow",
                                          "qed",
                                          "qcow2",
                                          "vmdk",
                                          "cloop"
                                       ],
                                       "format_description" : "image format",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "heads" : {
                                       "description" : "Force the drive's physical geometry to have a specific head count.",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops" : {
                                       "description" : "Maximum r/w I/O speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_max" : {
                                       "description" : "Maximum unthrottled r/w I/O pool speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_rd" : {
                                       "description" : "Maximum read I/O speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_rd_max" : {
                                       "description" : "Maximum unthrottled read I/O pool speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_wr" : {
                                       "description" : "Maximum write I/O speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_wr_max" : {
                                       "description" : "Maximum unthrottled write I/O pool speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iothread" : {
                                       "description" : "Whether to use iothreads for this drive",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "mbps" : {
                                       "description" : "Maximum r/w speed speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_max" : {
                                       "description" : "Maximum unthrottled r/w pool speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_rd" : {
                                       "description" : "Maximum read speed speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_rd_max" : {
                                       "description" : "Maximum unthrottled read pool speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_wr" : {
                                       "description" : "Maximum write speed speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_wr_max" : {
                                       "description" : "Maximum unthrottled write pool speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "media" : {
                                       "default" : "disk",
                                       "description" : "The drive's media type.",
                                       "enum" : [
                                          "cdrom",
                                          "disk"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "queues" : {
                                       "description" : "Number of queues.",
                                       "minimum" : 2,
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "secs" : {
                                       "description" : "Force the drive's physical geometry to have a specific sector count.",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "serial" : {
                                       "description" : "The drive's reported serial number, url-encoded, up to 20 bytes long.",
                                       "format" : "urlencoded",
                                       "format_description" : "serial",
                                       "maxLength" : 60,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "size" : {
                                       "description" : "Disk size. This is purely informational and has no effect.",
                                       "format" : "disk-size",
                                       "format_description" : "DiskSize",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "snapshot" : {
                                       "description" : "Whether the drive should be included when making snapshots.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "trans" : {
                                       "description" : "Force disk geometry bios translation mode.",
                                       "enum" : [
                                          "none",
                                          "lba",
                                          "auto"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "volume" : {
                                       "alias" : "file"
                                    },
                                    "werror" : {
                                       "description" : "Write error action.",
                                       "enum" : [
                                          "enospc",
                                          "ignore",
                                          "report",
                                          "stop"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    }
                                 },
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "[file=]<volume> [,aio=<native|threads>] [,backup=<1|0>] [,bps=<bps>] [,bps_rd=<bps>] [,bps_wr=<bps>] [,cache=<none|writethrough|writeback|unsafe|directsync>] [,cyls=<integer>] [,detect_zeroes=<1|0>] [,discard=<ignore|on>] [,format=<image format>] [,heads=<integer>] [,iops=<iops>] [,iops_max=<iops>] [,iops_rd=<iops>] [,iops_rd_max=<iops>] [,iops_wr=<iops>] [,iops_wr_max=<iops>] [,iothread=<1|0>] [,mbps=<mbps>] [,mbps_max=<mbps>] [,mbps_rd=<mbps>] [,mbps_rd_max=<mbps>] [,mbps_wr=<mbps>] [,mbps_wr_max=<mbps>] [,media=<cdrom|disk>] [,queues=<integer>] [,secs=<integer>] [,serial=<serial>] [,size=<DiskSize>] [,snapshot=<1|0>] [,trans=<none|lba|auto>] [,werror=<enospc|ignore|report|stop>]"
                              },
                              "scsihw" : {
                                 "default" : "lsi",
                                 "description" : "SCSI controller model",
                                 "enum" : [
                                    "lsi",
                                    "lsi53c810",
                                    "virtio-scsi-pci",
                                    "virtio-scsi-single",
                                    "megasas",
                                    "pvscsi"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "serial[n]" : {
                                 "description" : "Create a serial device inside the VM (n is 0 to 3)",
                                 "optional" : 1,
                                 "pattern" : "(/dev/.+|socket)",
                                 "type" : "string",
                                 "verbose_description" : "Create a serial device inside the VM (n is 0 to 3), and pass through a\nhost serial device (i.e. /dev/ttyS0), or create a unix socket on the\nhost side (use 'qm terminal' to open a terminal connection).\n\nNOTE: If you pass through a host serial device, it is no longer possible to migrate such machines - use with special care.\n\nCAUTION: Experimental! User reported problems with this option.\n"
                              },
                              "shares" : {
                                 "default" : 1000,
                                 "description" : "Amount of memory shares for auto-ballooning. The larger the number is, the more memory this VM gets. Number is relative to weights of all other running VMs. Using zero disables auto-ballooning",
                                 "maximum" : 50000,
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0-50000)"
                              },
                              "smbios1" : {
                                 "description" : "Specify SMBIOS type 1 fields.",
                                 "format" : "pve-qm-smbios1",
                                 "maxLength" : 256,
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "[family=<string>] [,manufacturer=<string>] [,product=<string>] [,serial=<string>] [,sku=<string>] [,uuid=<UUID>] [,version=<string>]"
                              },
                              "smp" : {
                                 "default" : 1,
                                 "description" : "The number of CPUs. Please use option -sockets instead.",
                                 "minimum" : 1,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (1- N)"
                              },
                              "sockets" : {
                                 "default" : 1,
                                 "description" : "The number of CPU sockets.",
                                 "minimum" : 1,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (1- N)"
                              },
                              "startdate" : {
                                 "default" : "now",
                                 "description" : "Set the initial date of the real time clock. Valid format for date are: 'now' or '2006-06-17T16:01:21' or '2006-06-17'.",
                                 "optional" : 1,
                                 "pattern" : "(now|\\d{4}-\\d{1,2}-\\d{1,2}(T\\d{1,2}:\\d{1,2}:\\d{1,2})?)",
                                 "type" : "string",
                                 "typetext" : "(now | YYYY-MM-DD | YYYY-MM-DDTHH:MM:SS)"
                              },
                              "startup" : {
                                 "description" : "Startup and shutdown behavior. Order is a non-negative number defining the general startup order. Shutdown in done with reverse ordering. Additionally you can set the 'up' or 'down' delay in seconds, which specifies a delay to wait before the next VM is started or stopped.",
                                 "format" : "pve-startup-order",
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "[[order=]\\d+] [,up=\\d+] [,down=\\d+] "
                              },
                              "storage" : {
                                 "description" : "Default storage.",
                                 "format" : "pve-storage-id",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "tablet" : {
                                 "default" : 1,
                                 "description" : "Enable/disable the USB tablet device.",
                                 "optional" : 1,
                                 "type" : "boolean",
                                 "verbose_description" : "Enable/disable the USB tablet device. This device is usually needed to allow absolute mouse positioning with VNC. Else the mouse runs out of sync with normal VNC clients. If you're running lots of console-only guests on one host, you may consider disabling this to save some context switches. This is turned off by default if you use spice (-vga=qxl)."
                              },
                              "tdf" : {
                                 "default" : 0,
                                 "description" : "Enable/disable time drift fix.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "template" : {
                                 "default" : 0,
                                 "description" : "Enable/disable Template.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "unique" : {
                                 "description" : "Assign a unique random ethernet address.",
                                 "optional" : 1,
                                 "requires" : "archive",
                                 "type" : "boolean"
                              },
                              "unused[n]" : {
                                 "description" : "Reference to unused volumes. This is used internally, and should not be modified manually.",
                                 "format" : "pve-volume-id",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "usb[n]" : {
                                 "description" : "Configure an USB device (n is 0 to 4).",
                                 "format" : {
                                    "host" : {
                                       "default_key" : 1,
                                       "description" : "The Host USB device or port or the value 'spice'. HOSTUSBDEVICE syntax is:\n\n 'bus-port(.port)*' (decimal numbers) or\n 'vendor_id:product_id' (hexadeciaml numbers) or\n 'spice'\n\nYou can use the 'lsusb -t' command to list existing usb devices.\n\nNOTE: This option allows direct access to host hardware. So it is no longer possible to migrate such machines - use with special care.\n\nThe value 'spice' can be used to add a usb redirection devices for spice.\n",
                                       "format" : "pve-qm-usb-device",
                                       "format_description" : "HOSTUSBDEVICE|spice",
                                       "type" : "string"
                                    },
                                    "usb3" : {
                                       "default" : 0,
                                       "description" : "Specifies whether if given host option is a USB3 device or port (this does currently not work reliably with spice redirection and is then ignored).",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    }
                                 },
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "[host=]<HOSTUSBDEVICE|spice> [,usb3=<1|0>]"
                              },
                              "vcpus" : {
                                 "default" : 0,
                                 "description" : "Number of hotplugged vcpus.",
                                 "minimum" : 1,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (1- N)"
                              },
                              "vga" : {
                                 "description" : "Select the VGA type.",
                                 "enum" : [
                                    "std",
                                    "cirrus",
                                    "vmware",
                                    "qxl",
                                    "serial0",
                                    "serial1",
                                    "serial2",
                                    "serial3",
                                    "qxl2",
                                    "qxl3",
                                    "qxl4"
                                 ],
                                 "optional" : 1,
                                 "type" : "string",
                                 "verbose_description" : "Select the VGA type. If you want to use high resolution modes (>= 1280x1024x16) then you should use the options 'std' or 'vmware'. Default is 'std' for win8/win7/w2k8, and 'cirrus' for other OS types. The 'qxl' option enables the SPICE display sever. For win* OS you can select how many independent displays you want, Linux guests can add displays them self. You can also run without any graphic card, using a serial device as terminal."
                              },
                              "virtio[n]" : {
                                 "description" : "Use volume as VIRTIO hard disk (n is 0 to 15).",
                                 "format" : {
                                    "aio" : {
                                       "description" : "AIO type to use.",
                                       "enum" : [
                                          "native",
                                          "threads"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "backup" : {
                                       "description" : "Whether the drive should be included when making backups.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "bps" : {
                                       "description" : "Maximum r/w speed speed in bytes per second.",
                                       "format_description" : "bps",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "bps_rd" : {
                                       "description" : "Maximum read speed speed in bytes per second.",
                                       "format_description" : "bps",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "bps_wr" : {
                                       "description" : "Maximum write speed speed in bytes per second.",
                                       "format_description" : "bps",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "cache" : {
                                       "description" : "The drive's cache mode",
                                       "enum" : [
                                          "none",
                                          "writethrough",
                                          "writeback",
                                          "unsafe",
                                          "directsync"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "cyls" : {
                                       "description" : "Force the drive's physical geometry to have a specific cylinder count.",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "detect_zeroes" : {
                                       "description" : "Controls whether to detect and try to optimize writes of zeroes.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "discard" : {
                                       "description" : "Controls whether to pass discard/trim requests to the underlying storage.",
                                       "enum" : [
                                          "ignore",
                                          "on"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "file" : {
                                       "default_key" : 1,
                                       "description" : "The drive's backing volume.",
                                       "format" : "pve-volume-id-or-qm-path",
                                       "format_description" : "volume",
                                       "type" : "string"
                                    },
                                    "format" : {
                                       "description" : "The drive's backing file's data format.",
                                       "enum" : [
                                          "raw",
                                          "cow",
                                          "qcow",
                                          "qed",
                                          "qcow2",
                                          "vmdk",
                                          "cloop"
                                       ],
                                       "format_description" : "image format",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "heads" : {
                                       "description" : "Force the drive's physical geometry to have a specific head count.",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops" : {
                                       "description" : "Maximum r/w I/O speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_max" : {
                                       "description" : "Maximum unthrottled r/w I/O pool speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_rd" : {
                                       "description" : "Maximum read I/O speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_rd_max" : {
                                       "description" : "Maximum unthrottled read I/O pool speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_wr" : {
                                       "description" : "Maximum write I/O speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iops_wr_max" : {
                                       "description" : "Maximum unthrottled write I/O pool speed in operations per second.",
                                       "format_description" : "iops",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "iothread" : {
                                       "description" : "Whether to use iothreads for this drive",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "mbps" : {
                                       "description" : "Maximum r/w speed speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_max" : {
                                       "description" : "Maximum unthrottled r/w pool speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_rd" : {
                                       "description" : "Maximum read speed speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_rd_max" : {
                                       "description" : "Maximum unthrottled read pool speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_wr" : {
                                       "description" : "Maximum write speed speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "mbps_wr_max" : {
                                       "description" : "Maximum unthrottled write pool speed in megabytes per second.",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "media" : {
                                       "default" : "disk",
                                       "description" : "The drive's media type.",
                                       "enum" : [
                                          "cdrom",
                                          "disk"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "rerror" : {
                                       "description" : "Read error action.",
                                       "enum" : [
                                          "ignore",
                                          "report",
                                          "stop"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "secs" : {
                                       "description" : "Force the drive's physical geometry to have a specific sector count.",
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "serial" : {
                                       "description" : "The drive's reported serial number, url-encoded, up to 20 bytes long.",
                                       "format" : "urlencoded",
                                       "format_description" : "serial",
                                       "maxLength" : 60,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "size" : {
                                       "description" : "Disk size. This is purely informational and has no effect.",
                                       "format" : "disk-size",
                                       "format_description" : "DiskSize",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "snapshot" : {
                                       "description" : "Whether the drive should be included when making snapshots.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "trans" : {
                                       "description" : "Force disk geometry bios translation mode.",
                                       "enum" : [
                                          "none",
                                          "lba",
                                          "auto"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "volume" : {
                                       "alias" : "file"
                                    },
                                    "werror" : {
                                       "description" : "Write error action.",
                                       "enum" : [
                                          "enospc",
                                          "ignore",
                                          "report",
                                          "stop"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    }
                                 },
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "[file=]<volume> [,aio=<native|threads>] [,backup=<1|0>] [,bps=<bps>] [,bps_rd=<bps>] [,bps_wr=<bps>] [,cache=<none|writethrough|writeback|unsafe|directsync>] [,cyls=<integer>] [,detect_zeroes=<1|0>] [,discard=<ignore|on>] [,format=<image format>] [,heads=<integer>] [,iops=<iops>] [,iops_max=<iops>] [,iops_rd=<iops>] [,iops_rd_max=<iops>] [,iops_wr=<iops>] [,iops_wr_max=<iops>] [,iothread=<1|0>] [,mbps=<mbps>] [,mbps_max=<mbps>] [,mbps_rd=<mbps>] [,mbps_rd_max=<mbps>] [,mbps_wr=<mbps>] [,mbps_wr_max=<mbps>] [,media=<cdrom|disk>] [,rerror=<ignore|report|stop>] [,secs=<integer>] [,serial=<serial>] [,size=<DiskSize>] [,snapshot=<1|0>] [,trans=<none|lba|auto>] [,werror=<enospc|ignore|report|stop>]"
                              },
                              "vmid" : {
                                 "description" : "The (unique) ID of the VM.",
                                 "format" : "pve-vmid",
                                 "minimum" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (1- N)"
                              },
                              "watchdog" : {
                                 "description" : "Create a virtual hardware watchdog device.",
                                 "format" : "pve-qm-watchdog",
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "[[model=]<i6300esb|ib700>] [,action=<reset|shutdown|poweroff|pause|debug|none>]",
                                 "verbose_description" : "Create a virtual hardware watchdog device. Once enabled (by a guest action), the watchdog must be periodically polled by an agent inside the guest or else the watchdog will reset the guest (or execute the respective action specified)"
                              }
                           }
                        },
                        "permissions" : {
                           "description" : "You need 'VM.Allocate' permissions on /vms/{vmid} or on the VM pool /pool/{pool}. For restore (option 'archive'), it is enough if the user has 'VM.Backup' permission and the VM already exists. If you create disks you need 'Datastore.AllocateSpace' on any used storage.",
                           "user" : "all"
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "string"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/nodes/{node}/qemu",
                  "text" : "qemu"
               },
               {
                  "children" : [
                     {
                        "children" : [
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Get container configuration.",
                                    "method" : "GET",
                                    "name" : "vm_config",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "proxyto" : "node",
                                    "returns" : {
                                       "properties" : {
                                          "digest" : {
                                             "description" : "SHA1 digest of configuration file. This can be used to prevent concurrent modifications.",
                                             "type" : "string"
                                          }
                                       },
                                       "type" : "object"
                                    }
                                 },
                                 "PUT" : {
                                    "description" : "Set container options.",
                                    "method" : "PUT",
                                    "name" : "update_vm",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "arch" : {
                                             "default" : "amd64",
                                             "description" : "OS architecture type.",
                                             "enum" : [
                                                "amd64",
                                                "i386"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "cmode" : {
                                             "default" : "tty",
                                             "description" : "Console mode. By default, the console command tries to open a connection to one of the available tty devices. By setting cmode to 'console' it tries to attach to /dev/console instead. If you set cmode to 'shell', it simply invokes a shell inside the container (no login).",
                                             "enum" : [
                                                "shell",
                                                "console",
                                                "tty"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "console" : {
                                             "default" : 1,
                                             "description" : "Attach a console device (/dev/console) to the container.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "cpulimit" : {
                                             "default" : 0,
                                             "description" : "Limit of CPU usage.\n\nNOTE: If the computer has 2 CPUs, it has a total of '2' CPU time. Value '0' indicates no CPU limit.",
                                             "maximum" : 128,
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "number",
                                             "typetext" : "number (0-128)"
                                          },
                                          "cpuunits" : {
                                             "default" : 1024,
                                             "description" : "CPU weight for a VM. Argument is used in the kernel fair scheduler. The larger the number is, the more CPU time this VM gets. Number is relative to the weights of all the other running VMs.\n\nNOTE: You can disable fair-scheduler configuration by setting this to 0.",
                                             "maximum" : 500000,
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0-500000)"
                                          },
                                          "delete" : {
                                             "description" : "A list of settings you want to delete.",
                                             "format" : "pve-configid-list",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "description" : {
                                             "description" : "Container description. Only used on the configuration web interface.",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "digest" : {
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "hostname" : {
                                             "description" : "Set a host name for the container.",
                                             "format" : "dns-name",
                                             "maxLength" : 255,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "lock" : {
                                             "description" : "Lock/unlock the VM.",
                                             "enum" : [
                                                "migrate",
                                                "backup",
                                                "snapshot",
                                                "rollback"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "memory" : {
                                             "default" : 512,
                                             "description" : "Amount of RAM for the VM in MB.",
                                             "minimum" : 16,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (16- N)"
                                          },
                                          "mp[n]" : {
                                             "description" : "Use volume as container mount point.",
                                             "format" : {
                                                "acl" : {
                                                   "description" : "Explicitly enable or disable ACL support.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "backup" : {
                                                   "description" : "Whether to include the mountpoint in backups.",
                                                   "optional" : 1,
                                                   "type" : "boolean",
                                                   "verbose_description" : "Whether to include the mountpoint in backups (only used for volume mountpoints)."
                                                },
                                                "mp" : {
                                                   "description" : "Path to the mountpoint as seen from inside the container (must not contain symlinks).",
                                                   "format" : "pve-lxc-mp-string",
                                                   "format_description" : "Path",
                                                   "type" : "string",
                                                   "verbose_description" : "Path to the mountpoint as seen from inside the container.\n\nNOTE: Must not contain any symlinks for security reasons."
                                                },
                                                "quota" : {
                                                   "description" : "Enable user quotas inside the container (not supported with zfs subvolumes)",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "ro" : {
                                                   "description" : "Read-only mountpoint",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "size" : {
                                                   "description" : "Volume size (read only value).",
                                                   "format" : "disk-size",
                                                   "format_description" : "DiskSize",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "volume" : {
                                                   "default_key" : 1,
                                                   "description" : "Volume, device or directory to mount into the container.",
                                                   "format" : "pve-lxc-mp-string",
                                                   "format_description" : "volume",
                                                   "type" : "string"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[volume=]<volume> ,mp=<Path> [,acl=<1|0>] [,backup=<1|0>] [,quota=<1|0>] [,ro=<1|0>] [,size=<DiskSize>]"
                                          },
                                          "nameserver" : {
                                             "description" : "Sets DNS server IP address for a container. Create will automatically use the setting from the host if you neither set searchdomain nor nameserver.",
                                             "format" : "address-list",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "net[n]" : {
                                             "description" : "Specifies network interfaces for the container.",
                                             "format" : {
                                                "bridge" : {
                                                   "description" : "Bridge to attach the network device to.",
                                                   "format_description" : "bridge",
                                                   "optional" : 1,
                                                   "pattern" : "[-_.\\w\\d]+",
                                                   "type" : "string"
                                                },
                                                "firewall" : {
                                                   "description" : "Controls whether this interface's firewall rules should be used.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "gw" : {
                                                   "description" : "Default gateway for IPv4 traffic.",
                                                   "format" : "ipv4",
                                                   "format_description" : "GatewayIPv4",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "gw6" : {
                                                   "description" : "Default gateway for IPv6 traffic.",
                                                   "format" : "ipv6",
                                                   "format_description" : "GatewayIPv6",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "hwaddr" : {
                                                   "description" : "The interface MAC address. This is dynamically allocated by default, but you can set that statically if needed, for example to always have the same link-local IPv6 address. (lxc.network.hwaddr)",
                                                   "format_description" : "XX:XX:XX:XX:XX:XX",
                                                   "optional" : 1,
                                                   "pattern" : "(?^i:(?:[a-f0-9]{2}:){5}[a-f0-9]{2})",
                                                   "type" : "string"
                                                },
                                                "ip" : {
                                                   "description" : "IPv4 address in CIDR format.",
                                                   "format" : "pve-ipv4-config",
                                                   "format_description" : "IPv4Format/CIDR",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "ip6" : {
                                                   "description" : "IPv6 address in CIDR format.",
                                                   "format" : "pve-ipv6-config",
                                                   "format_description" : "IPv6Format/CIDR",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "mtu" : {
                                                   "description" : "Maximum transfer unit of the interface. (lxc.network.mtu)",
                                                   "minimum" : 64,
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "name" : {
                                                   "description" : "Name of the network device as seen from inside the container. (lxc.network.name)",
                                                   "format_description" : "string",
                                                   "pattern" : "[-_.\\w\\d]+",
                                                   "type" : "string"
                                                },
                                                "rate" : {
                                                   "description" : "Apply rate limiting to the interface",
                                                   "format_description" : "mbps",
                                                   "optional" : 1,
                                                   "type" : "number"
                                                },
                                                "tag" : {
                                                   "description" : "VLAN tag for this interface.",
                                                   "maximum" : 4094,
                                                   "minimum" : 1,
                                                   "optional" : 1,
                                                   "type" : "integer"
                                                },
                                                "trunks" : {
                                                   "description" : "VLAN ids to pass through the interface",
                                                   "format_description" : "vlanid[;vlanid...]",
                                                   "optional" : 1,
                                                   "pattern" : "(?^:\\d+(?:;\\d+)*)",
                                                   "type" : "string"
                                                },
                                                "type" : {
                                                   "description" : "Network interface type.",
                                                   "enum" : [
                                                      "veth"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "name=<string> [,bridge=<bridge>] [,firewall=<1|0>] [,gw=<GatewayIPv4>] [,gw6=<GatewayIPv6>] [,hwaddr=<XX:XX:XX:XX:XX:XX>] [,ip=<IPv4Format/CIDR>] [,ip6=<IPv6Format/CIDR>] [,mtu=<integer>] [,rate=<mbps>] [,tag=<integer>] [,trunks=<vlanid[;vlanid...]>] [,type=<veth>]"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "onboot" : {
                                             "default" : 0,
                                             "description" : "Specifies whether a VM will be started during system bootup.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "ostype" : {
                                             "description" : "OS type. This is used to setup configuration inside the container, and corresponds to lxc setup scripts in /usr/share/lxc/config/<ostype>.common.conf. Value 'unmanaged' can be used to skip and OS specific setup.",
                                             "enum" : [
                                                "debian",
                                                "ubuntu",
                                                "centos",
                                                "fedora",
                                                "opensuse",
                                                "archlinux",
                                                "alpine",
                                                "gentoo",
                                                "unmanaged"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "protection" : {
                                             "default" : 0,
                                             "description" : "Sets the protection flag of the container. This will prevent the CT or CT's disk remove/update operation.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "rootfs" : {
                                             "description" : "Use volume as container root.",
                                             "format" : {
                                                "acl" : {
                                                   "description" : "Explicitly enable or disable ACL support.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "quota" : {
                                                   "description" : "Enable user quotas inside the container (not supported with zfs subvolumes)",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "ro" : {
                                                   "description" : "Read-only mountpoint",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "size" : {
                                                   "description" : "Volume size (read only value).",
                                                   "format" : "disk-size",
                                                   "format_description" : "DiskSize",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "volume" : {
                                                   "default_key" : 1,
                                                   "description" : "Volume, device or directory to mount into the container.",
                                                   "format" : "pve-lxc-mp-string",
                                                   "format_description" : "volume",
                                                   "type" : "string"
                                                }
                                             },
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[volume=]<volume> [,acl=<1|0>] [,quota=<1|0>] [,ro=<1|0>] [,size=<DiskSize>]"
                                          },
                                          "searchdomain" : {
                                             "description" : "Sets DNS search domains for a container. Create will automatically use the setting from the host if you neither set searchdomain nor nameserver.",
                                             "format" : "dns-name-list",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "startup" : {
                                             "description" : "Startup and shutdown behavior. Order is a non-negative number defining the general startup order. Shutdown in done with reverse ordering. Additionally you can set the 'up' or 'down' delay in seconds, which specifies a delay to wait before the next VM is started or stopped.",
                                             "format" : "pve-startup-order",
                                             "optional" : 1,
                                             "type" : "string",
                                             "typetext" : "[[order=]\\d+] [,up=\\d+] [,down=\\d+] "
                                          },
                                          "swap" : {
                                             "default" : 512,
                                             "description" : "Amount of SWAP for the VM in MB.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          },
                                          "template" : {
                                             "default" : 0,
                                             "description" : "Enable/disable Template.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "tty" : {
                                             "default" : 2,
                                             "description" : "Specify the number of tty available to the container",
                                             "maximum" : 6,
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0-6)"
                                          },
                                          "unprivileged" : {
                                             "default" : 0,
                                             "description" : "Makes the container run as unprivileged user. (Should not be modified manually.)",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "unused[n]" : {
                                             "description" : "Reference to unused volumes. This is used internally, and should not be modified manually.",
                                             "format" : "pve-volume-id",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Config.Disk",
                                             "VM.Config.CPU",
                                             "VM.Config.Memory",
                                             "VM.Config.Network",
                                             "VM.Config.Options"
                                          ],
                                          "any",
                                          1
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/lxc/{vmid}/config",
                              "text" : "config"
                           },
                           {
                              "children" : [
                                 {
                                    "info" : {
                                       "GET" : {
                                          "description" : "Get virtual machine status.",
                                          "method" : "GET",
                                          "name" : "vm_status",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "object"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/lxc/{vmid}/status/current",
                                    "text" : "current"
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "description" : "Start the container.",
                                          "method" : "POST",
                                          "name" : "vm_start",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "skiplock" : {
                                                   "description" : "Ignore locks - only root is allowed to use this option.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/lxc/{vmid}/status/start",
                                    "text" : "start"
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "description" : "Stop the container. This will abruptly stop all processes running in the container.",
                                          "method" : "POST",
                                          "name" : "vm_stop",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "skiplock" : {
                                                   "description" : "Ignore locks - only root is allowed to use this option.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/lxc/{vmid}/status/stop",
                                    "text" : "stop"
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "description" : "Shutdown the container. This will trigger a clean shutdown of the container, see lxc-stop(1) for details.",
                                          "method" : "POST",
                                          "name" : "vm_shutdown",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "forceStop" : {
                                                   "default" : 0,
                                                   "description" : "Make sure the Container stops.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "timeout" : {
                                                   "default" : 60,
                                                   "description" : "Wait maximal timeout seconds.",
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (0- N)"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/lxc/{vmid}/status/shutdown",
                                    "text" : "shutdown"
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "description" : "Suspend the container.",
                                          "method" : "POST",
                                          "name" : "vm_suspend",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/lxc/{vmid}/status/suspend",
                                    "text" : "suspend"
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "description" : "Resume the container.",
                                          "method" : "POST",
                                          "name" : "vm_resume",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.PowerMgmt"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/lxc/{vmid}/status/resume",
                                    "text" : "resume"
                                 }
                              ],
                              "info" : {
                                 "GET" : {
                                    "description" : "Directory index",
                                    "method" : "GET",
                                    "name" : "vmcmdidx",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "user" : "all"
                                    },
                                    "proxyto" : "node",
                                    "returns" : {
                                       "items" : {
                                          "properties" : {
                                             "subdir" : {
                                                "type" : "string"
                                             }
                                          },
                                          "type" : "object"
                                       },
                                       "links" : [
                                          {
                                             "href" : "{subdir}",
                                             "rel" : "child"
                                          }
                                       ],
                                       "type" : "array"
                                    }
                                 }
                              },
                              "leaf" : 0,
                              "path" : "/nodes/{node}/lxc/{vmid}/status",
                              "text" : "status"
                           },
                           {
                              "children" : [
                                 {
                                    "children" : [
                                       {
                                          "info" : {
                                             "POST" : {
                                                "description" : "Rollback LXC state to specified snapshot.",
                                                "method" : "POST",
                                                "name" : "rollback",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "snapname" : {
                                                         "description" : "The name of the snapshot.",
                                                         "format" : "pve-configid",
                                                         "maxLength" : 40,
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Snapshot"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "proxyto" : "node",
                                                "returns" : {
                                                   "description" : "the task ID.",
                                                   "type" : "string"
                                                }
                                             }
                                          },
                                          "leaf" : 1,
                                          "path" : "/nodes/{node}/lxc/{vmid}/snapshot/{snapname}/rollback",
                                          "text" : "rollback"
                                       },
                                       {
                                          "info" : {
                                             "GET" : {
                                                "description" : "Get snapshot configuration",
                                                "method" : "GET",
                                                "name" : "get_snapshot_config",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "snapname" : {
                                                         "description" : "The name of the snapshot.",
                                                         "format" : "pve-configid",
                                                         "maxLength" : 40,
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Snapshot"
                                                      ]
                                                   ]
                                                },
                                                "proxyto" : "node",
                                                "returns" : {
                                                   "type" : "object"
                                                }
                                             },
                                             "PUT" : {
                                                "description" : "Update snapshot metadata.",
                                                "method" : "PUT",
                                                "name" : "update_snapshot_config",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "description" : {
                                                         "description" : "A textual description or comment.",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "snapname" : {
                                                         "description" : "The name of the snapshot.",
                                                         "format" : "pve-configid",
                                                         "maxLength" : 40,
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Snapshot"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "proxyto" : "node",
                                                "returns" : {
                                                   "type" : "null"
                                                }
                                             }
                                          },
                                          "leaf" : 1,
                                          "path" : "/nodes/{node}/lxc/{vmid}/snapshot/{snapname}/config",
                                          "text" : "config"
                                       }
                                    ],
                                    "info" : {
                                       "DELETE" : {
                                          "description" : "Delete a LXC snapshot.",
                                          "method" : "DELETE",
                                          "name" : "delsnapshot",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "force" : {
                                                   "description" : "For removal from config file, even if removing disk snapshots fails.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "snapname" : {
                                                   "description" : "The name of the snapshot.",
                                                   "format" : "pve-configid",
                                                   "maxLength" : 40,
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Snapshot"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "description" : "the task ID.",
                                             "type" : "string"
                                          }
                                       },
                                       "GET" : {
                                          "description" : "",
                                          "method" : "GET",
                                          "name" : "snapshot_cmd_idx",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "snapname" : {
                                                   "description" : "The name of the snapshot.",
                                                   "format" : "pve-configid",
                                                   "maxLength" : 40,
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "user" : "all"
                                          },
                                          "returns" : {
                                             "items" : {
                                                "properties" : {},
                                                "type" : "object"
                                             },
                                             "links" : [
                                                {
                                                   "href" : "{cmd}",
                                                   "rel" : "child"
                                                }
                                             ],
                                             "type" : "array"
                                          }
                                       }
                                    },
                                    "leaf" : 0,
                                    "path" : "/nodes/{node}/lxc/{vmid}/snapshot/{snapname}",
                                    "text" : "{snapname}"
                                 }
                              ],
                              "info" : {
                                 "GET" : {
                                    "description" : "List all snapshots.",
                                    "method" : "GET",
                                    "name" : "list",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "items" : {
                                          "properties" : {},
                                          "type" : "object"
                                       },
                                       "links" : [
                                          {
                                             "href" : "{name}",
                                             "rel" : "child"
                                          }
                                       ],
                                       "type" : "array"
                                    }
                                 },
                                 "POST" : {
                                    "description" : "Snapshot a container.",
                                    "method" : "POST",
                                    "name" : "snapshot",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "description" : {
                                             "description" : "A textual description or comment.",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "snapname" : {
                                             "description" : "The name of the snapshot.",
                                             "format" : "pve-configid",
                                             "maxLength" : 40,
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Snapshot"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "description" : "the task ID.",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 0,
                              "path" : "/nodes/{node}/lxc/{vmid}/snapshot",
                              "text" : "snapshot"
                           },
                           {
                              "children" : [
                                 {
                                    "children" : [
                                       {
                                          "info" : {
                                             "DELETE" : {
                                                "description" : "Delete rule.",
                                                "method" : "DELETE",
                                                "name" : "delete_rule",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "digest" : {
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                         "maxLength" : 40,
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "pos" : {
                                                         "description" : "Update rule at position <pos>.",
                                                         "minimum" : 0,
                                                         "optional" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (0- N)"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "proxyto" : null,
                                                "returns" : {
                                                   "type" : "null"
                                                }
                                             },
                                             "GET" : {
                                                "description" : "Get single rule data.",
                                                "method" : "GET",
                                                "name" : "get_rule",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "pos" : {
                                                         "description" : "Update rule at position <pos>.",
                                                         "minimum" : 0,
                                                         "optional" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (0- N)"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Audit"
                                                      ]
                                                   ]
                                                },
                                                "proxyto" : null,
                                                "returns" : {
                                                   "properties" : {
                                                      "pos" : {
                                                         "type" : "integer"
                                                      }
                                                   },
                                                   "type" : "object"
                                                }
                                             },
                                             "PUT" : {
                                                "description" : "Modify rule data.",
                                                "method" : "PUT",
                                                "name" : "update_rule",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "action" : {
                                                         "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                                         "maxLength" : 20,
                                                         "minLength" : 2,
                                                         "optional" : 1,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "comment" : {
                                                         "description" : "Descriptive comment.",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "delete" : {
                                                         "description" : "A list of settings you want to delete.",
                                                         "format" : "pve-configid-list",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "dest" : {
                                                         "description" : "Restrict packet destination address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                                         "format" : "pve-fw-addr-spec",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "digest" : {
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                         "maxLength" : 40,
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "dport" : {
                                                         "description" : "Restrict TCP/UDP destination port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                                         "format" : "pve-fw-dport-spec",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "enable" : {
                                                         "description" : "Flag to enable/disable a rule.",
                                                         "minimum" : 0,
                                                         "optional" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (0- N)"
                                                      },
                                                      "iface" : {
                                                         "description" : "Network interface name. You have to use network configuration key names for VMs and containers ('net\\d+'). Host related rules can use arbitrary strings.",
                                                         "format" : "pve-iface",
                                                         "maxLength" : 20,
                                                         "minLength" : 2,
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "macro" : {
                                                         "description" : "Use predefined standard macro.",
                                                         "maxLength" : 128,
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "moveto" : {
                                                         "description" : "Move rule to new position <moveto>. Other arguments are ignored.",
                                                         "minimum" : 0,
                                                         "optional" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (0- N)"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "pos" : {
                                                         "description" : "Update rule at position <pos>.",
                                                         "minimum" : 0,
                                                         "optional" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (0- N)"
                                                      },
                                                      "proto" : {
                                                         "description" : "IP protocol. You can use protocol names ('tcp'/'udp') or simple numbers, as defined in '/etc/protocols'.",
                                                         "format" : "pve-fw-protocol-spec",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "source" : {
                                                         "description" : "Restrict packet source address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                                         "format" : "pve-fw-addr-spec",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "sport" : {
                                                         "description" : "Restrict TCP/UDP source port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                                         "format" : "pve-fw-sport-spec",
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "type" : {
                                                         "description" : "Rule type.",
                                                         "enum" : [
                                                            "in",
                                                            "out",
                                                            "group"
                                                         ],
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "proxyto" : null,
                                                "returns" : {
                                                   "type" : "null"
                                                }
                                             }
                                          },
                                          "leaf" : 1,
                                          "path" : "/nodes/{node}/lxc/{vmid}/firewall/rules/{pos}",
                                          "text" : "{pos}"
                                       }
                                    ],
                                    "info" : {
                                       "GET" : {
                                          "description" : "List rules.",
                                          "method" : "GET",
                                          "name" : "get_rules",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "proxyto" : null,
                                          "returns" : {
                                             "items" : {
                                                "properties" : {
                                                   "pos" : {
                                                      "type" : "integer"
                                                   }
                                                },
                                                "type" : "object"
                                             },
                                             "links" : [
                                                {
                                                   "href" : "{pos}",
                                                   "rel" : "child"
                                                }
                                             ],
                                             "type" : "array"
                                          }
                                       },
                                       "POST" : {
                                          "description" : "Create new rule.",
                                          "method" : "POST",
                                          "name" : "create_rule",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "action" : {
                                                   "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                                   "maxLength" : 20,
                                                   "minLength" : 2,
                                                   "optional" : 0,
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "type" : "string"
                                                },
                                                "comment" : {
                                                   "description" : "Descriptive comment.",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "dest" : {
                                                   "description" : "Restrict packet destination address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                                   "format" : "pve-fw-addr-spec",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "digest" : {
                                                   "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                   "maxLength" : 40,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "dport" : {
                                                   "description" : "Restrict TCP/UDP destination port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                                   "format" : "pve-fw-dport-spec",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "enable" : {
                                                   "description" : "Flag to enable/disable a rule.",
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (0- N)"
                                                },
                                                "iface" : {
                                                   "description" : "Network interface name. You have to use network configuration key names for VMs and containers ('net\\d+'). Host related rules can use arbitrary strings.",
                                                   "format" : "pve-iface",
                                                   "maxLength" : 20,
                                                   "minLength" : 2,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "macro" : {
                                                   "description" : "Use predefined standard macro.",
                                                   "maxLength" : 128,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "pos" : {
                                                   "description" : "Update rule at position <pos>.",
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (0- N)"
                                                },
                                                "proto" : {
                                                   "description" : "IP protocol. You can use protocol names ('tcp'/'udp') or simple numbers, as defined in '/etc/protocols'.",
                                                   "format" : "pve-fw-protocol-spec",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "source" : {
                                                   "description" : "Restrict packet source address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                                   "format" : "pve-fw-addr-spec",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "sport" : {
                                                   "description" : "Restrict TCP/UDP source port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                                   "format" : "pve-fw-sport-spec",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "type" : {
                                                   "description" : "Rule type.",
                                                   "enum" : [
                                                      "in",
                                                      "out",
                                                      "group"
                                                   ],
                                                   "optional" : 0,
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : null,
                                          "returns" : {
                                             "type" : "null"
                                          }
                                       }
                                    },
                                    "leaf" : 0,
                                    "path" : "/nodes/{node}/lxc/{vmid}/firewall/rules",
                                    "text" : "rules"
                                 },
                                 {
                                    "children" : [
                                       {
                                          "info" : {
                                             "DELETE" : {
                                                "description" : "Remove IP or Network alias.",
                                                "method" : "DELETE",
                                                "name" : "remove_alias",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "digest" : {
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                         "maxLength" : 40,
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "name" : {
                                                         "description" : "Alias name.",
                                                         "maxLength" : 64,
                                                         "minLength" : 2,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "returns" : {
                                                   "type" : "null"
                                                }
                                             },
                                             "GET" : {
                                                "description" : "Read alias.",
                                                "method" : "GET",
                                                "name" : "read_alias",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "name" : {
                                                         "description" : "Alias name.",
                                                         "maxLength" : 64,
                                                         "minLength" : 2,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Audit"
                                                      ]
                                                   ]
                                                },
                                                "returns" : {
                                                   "type" : "object"
                                                }
                                             },
                                             "PUT" : {
                                                "description" : "Update IP or Network alias.",
                                                "method" : "PUT",
                                                "name" : "update_alias",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "cidr" : {
                                                         "description" : "Network/IP specification in CIDR format.",
                                                         "format" : "IPorCIDR",
                                                         "type" : "string"
                                                      },
                                                      "comment" : {
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "digest" : {
                                                         "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                         "maxLength" : 40,
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "name" : {
                                                         "description" : "Alias name.",
                                                         "maxLength" : 64,
                                                         "minLength" : 2,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "rename" : {
                                                         "description" : "Rename an existing alias.",
                                                         "maxLength" : 64,
                                                         "minLength" : 2,
                                                         "optional" : 1,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "returns" : {
                                                   "type" : "null"
                                                }
                                             }
                                          },
                                          "leaf" : 1,
                                          "path" : "/nodes/{node}/lxc/{vmid}/firewall/aliases/{name}",
                                          "text" : "{name}"
                                       }
                                    ],
                                    "info" : {
                                       "GET" : {
                                          "description" : "List aliases",
                                          "method" : "GET",
                                          "name" : "get_aliases",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "returns" : {
                                             "items" : {
                                                "properties" : {
                                                   "cidr" : {
                                                      "type" : "string"
                                                   },
                                                   "comment" : {
                                                      "optional" : 1,
                                                      "type" : "string"
                                                   },
                                                   "digest" : {
                                                      "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                      "maxLength" : 40,
                                                      "optional" : 0,
                                                      "type" : "string"
                                                   },
                                                   "name" : {
                                                      "type" : "string"
                                                   }
                                                },
                                                "type" : "object"
                                             },
                                             "links" : [
                                                {
                                                   "href" : "{name}",
                                                   "rel" : "child"
                                                }
                                             ],
                                             "type" : "array"
                                          }
                                       },
                                       "POST" : {
                                          "description" : "Create IP or Network Alias.",
                                          "method" : "POST",
                                          "name" : "create_alias",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "cidr" : {
                                                   "description" : "Network/IP specification in CIDR format.",
                                                   "format" : "IPorCIDR",
                                                   "type" : "string"
                                                },
                                                "comment" : {
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "name" : {
                                                   "description" : "Alias name.",
                                                   "maxLength" : 64,
                                                   "minLength" : 2,
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "type" : "string"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "returns" : {
                                             "type" : "null"
                                          }
                                       }
                                    },
                                    "leaf" : 0,
                                    "path" : "/nodes/{node}/lxc/{vmid}/firewall/aliases",
                                    "text" : "aliases"
                                 },
                                 {
                                    "children" : [
                                       {
                                          "children" : [
                                             {
                                                "info" : {
                                                   "DELETE" : {
                                                      "description" : "Remove IP or Network from IPSet.",
                                                      "method" : "DELETE",
                                                      "name" : "remove_ip",
                                                      "parameters" : {
                                                         "additionalProperties" : 0,
                                                         "properties" : {
                                                            "cidr" : {
                                                               "description" : "Network/IP specification in CIDR format.",
                                                               "format" : "IPorCIDRorAlias",
                                                               "type" : "string"
                                                            },
                                                            "digest" : {
                                                               "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                               "maxLength" : 40,
                                                               "optional" : 1,
                                                               "type" : "string"
                                                            },
                                                            "name" : {
                                                               "description" : "IP set name.",
                                                               "maxLength" : 64,
                                                               "minLength" : 2,
                                                               "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                               "type" : "string"
                                                            },
                                                            "node" : {
                                                               "description" : "The cluster node name.",
                                                               "format" : "pve-node",
                                                               "type" : "string"
                                                            },
                                                            "vmid" : {
                                                               "description" : "The (unique) ID of the VM.",
                                                               "format" : "pve-vmid",
                                                               "minimum" : 1,
                                                               "type" : "integer",
                                                               "typetext" : "integer (1- N)"
                                                            }
                                                         }
                                                      },
                                                      "permissions" : {
                                                         "check" : [
                                                            "perm",
                                                            "/vms/{vmid}",
                                                            [
                                                               "VM.Config.Network"
                                                            ]
                                                         ]
                                                      },
                                                      "protected" : 1,
                                                      "returns" : {
                                                         "type" : "null"
                                                      }
                                                   },
                                                   "GET" : {
                                                      "description" : "Read IP or Network settings from IPSet.",
                                                      "method" : "GET",
                                                      "name" : "read_ip",
                                                      "parameters" : {
                                                         "additionalProperties" : 0,
                                                         "properties" : {
                                                            "cidr" : {
                                                               "description" : "Network/IP specification in CIDR format.",
                                                               "format" : "IPorCIDRorAlias",
                                                               "type" : "string"
                                                            },
                                                            "name" : {
                                                               "description" : "IP set name.",
                                                               "maxLength" : 64,
                                                               "minLength" : 2,
                                                               "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                               "type" : "string"
                                                            },
                                                            "node" : {
                                                               "description" : "The cluster node name.",
                                                               "format" : "pve-node",
                                                               "type" : "string"
                                                            },
                                                            "vmid" : {
                                                               "description" : "The (unique) ID of the VM.",
                                                               "format" : "pve-vmid",
                                                               "minimum" : 1,
                                                               "type" : "integer",
                                                               "typetext" : "integer (1- N)"
                                                            }
                                                         }
                                                      },
                                                      "permissions" : {
                                                         "check" : [
                                                            "perm",
                                                            "/vms/{vmid}",
                                                            [
                                                               "VM.Audit"
                                                            ]
                                                         ]
                                                      },
                                                      "protected" : 1,
                                                      "returns" : {
                                                         "type" : "object"
                                                      }
                                                   },
                                                   "PUT" : {
                                                      "description" : "Update IP or Network settings",
                                                      "method" : "PUT",
                                                      "name" : "update_ip",
                                                      "parameters" : {
                                                         "additionalProperties" : 0,
                                                         "properties" : {
                                                            "cidr" : {
                                                               "description" : "Network/IP specification in CIDR format.",
                                                               "format" : "IPorCIDRorAlias",
                                                               "type" : "string"
                                                            },
                                                            "comment" : {
                                                               "optional" : 1,
                                                               "type" : "string"
                                                            },
                                                            "digest" : {
                                                               "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                               "maxLength" : 40,
                                                               "optional" : 1,
                                                               "type" : "string"
                                                            },
                                                            "name" : {
                                                               "description" : "IP set name.",
                                                               "maxLength" : 64,
                                                               "minLength" : 2,
                                                               "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                               "type" : "string"
                                                            },
                                                            "node" : {
                                                               "description" : "The cluster node name.",
                                                               "format" : "pve-node",
                                                               "type" : "string"
                                                            },
                                                            "nomatch" : {
                                                               "optional" : 1,
                                                               "type" : "boolean"
                                                            },
                                                            "vmid" : {
                                                               "description" : "The (unique) ID of the VM.",
                                                               "format" : "pve-vmid",
                                                               "minimum" : 1,
                                                               "type" : "integer",
                                                               "typetext" : "integer (1- N)"
                                                            }
                                                         }
                                                      },
                                                      "permissions" : {
                                                         "check" : [
                                                            "perm",
                                                            "/vms/{vmid}",
                                                            [
                                                               "VM.Config.Network"
                                                            ]
                                                         ]
                                                      },
                                                      "protected" : 1,
                                                      "returns" : {
                                                         "type" : "null"
                                                      }
                                                   }
                                                },
                                                "leaf" : 1,
                                                "path" : "/nodes/{node}/lxc/{vmid}/firewall/ipset/{name}/{cidr}",
                                                "text" : "{cidr}"
                                             }
                                          ],
                                          "info" : {
                                             "DELETE" : {
                                                "description" : "Delete IPSet",
                                                "method" : "DELETE",
                                                "name" : "delete_ipset",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "name" : {
                                                         "description" : "IP set name.",
                                                         "maxLength" : 64,
                                                         "minLength" : 2,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "returns" : {
                                                   "type" : "null"
                                                }
                                             },
                                             "GET" : {
                                                "description" : "List IPSet content",
                                                "method" : "GET",
                                                "name" : "get_ipset",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "name" : {
                                                         "description" : "IP set name.",
                                                         "maxLength" : 64,
                                                         "minLength" : 2,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Audit"
                                                      ]
                                                   ]
                                                },
                                                "returns" : {
                                                   "items" : {
                                                      "properties" : {
                                                         "cidr" : {
                                                            "type" : "string"
                                                         },
                                                         "comment" : {
                                                            "optional" : 1,
                                                            "type" : "string"
                                                         },
                                                         "digest" : {
                                                            "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                            "maxLength" : 40,
                                                            "optional" : 0,
                                                            "type" : "string"
                                                         },
                                                         "nomatch" : {
                                                            "optional" : 1,
                                                            "type" : "boolean"
                                                         }
                                                      },
                                                      "type" : "object"
                                                   },
                                                   "links" : [
                                                      {
                                                         "href" : "{cidr}",
                                                         "rel" : "child"
                                                      }
                                                   ],
                                                   "type" : "array"
                                                }
                                             },
                                             "POST" : {
                                                "description" : "Add IP or Network to IPSet.",
                                                "method" : "POST",
                                                "name" : "create_ip",
                                                "parameters" : {
                                                   "additionalProperties" : 0,
                                                   "properties" : {
                                                      "cidr" : {
                                                         "description" : "Network/IP specification in CIDR format.",
                                                         "format" : "IPorCIDRorAlias",
                                                         "type" : "string"
                                                      },
                                                      "comment" : {
                                                         "optional" : 1,
                                                         "type" : "string"
                                                      },
                                                      "name" : {
                                                         "description" : "IP set name.",
                                                         "maxLength" : 64,
                                                         "minLength" : 2,
                                                         "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                         "type" : "string"
                                                      },
                                                      "node" : {
                                                         "description" : "The cluster node name.",
                                                         "format" : "pve-node",
                                                         "type" : "string"
                                                      },
                                                      "nomatch" : {
                                                         "optional" : 1,
                                                         "type" : "boolean"
                                                      },
                                                      "vmid" : {
                                                         "description" : "The (unique) ID of the VM.",
                                                         "format" : "pve-vmid",
                                                         "minimum" : 1,
                                                         "type" : "integer",
                                                         "typetext" : "integer (1- N)"
                                                      }
                                                   }
                                                },
                                                "permissions" : {
                                                   "check" : [
                                                      "perm",
                                                      "/vms/{vmid}",
                                                      [
                                                         "VM.Config.Network"
                                                      ]
                                                   ]
                                                },
                                                "protected" : 1,
                                                "returns" : {
                                                   "type" : "null"
                                                }
                                             }
                                          },
                                          "leaf" : 0,
                                          "path" : "/nodes/{node}/lxc/{vmid}/firewall/ipset/{name}",
                                          "text" : "{name}"
                                       }
                                    ],
                                    "info" : {
                                       "GET" : {
                                          "description" : "List IPSets",
                                          "method" : "GET",
                                          "name" : "ipset_index",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "returns" : {
                                             "items" : {
                                                "properties" : {
                                                   "comment" : {
                                                      "optional" : 1,
                                                      "type" : "string"
                                                   },
                                                   "digest" : {
                                                      "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                      "maxLength" : 40,
                                                      "optional" : 0,
                                                      "type" : "string"
                                                   },
                                                   "name" : {
                                                      "description" : "IP set name.",
                                                      "maxLength" : 64,
                                                      "minLength" : 2,
                                                      "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                      "type" : "string"
                                                   }
                                                },
                                                "type" : "object"
                                             },
                                             "links" : [
                                                {
                                                   "href" : "{name}",
                                                   "rel" : "child"
                                                }
                                             ],
                                             "type" : "array"
                                          }
                                       },
                                       "POST" : {
                                          "description" : "Create new IPSet",
                                          "method" : "POST",
                                          "name" : "create_ipset",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "comment" : {
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "digest" : {
                                                   "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                   "maxLength" : 40,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "name" : {
                                                   "description" : "IP set name.",
                                                   "maxLength" : 64,
                                                   "minLength" : 2,
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "type" : "string"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "rename" : {
                                                   "description" : "Rename an existing IPSet. You can set 'rename' to the same value as 'name' to update the 'comment' of an existing IPSet.",
                                                   "maxLength" : 64,
                                                   "minLength" : 2,
                                                   "optional" : 1,
                                                   "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "returns" : {
                                             "type" : "null"
                                          }
                                       }
                                    },
                                    "leaf" : 0,
                                    "path" : "/nodes/{node}/lxc/{vmid}/firewall/ipset",
                                    "text" : "ipset"
                                 },
                                 {
                                    "info" : {
                                       "GET" : {
                                          "description" : "Get VM firewall options.",
                                          "method" : "GET",
                                          "name" : "get_options",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "proxyto" : "node",
                                          "returns" : {
                                             "properties" : {
                                                "dhcp" : {
                                                   "description" : "Enable DHCP.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "enable" : {
                                                   "description" : "Enable/disable firewall rules.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "ipfilter" : {
                                                   "description" : "Enable default IP filters. This is equivalent to adding an empty ipfilter-net<id> ipset for every interface. Such ipsets implicitly contain sane default restrictions such as restricting IPv6 link local addresses to the one derived from the interface's MAC address. For containers the configured IP addresses will be implicitly added.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "log_level_in" : {
                                                   "description" : "Log level for incoming traffic.",
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "log_level_out" : {
                                                   "description" : "Log level for outgoing traffic.",
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "macfilter" : {
                                                   "description" : "Enable/disable MAC address filter.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "ndp" : {
                                                   "description" : "Enable NDP.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "policy_in" : {
                                                   "description" : "Input policy.",
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "policy_out" : {
                                                   "description" : "Output policy.",
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "radv" : {
                                                   "description" : "Allow sending Router Advertisement.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                }
                                             },
                                             "type" : "object"
                                          }
                                       },
                                       "PUT" : {
                                          "description" : "Set Firewall options.",
                                          "method" : "PUT",
                                          "name" : "set_options",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "delete" : {
                                                   "description" : "A list of settings you want to delete.",
                                                   "format" : "pve-configid-list",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "dhcp" : {
                                                   "description" : "Enable DHCP.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "digest" : {
                                                   "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                                   "maxLength" : 40,
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "enable" : {
                                                   "description" : "Enable/disable firewall rules.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "ipfilter" : {
                                                   "description" : "Enable default IP filters. This is equivalent to adding an empty ipfilter-net<id> ipset for every interface. Such ipsets implicitly contain sane default restrictions such as restricting IPv6 link local addresses to the one derived from the interface's MAC address. For containers the configured IP addresses will be implicitly added.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "log_level_in" : {
                                                   "description" : "Log level for incoming traffic.",
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "log_level_out" : {
                                                   "description" : "Log level for outgoing traffic.",
                                                   "enum" : [
                                                      "emerg",
                                                      "alert",
                                                      "crit",
                                                      "err",
                                                      "warning",
                                                      "notice",
                                                      "info",
                                                      "debug",
                                                      "nolog"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "macfilter" : {
                                                   "description" : "Enable/disable MAC address filter.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "ndp" : {
                                                   "description" : "Enable NDP.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "policy_in" : {
                                                   "description" : "Input policy.",
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "policy_out" : {
                                                   "description" : "Output policy.",
                                                   "enum" : [
                                                      "ACCEPT",
                                                      "REJECT",
                                                      "DROP"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "radv" : {
                                                   "description" : "Allow sending Router Advertisement.",
                                                   "optional" : 1,
                                                   "type" : "boolean"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Config.Network"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "null"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/lxc/{vmid}/firewall/options",
                                    "text" : "options"
                                 },
                                 {
                                    "info" : {
                                       "GET" : {
                                          "description" : "Read firewall log",
                                          "method" : "GET",
                                          "name" : "log",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "limit" : {
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (0- N)"
                                                },
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "start" : {
                                                   "minimum" : 0,
                                                   "optional" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (0- N)"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Console"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "items" : {
                                                "properties" : {
                                                   "n" : {
                                                      "description" : "Line number",
                                                      "type" : "integer"
                                                   },
                                                   "t" : {
                                                      "description" : "Line text",
                                                      "type" : "string"
                                                   }
                                                },
                                                "type" : "object"
                                             },
                                             "type" : "array"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/lxc/{vmid}/firewall/log",
                                    "text" : "log"
                                 },
                                 {
                                    "info" : {
                                       "GET" : {
                                          "description" : "Lists possible IPSet/Alias reference which are allowed in source/dest properties.",
                                          "method" : "GET",
                                          "name" : "refs",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "type" : {
                                                   "description" : "Only list references of specified type.",
                                                   "enum" : [
                                                      "alias",
                                                      "ipset"
                                                   ],
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "vmid" : {
                                                   "description" : "The (unique) ID of the VM.",
                                                   "format" : "pve-vmid",
                                                   "minimum" : 1,
                                                   "type" : "integer",
                                                   "typetext" : "integer (1- N)"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/vms/{vmid}",
                                                [
                                                   "VM.Audit"
                                                ]
                                             ]
                                          },
                                          "returns" : {
                                             "items" : {
                                                "properties" : {
                                                   "comment" : {
                                                      "optional" : 1,
                                                      "type" : "string"
                                                   },
                                                   "name" : {
                                                      "type" : "string"
                                                   },
                                                   "type" : {
                                                      "enum" : [
                                                         "alias",
                                                         "ipset"
                                                      ],
                                                      "type" : "string"
                                                   }
                                                },
                                                "type" : "object"
                                             },
                                             "type" : "array"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/lxc/{vmid}/firewall/refs",
                                    "text" : "refs"
                                 }
                              ],
                              "info" : {
                                 "GET" : {
                                    "description" : "Directory index.",
                                    "method" : "GET",
                                    "name" : "index",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "user" : "all"
                                    },
                                    "returns" : {
                                       "items" : {
                                          "properties" : {},
                                          "type" : "object"
                                       },
                                       "links" : [
                                          {
                                             "href" : "{name}",
                                             "rel" : "child"
                                          }
                                       ],
                                       "type" : "array"
                                    }
                                 }
                              },
                              "leaf" : 0,
                              "path" : "/nodes/{node}/lxc/{vmid}/firewall",
                              "text" : "firewall"
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Read VM RRD statistics (returns PNG)",
                                    "method" : "GET",
                                    "name" : "rrd",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "cf" : {
                                             "description" : "The RRD consolidation function",
                                             "enum" : [
                                                "AVERAGE",
                                                "MAX"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "ds" : {
                                             "description" : "The list of datasources you want to display.",
                                             "format" : "pve-configid-list",
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "timeframe" : {
                                             "description" : "Specify the time frame you are interested in.",
                                             "enum" : [
                                                "hour",
                                                "day",
                                                "week",
                                                "month",
                                                "year"
                                             ],
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "returns" : {
                                       "properties" : {
                                          "filename" : {
                                             "type" : "string"
                                          }
                                       },
                                       "type" : "object"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/lxc/{vmid}/rrd",
                              "text" : "rrd"
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Read VM RRD statistics",
                                    "method" : "GET",
                                    "name" : "rrddata",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "cf" : {
                                             "description" : "The RRD consolidation function",
                                             "enum" : [
                                                "AVERAGE",
                                                "MAX"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "timeframe" : {
                                             "description" : "Specify the time frame you are interested in.",
                                             "enum" : [
                                                "hour",
                                                "day",
                                                "week",
                                                "month",
                                                "year"
                                             ],
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "returns" : {
                                       "items" : {
                                          "properties" : {},
                                          "type" : "object"
                                       },
                                       "type" : "array"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/lxc/{vmid}/rrddata",
                              "text" : "rrddata"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Creates a TCP VNC proxy connections.",
                                    "method" : "POST",
                                    "name" : "vncproxy",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "websocket" : {
                                             "description" : "use websocket instead of standard VNC.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Console"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "returns" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "cert" : {
                                             "type" : "string"
                                          },
                                          "port" : {
                                             "type" : "integer"
                                          },
                                          "ticket" : {
                                             "type" : "string"
                                          },
                                          "upid" : {
                                             "type" : "string"
                                          },
                                          "user" : {
                                             "type" : "string"
                                          }
                                       }
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/lxc/{vmid}/vncproxy",
                              "text" : "vncproxy"
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Opens a weksocket for VNC traffic.",
                                    "method" : "GET",
                                    "name" : "vncwebsocket",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "port" : {
                                             "description" : "Port number returned by previous vncproxy call.",
                                             "maximum" : 5999,
                                             "minimum" : 5900,
                                             "type" : "integer",
                                             "typetext" : "integer (5900-5999)"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "vncticket" : {
                                             "description" : "Ticket from previous call to vncproxy.",
                                             "maxLength" : 512,
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Console"
                                          ]
                                       ],
                                       "description" : "You also need to pass a valid ticket (vncticket)."
                                    },
                                    "returns" : {
                                       "properties" : {
                                          "port" : {
                                             "type" : "string"
                                          }
                                       },
                                       "type" : "object"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/lxc/{vmid}/vncwebsocket",
                              "text" : "vncwebsocket"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Returns a SPICE configuration to connect to the CT.",
                                    "method" : "POST",
                                    "name" : "spiceproxy",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "proxy" : {
                                             "description" : "SPICE proxy server. This can be used by the client to specify the proxy server. All nodes in a cluster runs 'spiceproxy', so it is up to the client to choose one. By default, we return the node where the VM is currently running. As resonable setting is to use same node you use to connect to the API (This is window.location.hostname for the JS GUI).",
                                             "format" : "address",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Console"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "additionalProperties" : 1,
                                       "description" : "Returned values can be directly passed to the 'remote-viewer' application.",
                                       "properties" : {
                                          "host" : {
                                             "type" : "string"
                                          },
                                          "password" : {
                                             "type" : "string"
                                          },
                                          "proxy" : {
                                             "type" : "string"
                                          },
                                          "tls-port" : {
                                             "type" : "integer"
                                          },
                                          "type" : {
                                             "type" : "string"
                                          }
                                       }
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/lxc/{vmid}/spiceproxy",
                              "text" : "spiceproxy"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Migrate the container to another node. Creates a new migration task.",
                                    "method" : "POST",
                                    "name" : "migrate_vm",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "force" : {
                                             "description" : "Force migration despite local bind / device mounts. WARNING: identical bind / device mounts need to  be available on the target node.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "online" : {
                                             "description" : "Use online/live migration.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "target" : {
                                             "description" : "Target node.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Migrate"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "description" : "the task ID.",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/lxc/{vmid}/migrate",
                              "text" : "migrate"
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Check if feature for virtual machine is available.",
                                    "method" : "GET",
                                    "name" : "vm_feature",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "feature" : {
                                             "description" : "Feature to check.",
                                             "enum" : [
                                                "snapshot"
                                             ],
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "snapname" : {
                                             "description" : "The name of the snapshot.",
                                             "format" : "pve-configid",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Audit"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "properties" : {
                                          "hasFeature" : {
                                             "type" : "boolean"
                                          }
                                       },
                                       "type" : "object"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/lxc/{vmid}/feature",
                              "text" : "feature"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Create a Template.",
                                    "method" : "POST",
                                    "name" : "template",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "experimental" : {
                                             "default" : 0,
                                             "description" : "The template feature is experimental, set this flag if you know what you are doing.",
                                             "type" : "boolean"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Allocate"
                                          ]
                                       ],
                                       "description" : "You need 'VM.Allocate' permissions on /vms/{vmid}"
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/lxc/{vmid}/template",
                              "text" : "template"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Create a container clone/copy",
                                    "method" : "POST",
                                    "name" : "clone_vm",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "description" : {
                                             "description" : "Description for the new CT.",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "experimental" : {
                                             "default" : 0,
                                             "description" : "The clone feature is experimental, set this flag if you know what you are doing.",
                                             "type" : "boolean"
                                          },
                                          "full" : {
                                             "default" : 0,
                                             "description" : "Create a full copy of all disk. This is always done when you clone a normal CT. For CT templates, we try to create a linked clone by default.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "hostname" : {
                                             "description" : "Set a hostname for the new CT.",
                                             "format" : "dns-name",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "newid" : {
                                             "description" : "VMID for the clone.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "pool" : {
                                             "description" : "Add the new CT to the specified pool.",
                                             "format" : "pve-poolid",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "snapname" : {
                                             "description" : "The name of the snapshot.",
                                             "format" : "pve-configid",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "storage" : {
                                             "description" : "Target storage for full clone.",
                                             "format" : "pve-storage-id",
                                             "optional" : 1,
                                             "requires" : "full",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "and",
                                          [
                                             "perm",
                                             "/vms/{vmid}",
                                             [
                                                "VM.Clone"
                                             ]
                                          ],
                                          [
                                             "or",
                                             [
                                                "perm",
                                                "/vms/{newid}",
                                                [
                                                   "VM.Allocate"
                                                ]
                                             ],
                                             [
                                                "perm",
                                                "/pool/{pool}",
                                                [
                                                   "VM.Allocate"
                                                ],
                                                "require_param",
                                                "pool"
                                             ]
                                          ]
                                       ],
                                       "description" : "You need 'VM.Clone' permissions on /vms/{vmid}, and 'VM.Allocate' permissions on /vms/{newid} (or on the VM pool /pool/{pool}). You also need 'Datastore.AllocateSpace' on any used storage."
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/lxc/{vmid}/clone",
                              "text" : "clone"
                           },
                           {
                              "info" : {
                                 "PUT" : {
                                    "description" : "Resize a container mountpoint.",
                                    "method" : "PUT",
                                    "name" : "resize_vm",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "digest" : {
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "disk" : {
                                             "description" : "The disk you want to resize.",
                                             "enum" : [
                                                "rootfs",
                                                "mp0",
                                                "mp1",
                                                "mp2",
                                                "mp3",
                                                "mp4",
                                                "mp5",
                                                "mp6",
                                                "mp7",
                                                "mp8",
                                                "mp9"
                                             ],
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "size" : {
                                             "description" : "The new size. With the '+' sign the value is added to the actual size of the volume and without it, the value is taken as an absolute one. Shrinking disk size is not supported.",
                                             "pattern" : "\\+?\\d+(\\.\\d+)?[KMGT]?",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "The (unique) ID of the VM.",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/vms/{vmid}",
                                          [
                                             "VM.Config.Disk"
                                          ],
                                          "any",
                                          1
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "description" : "the task ID.",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/lxc/{vmid}/resize",
                              "text" : "resize"
                           }
                        ],
                        "info" : {
                           "DELETE" : {
                              "description" : "Destroy the container (also delete all uses files).",
                              "method" : "DELETE",
                              "name" : "destroy_vm",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "vmid" : {
                                       "description" : "The (unique) ID of the VM.",
                                       "format" : "pve-vmid",
                                       "minimum" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (1- N)"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/vms/{vmid}",
                                    [
                                       "VM.Allocate"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "string"
                              }
                           },
                           "GET" : {
                              "description" : "Directory index",
                              "method" : "GET",
                              "name" : "vmdiridx",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "vmid" : {
                                       "description" : "The (unique) ID of the VM.",
                                       "format" : "pve-vmid",
                                       "minimum" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (1- N)"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "user" : "all"
                              },
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "subdir" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "links" : [
                                    {
                                       "href" : "{subdir}",
                                       "rel" : "child"
                                    }
                                 ],
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 0,
                        "path" : "/nodes/{node}/lxc/{vmid}",
                        "text" : "{vmid}"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "LXC container index (per node).",
                        "method" : "GET",
                        "name" : "vmlist",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "description" : "Only list CTs where you have VM.Audit permissons on /vms/<vmid>.",
                           "user" : "all"
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "items" : {
                              "properties" : {},
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{vmid}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     },
                     "POST" : {
                        "description" : "Create or restore a container.",
                        "method" : "POST",
                        "name" : "create_vm",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "arch" : {
                                 "default" : "amd64",
                                 "description" : "OS architecture type.",
                                 "enum" : [
                                    "amd64",
                                    "i386"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "cmode" : {
                                 "default" : "tty",
                                 "description" : "Console mode. By default, the console command tries to open a connection to one of the available tty devices. By setting cmode to 'console' it tries to attach to /dev/console instead. If you set cmode to 'shell', it simply invokes a shell inside the container (no login).",
                                 "enum" : [
                                    "shell",
                                    "console",
                                    "tty"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "console" : {
                                 "default" : 1,
                                 "description" : "Attach a console device (/dev/console) to the container.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "cpulimit" : {
                                 "default" : 0,
                                 "description" : "Limit of CPU usage.\n\nNOTE: If the computer has 2 CPUs, it has a total of '2' CPU time. Value '0' indicates no CPU limit.",
                                 "maximum" : 128,
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "number",
                                 "typetext" : "number (0-128)"
                              },
                              "cpuunits" : {
                                 "default" : 1024,
                                 "description" : "CPU weight for a VM. Argument is used in the kernel fair scheduler. The larger the number is, the more CPU time this VM gets. Number is relative to the weights of all the other running VMs.\n\nNOTE: You can disable fair-scheduler configuration by setting this to 0.",
                                 "maximum" : 500000,
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0-500000)"
                              },
                              "description" : {
                                 "description" : "Container description. Only used on the configuration web interface.",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "force" : {
                                 "description" : "Allow to overwrite existing container.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "hostname" : {
                                 "description" : "Set a host name for the container.",
                                 "format" : "dns-name",
                                 "maxLength" : 255,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "ignore-unpack-errors" : {
                                 "description" : "Ignore errors when extracting the template.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "lock" : {
                                 "description" : "Lock/unlock the VM.",
                                 "enum" : [
                                    "migrate",
                                    "backup",
                                    "snapshot",
                                    "rollback"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "memory" : {
                                 "default" : 512,
                                 "description" : "Amount of RAM for the VM in MB.",
                                 "minimum" : 16,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (16- N)"
                              },
                              "mp[n]" : {
                                 "description" : "Use volume as container mount point.",
                                 "format" : {
                                    "acl" : {
                                       "description" : "Explicitly enable or disable ACL support.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "backup" : {
                                       "description" : "Whether to include the mountpoint in backups.",
                                       "optional" : 1,
                                       "type" : "boolean",
                                       "verbose_description" : "Whether to include the mountpoint in backups (only used for volume mountpoints)."
                                    },
                                    "mp" : {
                                       "description" : "Path to the mountpoint as seen from inside the container (must not contain symlinks).",
                                       "format" : "pve-lxc-mp-string",
                                       "format_description" : "Path",
                                       "type" : "string",
                                       "verbose_description" : "Path to the mountpoint as seen from inside the container.\n\nNOTE: Must not contain any symlinks for security reasons."
                                    },
                                    "quota" : {
                                       "description" : "Enable user quotas inside the container (not supported with zfs subvolumes)",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "ro" : {
                                       "description" : "Read-only mountpoint",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "size" : {
                                       "description" : "Volume size (read only value).",
                                       "format" : "disk-size",
                                       "format_description" : "DiskSize",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "volume" : {
                                       "default_key" : 1,
                                       "description" : "Volume, device or directory to mount into the container.",
                                       "format" : "pve-lxc-mp-string",
                                       "format_description" : "volume",
                                       "type" : "string"
                                    }
                                 },
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "[volume=]<volume> ,mp=<Path> [,acl=<1|0>] [,backup=<1|0>] [,quota=<1|0>] [,ro=<1|0>] [,size=<DiskSize>]"
                              },
                              "nameserver" : {
                                 "description" : "Sets DNS server IP address for a container. Create will automatically use the setting from the host if you neither set searchdomain nor nameserver.",
                                 "format" : "address-list",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "net[n]" : {
                                 "description" : "Specifies network interfaces for the container.",
                                 "format" : {
                                    "bridge" : {
                                       "description" : "Bridge to attach the network device to.",
                                       "format_description" : "bridge",
                                       "optional" : 1,
                                       "pattern" : "[-_.\\w\\d]+",
                                       "type" : "string"
                                    },
                                    "firewall" : {
                                       "description" : "Controls whether this interface's firewall rules should be used.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "gw" : {
                                       "description" : "Default gateway for IPv4 traffic.",
                                       "format" : "ipv4",
                                       "format_description" : "GatewayIPv4",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "gw6" : {
                                       "description" : "Default gateway for IPv6 traffic.",
                                       "format" : "ipv6",
                                       "format_description" : "GatewayIPv6",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "hwaddr" : {
                                       "description" : "The interface MAC address. This is dynamically allocated by default, but you can set that statically if needed, for example to always have the same link-local IPv6 address. (lxc.network.hwaddr)",
                                       "format_description" : "XX:XX:XX:XX:XX:XX",
                                       "optional" : 1,
                                       "pattern" : "(?^i:(?:[a-f0-9]{2}:){5}[a-f0-9]{2})",
                                       "type" : "string"
                                    },
                                    "ip" : {
                                       "description" : "IPv4 address in CIDR format.",
                                       "format" : "pve-ipv4-config",
                                       "format_description" : "IPv4Format/CIDR",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "ip6" : {
                                       "description" : "IPv6 address in CIDR format.",
                                       "format" : "pve-ipv6-config",
                                       "format_description" : "IPv6Format/CIDR",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "mtu" : {
                                       "description" : "Maximum transfer unit of the interface. (lxc.network.mtu)",
                                       "minimum" : 64,
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "name" : {
                                       "description" : "Name of the network device as seen from inside the container. (lxc.network.name)",
                                       "format_description" : "string",
                                       "pattern" : "[-_.\\w\\d]+",
                                       "type" : "string"
                                    },
                                    "rate" : {
                                       "description" : "Apply rate limiting to the interface",
                                       "format_description" : "mbps",
                                       "optional" : 1,
                                       "type" : "number"
                                    },
                                    "tag" : {
                                       "description" : "VLAN tag for this interface.",
                                       "maximum" : 4094,
                                       "minimum" : 1,
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "trunks" : {
                                       "description" : "VLAN ids to pass through the interface",
                                       "format_description" : "vlanid[;vlanid...]",
                                       "optional" : 1,
                                       "pattern" : "(?^:\\d+(?:;\\d+)*)",
                                       "type" : "string"
                                    },
                                    "type" : {
                                       "description" : "Network interface type.",
                                       "enum" : [
                                          "veth"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    }
                                 },
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "name=<string> [,bridge=<bridge>] [,firewall=<1|0>] [,gw=<GatewayIPv4>] [,gw6=<GatewayIPv6>] [,hwaddr=<XX:XX:XX:XX:XX:XX>] [,ip=<IPv4Format/CIDR>] [,ip6=<IPv6Format/CIDR>] [,mtu=<integer>] [,rate=<mbps>] [,tag=<integer>] [,trunks=<vlanid[;vlanid...]>] [,type=<veth>]"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "onboot" : {
                                 "default" : 0,
                                 "description" : "Specifies whether a VM will be started during system bootup.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "ostemplate" : {
                                 "description" : "The OS template or backup file.",
                                 "maxLength" : 255,
                                 "type" : "string"
                              },
                              "ostype" : {
                                 "description" : "OS type. This is used to setup configuration inside the container, and corresponds to lxc setup scripts in /usr/share/lxc/config/<ostype>.common.conf. Value 'unmanaged' can be used to skip and OS specific setup.",
                                 "enum" : [
                                    "debian",
                                    "ubuntu",
                                    "centos",
                                    "fedora",
                                    "opensuse",
                                    "archlinux",
                                    "alpine",
                                    "gentoo",
                                    "unmanaged"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "password" : {
                                 "description" : "Sets root password inside container.",
                                 "minLength" : 5,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "pool" : {
                                 "description" : "Add the VM to the specified pool.",
                                 "format" : "pve-poolid",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "protection" : {
                                 "default" : 0,
                                 "description" : "Sets the protection flag of the container. This will prevent the CT or CT's disk remove/update operation.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "restore" : {
                                 "description" : "Mark this as restore task.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "rootfs" : {
                                 "description" : "Use volume as container root.",
                                 "format" : {
                                    "acl" : {
                                       "description" : "Explicitly enable or disable ACL support.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "quota" : {
                                       "description" : "Enable user quotas inside the container (not supported with zfs subvolumes)",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "ro" : {
                                       "description" : "Read-only mountpoint",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "size" : {
                                       "description" : "Volume size (read only value).",
                                       "format" : "disk-size",
                                       "format_description" : "DiskSize",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "volume" : {
                                       "default_key" : 1,
                                       "description" : "Volume, device or directory to mount into the container.",
                                       "format" : "pve-lxc-mp-string",
                                       "format_description" : "volume",
                                       "type" : "string"
                                    }
                                 },
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "[volume=]<volume> [,acl=<1|0>] [,quota=<1|0>] [,ro=<1|0>] [,size=<DiskSize>]"
                              },
                              "searchdomain" : {
                                 "description" : "Sets DNS search domains for a container. Create will automatically use the setting from the host if you neither set searchdomain nor nameserver.",
                                 "format" : "dns-name-list",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "ssh-public-keys" : {
                                 "description" : "Setup public SSH keys (one key per line, OpenSSH format).",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "startup" : {
                                 "description" : "Startup and shutdown behavior. Order is a non-negative number defining the general startup order. Shutdown in done with reverse ordering. Additionally you can set the 'up' or 'down' delay in seconds, which specifies a delay to wait before the next VM is started or stopped.",
                                 "format" : "pve-startup-order",
                                 "optional" : 1,
                                 "type" : "string",
                                 "typetext" : "[[order=]\\d+] [,up=\\d+] [,down=\\d+] "
                              },
                              "storage" : {
                                 "default" : "local",
                                 "description" : "Default Storage.",
                                 "format" : "pve-storage-id",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "swap" : {
                                 "default" : 512,
                                 "description" : "Amount of SWAP for the VM in MB.",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "template" : {
                                 "default" : 0,
                                 "description" : "Enable/disable Template.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "tty" : {
                                 "default" : 2,
                                 "description" : "Specify the number of tty available to the container",
                                 "maximum" : 6,
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0-6)"
                              },
                              "unprivileged" : {
                                 "default" : 0,
                                 "description" : "Makes the container run as unprivileged user. (Should not be modified manually.)",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "unused[n]" : {
                                 "description" : "Reference to unused volumes. This is used internally, and should not be modified manually.",
                                 "format" : "pve-volume-id",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "vmid" : {
                                 "description" : "The (unique) ID of the VM.",
                                 "format" : "pve-vmid",
                                 "minimum" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (1- N)"
                              }
                           }
                        },
                        "permissions" : {
                           "description" : "You need 'VM.Allocate' permissions on /vms/{vmid} or on the VM pool /pool/{pool}. For restore, it is enough if the user has 'VM.Backup' permission and the VM already exists. You also need 'Datastore.AllocateSpace' permissions on the storage.",
                           "user" : "all"
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "string"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/nodes/{node}/lxc",
                  "text" : "lxc"
               },
               {
                  "children" : [
                     {
                        "children" : [
                           {
                              "children" : [
                                 {
                                    "info" : {
                                       "POST" : {
                                          "description" : "ceph osd in",
                                          "method" : "POST",
                                          "name" : "in",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "osdid" : {
                                                   "description" : "OSD ID",
                                                   "type" : "integer"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/",
                                                [
                                                   "Sys.Modify"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "null"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/ceph/osd/{osdid}/in",
                                    "text" : "in"
                                 },
                                 {
                                    "info" : {
                                       "POST" : {
                                          "description" : "ceph osd out",
                                          "method" : "POST",
                                          "name" : "out",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "osdid" : {
                                                   "description" : "OSD ID",
                                                   "type" : "integer"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "check" : [
                                                "perm",
                                                "/",
                                                [
                                                   "Sys.Modify"
                                                ]
                                             ]
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "null"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/ceph/osd/{osdid}/out",
                                    "text" : "out"
                                 }
                              ],
                              "info" : {
                                 "DELETE" : {
                                    "description" : "Destroy OSD",
                                    "method" : "DELETE",
                                    "name" : "destroyosd",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "cleanup" : {
                                             "default" : 0,
                                             "description" : "If set, we remove partition table entries.",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "osdid" : {
                                             "description" : "OSD ID",
                                             "type" : "integer"
                                          }
                                       }
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 0,
                              "path" : "/nodes/{node}/ceph/osd/{osdid}",
                              "text" : "{osdid}"
                           }
                        ],
                        "info" : {
                           "GET" : {
                              "description" : "Get Ceph osd list/tree.",
                              "method" : "GET",
                              "name" : "index",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit",
                                       "Datastore.Audit"
                                    ],
                                    "any",
                                    1
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "object"
                              }
                           },
                           "POST" : {
                              "description" : "Create OSD",
                              "method" : "POST",
                              "name" : "createosd",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "dev" : {
                                       "description" : "Block device name.",
                                       "type" : "string"
                                    },
                                    "fstype" : {
                                       "default" : "xfs",
                                       "description" : "File system type.",
                                       "enum" : [
                                          "xfs",
                                          "ext4",
                                          "btrfs"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "journal_dev" : {
                                       "description" : "Block device name for journal.",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "string"
                              }
                           }
                        },
                        "leaf" : 0,
                        "path" : "/nodes/{node}/ceph/osd",
                        "text" : "osd"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "List local disks.",
                              "method" : "GET",
                              "name" : "disks",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "type" : {
                                       "description" : "Only list specific types of disks.",
                                       "enum" : [
                                          "unused",
                                          "journal_disks"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit",
                                       "Datastore.Audit"
                                    ],
                                    "any",
                                    1
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "dev" : {
                                          "type" : "string"
                                       },
                                       "gpt" : {
                                          "type" : "boolean"
                                       },
                                       "model" : {
                                          "optional" : 1,
                                          "type" : "string"
                                       },
                                       "osdid" : {
                                          "type" : "integer"
                                       },
                                       "serial" : {
                                          "optional" : 1,
                                          "type" : "string"
                                       },
                                       "size" : {
                                          "type" : "integer"
                                       },
                                       "used" : {
                                          "optional" : 1,
                                          "type" : "string"
                                       },
                                       "vendor" : {
                                          "optional" : 1,
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/ceph/disks",
                        "text" : "disks"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Get Ceph configuration.",
                              "method" : "GET",
                              "name" : "config",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit",
                                       "Datastore.Audit"
                                    ],
                                    "any",
                                    1
                                 ]
                              },
                              "returns" : {
                                 "type" : "string"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/ceph/config",
                        "text" : "config"
                     },
                     {
                        "children" : [
                           {
                              "info" : {
                                 "DELETE" : {
                                    "description" : "Destroy Ceph monitor.",
                                    "method" : "DELETE",
                                    "name" : "destroymon",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "monid" : {
                                             "description" : "Monitor ID",
                                             "type" : "integer"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/ceph/mon/{monid}",
                              "text" : "{monid}"
                           }
                        ],
                        "info" : {
                           "GET" : {
                              "description" : "Get Ceph monitor list.",
                              "method" : "GET",
                              "name" : "listmon",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit",
                                       "Datastore.Audit"
                                    ],
                                    "any",
                                    1
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "addr" : {
                                          "type" : "string"
                                       },
                                       "name" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "links" : [
                                    {
                                       "href" : "{name}",
                                       "rel" : "child"
                                    }
                                 ],
                                 "type" : "array"
                              }
                           },
                           "POST" : {
                              "description" : "Create Ceph Monitor",
                              "method" : "POST",
                              "name" : "createmon",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "string"
                              }
                           }
                        },
                        "leaf" : 0,
                        "path" : "/nodes/{node}/ceph/mon",
                        "text" : "mon"
                     },
                     {
                        "info" : {
                           "POST" : {
                              "description" : "Create initial ceph default configuration and setup symlinks.",
                              "method" : "POST",
                              "name" : "init",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "network" : {
                                       "description" : "Use specific network for all ceph related traffic",
                                       "format" : "CIDR",
                                       "maxLength" : 128,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "pg_bits" : {
                                       "default" : 6,
                                       "description" : "Placement group bits, used to specify the default number of placement groups.\n\nNOTE: 'osd pool default pg num' does not work for default pools.",
                                       "maximum" : 14,
                                       "minimum" : 6,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (6-14)"
                                    },
                                    "size" : {
                                       "default" : 2,
                                       "description" : "Number of replicas per object",
                                       "maximum" : 3,
                                       "minimum" : 1,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (1-3)"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "null"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/ceph/init",
                        "text" : "init"
                     },
                     {
                        "info" : {
                           "POST" : {
                              "description" : "Stop ceph services.",
                              "method" : "POST",
                              "name" : "stop",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "service" : {
                                       "description" : "Ceph service name.",
                                       "optional" : 1,
                                       "pattern" : "(mon|mds|osd)\\.[A-Za-z0-9]{1,32}",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "string"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/ceph/stop",
                        "text" : "stop"
                     },
                     {
                        "info" : {
                           "POST" : {
                              "description" : "Start ceph services.",
                              "method" : "POST",
                              "name" : "start",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "service" : {
                                       "description" : "Ceph service name.",
                                       "optional" : 1,
                                       "pattern" : "(mon|mds|osd)\\.[A-Za-z0-9]{1,32}",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "string"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/ceph/start",
                        "text" : "start"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Get ceph status.",
                              "method" : "GET",
                              "name" : "status",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit",
                                       "Datastore.Audit"
                                    ],
                                    "any",
                                    1
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "object"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/ceph/status",
                        "text" : "status"
                     },
                     {
                        "children" : [
                           {
                              "info" : {
                                 "DELETE" : {
                                    "description" : "Destroy pool",
                                    "method" : "DELETE",
                                    "name" : "destroypool",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "force" : {
                                             "default" : 0,
                                             "description" : "If true, destroys pool even if in use",
                                             "optional" : 1,
                                             "type" : "boolean"
                                          },
                                          "name" : {
                                             "description" : "The name of the pool. It must be unique.",
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/ceph/pools/{name}",
                              "text" : "{name}"
                           }
                        ],
                        "info" : {
                           "GET" : {
                              "description" : "List all pools.",
                              "method" : "GET",
                              "name" : "lspools",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit",
                                       "Datastore.Audit"
                                    ],
                                    "any",
                                    1
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "pool" : {
                                          "type" : "integer"
                                       },
                                       "pool_name" : {
                                          "type" : "string"
                                       },
                                       "size" : {
                                          "type" : "integer"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "links" : [
                                    {
                                       "href" : "{pool_name}",
                                       "rel" : "child"
                                    }
                                 ],
                                 "type" : "array"
                              }
                           },
                           "POST" : {
                              "description" : "Create POOL",
                              "method" : "POST",
                              "name" : "createpool",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "crush_ruleset" : {
                                       "default" : 0,
                                       "description" : "The ruleset to use for mapping object placement in the cluster.",
                                       "maximum" : 32768,
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0-32768)"
                                    },
                                    "min_size" : {
                                       "default" : 1,
                                       "description" : "Minimum number of replicas per object",
                                       "maximum" : 3,
                                       "minimum" : 1,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (1-3)"
                                    },
                                    "name" : {
                                       "description" : "The name of the pool. It must be unique.",
                                       "type" : "string"
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "pg_num" : {
                                       "default" : 64,
                                       "description" : "Number of placement groups.",
                                       "maximum" : 32768,
                                       "minimum" : 8,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (8-32768)"
                                    },
                                    "size" : {
                                       "default" : 2,
                                       "description" : "Number of replicas per object",
                                       "maximum" : 3,
                                       "minimum" : 1,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (1-3)"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "null"
                              }
                           }
                        },
                        "leaf" : 0,
                        "path" : "/nodes/{node}/ceph/pools",
                        "text" : "pools"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Get OSD crush map",
                              "method" : "GET",
                              "name" : "crush",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Audit",
                                       "Datastore.Audit"
                                    ],
                                    "any",
                                    1
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "string"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/ceph/crush",
                        "text" : "crush"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Read ceph log",
                              "method" : "GET",
                              "name" : "log",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "limit" : {
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0- N)"
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "start" : {
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0- N)"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Syslog"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "n" : {
                                          "description" : "Line number",
                                          "type" : "integer"
                                       },
                                       "t" : {
                                          "description" : "Line text",
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/ceph/log",
                        "text" : "log"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "Directory index.",
                        "method" : "GET",
                        "name" : "index",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "Sys.Audit",
                                 "Datastore.Audit"
                              ],
                              "any",
                              1
                           ]
                        },
                        "returns" : {
                           "items" : {
                              "properties" : {},
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{name}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/nodes/{node}/ceph",
                  "text" : "ceph"
               },
               {
                  "children" : [
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Extract configuration from vzdump backup archive.",
                              "method" : "GET",
                              "name" : "extractconfig",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "volume" : {
                                       "description" : "Volume identifier",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "description" : "The user needs 'VM.Backup' permissions on the backed up guest ID, and 'Datastore.AllocateSpace' on the backup storage.",
                                 "user" : "all"
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "string"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/vzdump/extractconfig",
                        "text" : "extractconfig"
                     }
                  ],
                  "info" : {
                     "POST" : {
                        "description" : "Create backup.",
                        "method" : "POST",
                        "name" : "vzdump",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "all" : {
                                 "default" : 0,
                                 "description" : "Backup all known guest systems on this host.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "bwlimit" : {
                                 "default" : 0,
                                 "description" : "Limit I/O bandwidth (KBytes per second).",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "compress" : {
                                 "default" : "0",
                                 "description" : "Compress dump file.",
                                 "enum" : [
                                    "0",
                                    "1",
                                    "gzip",
                                    "lzo"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "dumpdir" : {
                                 "description" : "Store resulting files to specified directory.",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "exclude" : {
                                 "description" : "Exclude specified guest systems (assumes --all)",
                                 "format" : "pve-vmid-list",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "exclude-path" : {
                                 "description" : "Exclude certain files/directories (shell globs).",
                                 "format" : "string-alist",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "ionice" : {
                                 "default" : 7,
                                 "description" : "Set CFQ ionice priority.",
                                 "maximum" : 8,
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0-8)"
                              },
                              "lockwait" : {
                                 "default" : 180,
                                 "description" : "Maximal time to wait for the global lock (minutes).",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "mailnotification" : {
                                 "default" : "always",
                                 "description" : "Specify when to send an email",
                                 "enum" : [
                                    "always",
                                    "failure"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "mailto" : {
                                 "description" : "Comma-separated list of email addresses that should receive email notifications.",
                                 "format" : "string-list",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "maxfiles" : {
                                 "default" : 1,
                                 "description" : "Maximal number of backup files per guest system.",
                                 "minimum" : 1,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (1- N)"
                              },
                              "mode" : {
                                 "default" : "snapshot",
                                 "description" : "Backup mode.",
                                 "enum" : [
                                    "snapshot",
                                    "suspend",
                                    "stop"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "node" : {
                                 "description" : "Only run if executed on this node.",
                                 "format" : "pve-node",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "pigz" : {
                                 "default" : 0,
                                 "description" : "Use pigz instead of gzip when N>0. N=1 uses half of cores, N>1 uses N as thread count.",
                                 "optional" : 1,
                                 "type" : "integer"
                              },
                              "quiet" : {
                                 "default" : 0,
                                 "description" : "Be quiet.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "remove" : {
                                 "default" : 1,
                                 "description" : "Remove old backup files if there are more than 'maxfiles' backup files.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "script" : {
                                 "description" : "Use specified hook script.",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "size" : {
                                 "default" : 1024,
                                 "description" : "Unused, will be removed in a future release.",
                                 "minimum" : 500,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (500- N)"
                              },
                              "stdexcludes" : {
                                 "default" : 1,
                                 "description" : "Exclude temporary files and logs.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "stdout" : {
                                 "description" : "Write tar to stdout, not to a file.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "stop" : {
                                 "default" : 0,
                                 "description" : "Stop runnig backup jobs on this host.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "stopwait" : {
                                 "default" : 10,
                                 "description" : "Maximal time to wait until a guest system is stopped (minutes).",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "storage" : {
                                 "description" : "Store resulting file to this storage.",
                                 "format" : "pve-storage-id",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "tmpdir" : {
                                 "description" : "Store temporary files to specified directory.",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "vmid" : {
                                 "description" : "The ID of the guest system you want to backup.",
                                 "format" : "pve-vmid-list",
                                 "optional" : 1,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "description" : "The user needs 'VM.Backup' permissions on any VM, and 'Datastore.AllocateSpace' on the backup storage.",
                           "user" : "all"
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "string"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/nodes/{node}/vzdump",
                  "text" : "vzdump"
               },
               {
                  "children" : [
                     {
                        "children" : [
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Read service properties",
                                    "method" : "GET",
                                    "name" : "service_state",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "service" : {
                                             "description" : "Service ID",
                                             "enum" : [
                                                "pveproxy",
                                                "pvedaemon",
                                                "spiceproxy",
                                                "pvestatd",
                                                "pve-cluster",
                                                "corosync",
                                                "pve-firewall",
                                                "pvefw-logger",
                                                "pve-ha-crm",
                                                "pve-ha-lrm",
                                                "sshd",
                                                "syslog",
                                                "cron",
                                                "postfix",
                                                "ksmtuned",
                                                "systemd-timesyncd"
                                             ],
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Audit"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "properties" : {},
                                       "type" : "object"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/services/{service}/state",
                              "text" : "state"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Start service.",
                                    "method" : "POST",
                                    "name" : "service_start",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "service" : {
                                             "description" : "Service ID",
                                             "enum" : [
                                                "pveproxy",
                                                "pvedaemon",
                                                "spiceproxy",
                                                "pvestatd",
                                                "pve-cluster",
                                                "corosync",
                                                "pve-firewall",
                                                "pvefw-logger",
                                                "pve-ha-crm",
                                                "pve-ha-lrm",
                                                "sshd",
                                                "syslog",
                                                "cron",
                                                "postfix",
                                                "ksmtuned",
                                                "systemd-timesyncd"
                                             ],
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/services/{service}/start",
                              "text" : "start"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Stop service.",
                                    "method" : "POST",
                                    "name" : "service_stop",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "service" : {
                                             "description" : "Service ID",
                                             "enum" : [
                                                "pveproxy",
                                                "pvedaemon",
                                                "spiceproxy",
                                                "pvestatd",
                                                "pve-cluster",
                                                "corosync",
                                                "pve-firewall",
                                                "pvefw-logger",
                                                "pve-ha-crm",
                                                "pve-ha-lrm",
                                                "sshd",
                                                "syslog",
                                                "cron",
                                                "postfix",
                                                "ksmtuned",
                                                "systemd-timesyncd"
                                             ],
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/services/{service}/stop",
                              "text" : "stop"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Restart service.",
                                    "method" : "POST",
                                    "name" : "service_restart",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "service" : {
                                             "description" : "Service ID",
                                             "enum" : [
                                                "pveproxy",
                                                "pvedaemon",
                                                "spiceproxy",
                                                "pvestatd",
                                                "pve-cluster",
                                                "corosync",
                                                "pve-firewall",
                                                "pvefw-logger",
                                                "pve-ha-crm",
                                                "pve-ha-lrm",
                                                "sshd",
                                                "syslog",
                                                "cron",
                                                "postfix",
                                                "ksmtuned",
                                                "systemd-timesyncd"
                                             ],
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/services/{service}/restart",
                              "text" : "restart"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Reload service.",
                                    "method" : "POST",
                                    "name" : "service_reload",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "service" : {
                                             "description" : "Service ID",
                                             "enum" : [
                                                "pveproxy",
                                                "pvedaemon",
                                                "spiceproxy",
                                                "pvestatd",
                                                "pve-cluster",
                                                "corosync",
                                                "pve-firewall",
                                                "pvefw-logger",
                                                "pve-ha-crm",
                                                "pve-ha-lrm",
                                                "sshd",
                                                "syslog",
                                                "cron",
                                                "postfix",
                                                "ksmtuned",
                                                "systemd-timesyncd"
                                             ],
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/services/{service}/reload",
                              "text" : "reload"
                           }
                        ],
                        "info" : {
                           "GET" : {
                              "description" : "Directory index",
                              "method" : "GET",
                              "name" : "srvcmdidx",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "service" : {
                                       "description" : "Service ID",
                                       "enum" : [
                                          "pveproxy",
                                          "pvedaemon",
                                          "spiceproxy",
                                          "pvestatd",
                                          "pve-cluster",
                                          "corosync",
                                          "pve-firewall",
                                          "pvefw-logger",
                                          "pve-ha-crm",
                                          "pve-ha-lrm",
                                          "sshd",
                                          "syslog",
                                          "cron",
                                          "postfix",
                                          "ksmtuned",
                                          "systemd-timesyncd"
                                       ],
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "subdir" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "links" : [
                                    {
                                       "href" : "{subdir}",
                                       "rel" : "child"
                                    }
                                 ],
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 0,
                        "path" : "/nodes/{node}/services/{service}",
                        "text" : "{service}"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "Service list.",
                        "method" : "GET",
                        "name" : "index",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "items" : {
                              "properties" : {},
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{service}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/nodes/{node}/services",
                  "text" : "services"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "Read subscription info.",
                        "method" : "GET",
                        "name" : "get",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "user" : "all"
                        },
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "object"
                        }
                     },
                     "POST" : {
                        "description" : "Update subscription info.",
                        "method" : "POST",
                        "name" : "update",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "force" : {
                                 "default" : 0,
                                 "description" : "Always connect to server, even if we have up to date info inside local cache.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "null"
                        }
                     },
                     "PUT" : {
                        "description" : "Set subscription key.",
                        "method" : "PUT",
                        "name" : "set",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "key" : {
                                 "description" : "Proxmox VE subscription key",
                                 "type" : "string"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/subscription",
                  "text" : "subscription"
               },
               {
                  "children" : [
                     {
                        "info" : {
                           "DELETE" : {
                              "description" : "Delete network device configuration",
                              "method" : "DELETE",
                              "name" : "delete_network",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "iface" : {
                                       "description" : "Network interface name.",
                                       "format" : "pve-iface",
                                       "maxLength" : 20,
                                       "minLength" : 2,
                                       "type" : "string"
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "null"
                              }
                           },
                           "GET" : {
                              "description" : "Read network device configuration",
                              "method" : "GET",
                              "name" : "network_config",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "iface" : {
                                       "description" : "Network interface name.",
                                       "format" : "pve-iface",
                                       "maxLength" : 20,
                                       "minLength" : 2,
                                       "type" : "string"
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "proxyto" : "node",
                              "returns" : {
                                 "properties" : {
                                    "method" : {
                                       "type" : "string"
                                    },
                                    "type" : {
                                       "type" : "string"
                                    }
                                 },
                                 "type" : "object"
                              }
                           },
                           "PUT" : {
                              "description" : "Update network device configuration",
                              "method" : "PUT",
                              "name" : "update_network",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "address" : {
                                       "description" : "IP address.",
                                       "format" : "ipv4",
                                       "optional" : 1,
                                       "requires" : "netmask",
                                       "type" : "string"
                                    },
                                    "address6" : {
                                       "description" : "IP address.",
                                       "format" : "ipv6",
                                       "optional" : 1,
                                       "requires" : "netmask6",
                                       "type" : "string"
                                    },
                                    "autostart" : {
                                       "description" : "Automatically start interface on boot.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "bond_mode" : {
                                       "description" : "Bonding mode.",
                                       "enum" : [
                                          "balance-rr",
                                          "active-backup",
                                          "balance-xor",
                                          "broadcast",
                                          "802.3ad",
                                          "balance-tlb",
                                          "balance-alb",
                                          "balance-slb",
                                          "lacp-balance-slb",
                                          "lacp-balance-tcp"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "bond_xmit_hash_policy" : {
                                       "description" : "Selects the transmit hash policy to use for slave selection in balance-xor and 802.3ad modes.",
                                       "enum" : [
                                          "layer2",
                                          "layer2+3",
                                          "layer3+4"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "bridge_ports" : {
                                       "description" : "Specify the iterfaces you want to add to your bridge.",
                                       "format" : "pve-iface-list",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "bridge_vlan_aware" : {
                                       "description" : "Enable bridge vlan support.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "comments" : {
                                       "description" : "Comments",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "comments6" : {
                                       "description" : "Comments",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "delete" : {
                                       "description" : "A list of settings you want to delete.",
                                       "format" : "pve-configid-list",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "gateway" : {
                                       "description" : "Default gateway address.",
                                       "format" : "ipv4",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "gateway6" : {
                                       "description" : "Default ipv6 gateway address.",
                                       "format" : "ipv6",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "iface" : {
                                       "description" : "Network interface name.",
                                       "format" : "pve-iface",
                                       "maxLength" : 20,
                                       "minLength" : 2,
                                       "type" : "string"
                                    },
                                    "netmask" : {
                                       "description" : "Network mask.",
                                       "format" : "ipv4mask",
                                       "optional" : 1,
                                       "requires" : "address",
                                       "type" : "string"
                                    },
                                    "netmask6" : {
                                       "description" : "Network mask.",
                                       "maximum" : 128,
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "requires" : "address6",
                                       "type" : "integer",
                                       "typetext" : "integer (0-128)"
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "ovs_bonds" : {
                                       "description" : "Specify the interfaces used by the bonding device.",
                                       "format" : "pve-iface-list",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "ovs_bridge" : {
                                       "description" : "The OVS bridge associated with a OVS port. This is required when you create an OVS port.",
                                       "format" : "pve-iface",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "ovs_options" : {
                                       "description" : "OVS interface options.",
                                       "maxLength" : 1024,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "ovs_ports" : {
                                       "description" : "Specify the iterfaces you want to add to your bridge.",
                                       "format" : "pve-iface-list",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "ovs_tag" : {
                                       "description" : "Specify a VLan tag (used by OVSPort, OVSIntPort, OVSBond)",
                                       "maximum" : 4094,
                                       "minimum" : 1,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (1-4094)"
                                    },
                                    "slaves" : {
                                       "description" : "Specify the interfaces used by the bonding device.",
                                       "format" : "pve-iface-list",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "type" : {
                                       "description" : "Network interface type",
                                       "enum" : [
                                          "bridge",
                                          "bond",
                                          "eth",
                                          "alias",
                                          "vlan",
                                          "OVSBridge",
                                          "OVSBond",
                                          "OVSPort",
                                          "OVSIntPort",
                                          "unknown"
                                       ],
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "null"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/network/{iface}",
                        "text" : "{iface}"
                     }
                  ],
                  "info" : {
                     "DELETE" : {
                        "description" : "Revert network configuration changes.",
                        "method" : "DELETE",
                        "name" : "revert_network_changes",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "null"
                        }
                     },
                     "GET" : {
                        "description" : "List available networks",
                        "method" : "GET",
                        "name" : "index",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "type" : {
                                 "description" : "Only list specific interface types.",
                                 "enum" : [
                                    "bridge",
                                    "bond",
                                    "eth",
                                    "alias",
                                    "vlan",
                                    "OVSBridge",
                                    "OVSBond",
                                    "OVSPort",
                                    "OVSIntPort",
                                    "any_bridge"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "user" : "all"
                        },
                        "proxyto" : "node",
                        "returns" : {
                           "items" : {
                              "properties" : {},
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{iface}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     },
                     "POST" : {
                        "description" : "Create network device configuration",
                        "method" : "POST",
                        "name" : "create_network",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "address" : {
                                 "description" : "IP address.",
                                 "format" : "ipv4",
                                 "optional" : 1,
                                 "requires" : "netmask",
                                 "type" : "string"
                              },
                              "address6" : {
                                 "description" : "IP address.",
                                 "format" : "ipv6",
                                 "optional" : 1,
                                 "requires" : "netmask6",
                                 "type" : "string"
                              },
                              "autostart" : {
                                 "description" : "Automatically start interface on boot.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "bond_mode" : {
                                 "description" : "Bonding mode.",
                                 "enum" : [
                                    "balance-rr",
                                    "active-backup",
                                    "balance-xor",
                                    "broadcast",
                                    "802.3ad",
                                    "balance-tlb",
                                    "balance-alb",
                                    "balance-slb",
                                    "lacp-balance-slb",
                                    "lacp-balance-tcp"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "bond_xmit_hash_policy" : {
                                 "description" : "Selects the transmit hash policy to use for slave selection in balance-xor and 802.3ad modes.",
                                 "enum" : [
                                    "layer2",
                                    "layer2+3",
                                    "layer3+4"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "bridge_ports" : {
                                 "description" : "Specify the iterfaces you want to add to your bridge.",
                                 "format" : "pve-iface-list",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "bridge_vlan_aware" : {
                                 "description" : "Enable bridge vlan support.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "comments" : {
                                 "description" : "Comments",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "comments6" : {
                                 "description" : "Comments",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "gateway" : {
                                 "description" : "Default gateway address.",
                                 "format" : "ipv4",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "gateway6" : {
                                 "description" : "Default ipv6 gateway address.",
                                 "format" : "ipv6",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "iface" : {
                                 "description" : "Network interface name.",
                                 "format" : "pve-iface",
                                 "maxLength" : 20,
                                 "minLength" : 2,
                                 "type" : "string"
                              },
                              "netmask" : {
                                 "description" : "Network mask.",
                                 "format" : "ipv4mask",
                                 "optional" : 1,
                                 "requires" : "address",
                                 "type" : "string"
                              },
                              "netmask6" : {
                                 "description" : "Network mask.",
                                 "maximum" : 128,
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "requires" : "address6",
                                 "type" : "integer",
                                 "typetext" : "integer (0-128)"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "ovs_bonds" : {
                                 "description" : "Specify the interfaces used by the bonding device.",
                                 "format" : "pve-iface-list",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "ovs_bridge" : {
                                 "description" : "The OVS bridge associated with a OVS port. This is required when you create an OVS port.",
                                 "format" : "pve-iface",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "ovs_options" : {
                                 "description" : "OVS interface options.",
                                 "maxLength" : 1024,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "ovs_ports" : {
                                 "description" : "Specify the iterfaces you want to add to your bridge.",
                                 "format" : "pve-iface-list",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "ovs_tag" : {
                                 "description" : "Specify a VLan tag (used by OVSPort, OVSIntPort, OVSBond)",
                                 "maximum" : 4094,
                                 "minimum" : 1,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (1-4094)"
                              },
                              "slaves" : {
                                 "description" : "Specify the interfaces used by the bonding device.",
                                 "format" : "pve-iface-list",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "type" : {
                                 "description" : "Network interface type",
                                 "enum" : [
                                    "bridge",
                                    "bond",
                                    "eth",
                                    "alias",
                                    "vlan",
                                    "OVSBridge",
                                    "OVSBond",
                                    "OVSPort",
                                    "OVSIntPort",
                                    "unknown"
                                 ],
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/nodes/{node}/network",
                  "text" : "network"
               },
               {
                  "children" : [
                     {
                        "children" : [
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Read task log.",
                                    "method" : "GET",
                                    "name" : "read_task_log",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "limit" : {
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "start" : {
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          },
                                          "upid" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "description" : "The user needs 'Sys.Audit' permissions on '/nodes/<node>' if the task does not belong to him.",
                                       "user" : "all"
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "items" : {
                                          "properties" : {
                                             "n" : {
                                                "description" : "Line number",
                                                "type" : "integer"
                                             },
                                             "t" : {
                                                "description" : "Line text",
                                                "type" : "string"
                                             }
                                          },
                                          "type" : "object"
                                       },
                                       "type" : "array"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/tasks/{upid}/log",
                              "text" : "log"
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Read task status.",
                                    "method" : "GET",
                                    "name" : "read_task_status",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "upid" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "description" : "The user needs 'Sys.Audit' permissions on '/nodes/<node>' if the task does not belong to him.",
                                       "user" : "all"
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "properties" : {
                                          "pid" : {
                                             "type" : "integer"
                                          },
                                          "status" : {
                                             "enum" : [
                                                "running",
                                                "stopped"
                                             ],
                                             "type" : "string"
                                          }
                                       },
                                       "type" : "object"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/tasks/{upid}/status",
                              "text" : "status"
                           }
                        ],
                        "info" : {
                           "DELETE" : {
                              "description" : "Stop a task.",
                              "method" : "DELETE",
                              "name" : "stop_task",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "upid" : {
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "description" : "The user needs 'Sys.Modify' permissions on '/nodes/<node>' if the task does not belong to him.",
                                 "user" : "all"
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "null"
                              }
                           },
                           "GET" : {
                              "description" : "",
                              "method" : "GET",
                              "name" : "upid_index",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "upid" : {
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "user" : "all"
                              },
                              "returns" : {
                                 "items" : {
                                    "properties" : {},
                                    "type" : "object"
                                 },
                                 "links" : [
                                    {
                                       "href" : "{name}",
                                       "rel" : "child"
                                    }
                                 ],
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 0,
                        "path" : "/nodes/{node}/tasks/{upid}",
                        "text" : "{upid}"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "Read task list for one node (finished tasks).",
                        "method" : "GET",
                        "name" : "node_tasks",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "errors" : {
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "limit" : {
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "start" : {
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "userfilter" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "vmid" : {
                                 "description" : "Only list tasks for this VM.",
                                 "format" : "pve-vmid",
                                 "minimum" : 1,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (1- N)"
                              }
                           }
                        },
                        "permissions" : {
                           "description" : "List task associated with the current user, or all task the user has 'Sys.Audit' permissions on /nodes/<node> (the <node> the task runs on).",
                           "user" : "all"
                        },
                        "proxyto" : "node",
                        "returns" : {
                           "items" : {
                              "properties" : {
                                 "upid" : {
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{upid}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/nodes/{node}/tasks",
                  "text" : "tasks"
               },
               {
                  "children" : [
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Scan zfs pool list on local node.",
                              "method" : "GET",
                              "name" : "zfsscan",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/storage",
                                    [
                                       "Datastore.Allocate"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "pool" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/scan/zfs",
                        "text" : "zfs"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Scan remote NFS server.",
                              "method" : "GET",
                              "name" : "nfsscan",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "server" : {
                                       "format" : "pve-storage-server",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/storage",
                                    [
                                       "Datastore.Allocate"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "options" : {
                                          "type" : "string"
                                       },
                                       "path" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/scan/nfs",
                        "text" : "nfs"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Scan remote GlusterFS server.",
                              "method" : "GET",
                              "name" : "glusterfsscan",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "server" : {
                                       "format" : "pve-storage-server",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/storage",
                                    [
                                       "Datastore.Allocate"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "volname" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/scan/glusterfs",
                        "text" : "glusterfs"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Scan remote iSCSI server.",
                              "method" : "GET",
                              "name" : "iscsiscan",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "portal" : {
                                       "format" : "pve-storage-portal-dns",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/storage",
                                    [
                                       "Datastore.Allocate"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "portal" : {
                                          "type" : "string"
                                       },
                                       "target" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/scan/iscsi",
                        "text" : "iscsi"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "List local LVM volume groups.",
                              "method" : "GET",
                              "name" : "lvmscan",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/storage",
                                    [
                                       "Datastore.Allocate"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "vg" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/scan/lvm",
                        "text" : "lvm"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "List local LVM Thin Pools.",
                              "method" : "GET",
                              "name" : "lvmthinscan",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "vg" : {
                                       "maxLength" : 100,
                                       "pattern" : "[a-zA-Z0-9\\.\\+\\_][a-zA-Z0-9\\.\\+\\_\\-]+",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/storage",
                                    [
                                       "Datastore.Allocate"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "lv" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/scan/lvmthin",
                        "text" : "lvmthin"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "List local USB devices.",
                              "method" : "GET",
                              "name" : "usbscan",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "busnum" : {
                                          "type" : "integer"
                                       },
                                       "class" : {
                                          "type" : "integer"
                                       },
                                       "devnum" : {
                                          "type" : "integer"
                                       },
                                       "level" : {
                                          "type" : "integer"
                                       },
                                       "manufacturer" : {
                                          "optional" : 1,
                                          "type" : "string"
                                       },
                                       "port" : {
                                          "type" : "integer"
                                       },
                                       "prodid" : {
                                          "type" : "string"
                                       },
                                       "product" : {
                                          "optional" : 1,
                                          "type" : "string"
                                       },
                                       "serial" : {
                                          "optional" : 1,
                                          "type" : "string"
                                       },
                                       "speed" : {
                                          "type" : "string"
                                       },
                                       "usbpath" : {
                                          "optional" : 1,
                                          "type" : "string"
                                       },
                                       "vendid" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/scan/usb",
                        "text" : "usb"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "Index of available scan methods",
                        "method" : "GET",
                        "name" : "index",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "user" : "all"
                        },
                        "returns" : {
                           "items" : {
                              "properties" : {
                                 "method" : {
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{method}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/nodes/{node}/scan",
                  "text" : "scan"
               },
               {
                  "children" : [
                     {
                        "children" : [
                           {
                              "children" : [
                                 {
                                    "info" : {
                                       "DELETE" : {
                                          "description" : "Delete volume",
                                          "method" : "DELETE",
                                          "name" : "delete",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "storage" : {
                                                   "description" : "The storage identifier.",
                                                   "format" : "pve-storage-id",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "volume" : {
                                                   "description" : "Volume identifier",
                                                   "type" : "string"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "description" : "You need 'Datastore.Allocate' privilege on the storage (or 'Datastore.AllocateSpace' for backup volumes if you have VM.Backup privilege on the VM).",
                                             "user" : "all"
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "null"
                                          }
                                       },
                                       "GET" : {
                                          "description" : "Get volume attributes",
                                          "method" : "GET",
                                          "name" : "info",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "storage" : {
                                                   "description" : "The storage identifier.",
                                                   "format" : "pve-storage-id",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "volume" : {
                                                   "description" : "Volume identifier",
                                                   "type" : "string"
                                                }
                                             }
                                          },
                                          "permissions" : {
                                             "description" : "You need read access for the volume.",
                                             "user" : "all"
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "object"
                                          }
                                       },
                                       "POST" : {
                                          "description" : "Copy a volume. This is experimental code - do not use.",
                                          "method" : "POST",
                                          "name" : "copy",
                                          "parameters" : {
                                             "additionalProperties" : 0,
                                             "properties" : {
                                                "node" : {
                                                   "description" : "The cluster node name.",
                                                   "format" : "pve-node",
                                                   "type" : "string"
                                                },
                                                "storage" : {
                                                   "description" : "The storage identifier.",
                                                   "format" : "pve-storage-id",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "target" : {
                                                   "description" : "Target volume identifier",
                                                   "type" : "string"
                                                },
                                                "target_node" : {
                                                   "description" : "Target node. Default is local node.",
                                                   "format" : "pve-node",
                                                   "optional" : 1,
                                                   "type" : "string"
                                                },
                                                "volume" : {
                                                   "description" : "Source volume identifier",
                                                   "type" : "string"
                                                }
                                             }
                                          },
                                          "protected" : 1,
                                          "proxyto" : "node",
                                          "returns" : {
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "leaf" : 1,
                                    "path" : "/nodes/{node}/storage/{storage}/content/{volume}",
                                    "text" : "{volume}"
                                 }
                              ],
                              "info" : {
                                 "GET" : {
                                    "description" : "List storage content.",
                                    "method" : "GET",
                                    "name" : "index",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "content" : {
                                             "description" : "Only list content of this type.",
                                             "format" : "pve-storage-content",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "storage" : {
                                             "description" : "The storage identifier.",
                                             "format" : "pve-storage-id",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "Only list images for this VM",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/storage/{storage}",
                                          [
                                             "Datastore.Audit",
                                             "Datastore.AllocateSpace"
                                          ],
                                          "any",
                                          1
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "items" : {
                                          "properties" : {
                                             "volid" : {
                                                "type" : "string"
                                             }
                                          },
                                          "type" : "object"
                                       },
                                       "links" : [
                                          {
                                             "href" : "{volid}",
                                             "rel" : "child"
                                          }
                                       ],
                                       "type" : "array"
                                    }
                                 },
                                 "POST" : {
                                    "description" : "Allocate disk images.",
                                    "method" : "POST",
                                    "name" : "create",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "filename" : {
                                             "description" : "The name of the file to create.",
                                             "type" : "string"
                                          },
                                          "format" : {
                                             "enum" : [
                                                "raw",
                                                "qcow2",
                                                "subvol"
                                             ],
                                             "optional" : 1,
                                             "requires" : "size",
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "size" : {
                                             "description" : "Size in kilobyte (1024 bytes). Optional suffixes 'M' (megabyte, 1024K) and 'G' (gigabyte, 1024M)",
                                             "pattern" : "\\d+[MG]?",
                                             "type" : "string"
                                          },
                                          "storage" : {
                                             "description" : "The storage identifier.",
                                             "format" : "pve-storage-id",
                                             "type" : "string"
                                          },
                                          "vmid" : {
                                             "description" : "Specify owner VM",
                                             "format" : "pve-vmid",
                                             "minimum" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (1- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/storage/{storage}",
                                          [
                                             "Datastore.AllocateSpace"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "description" : "Volume identifier",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 0,
                              "path" : "/nodes/{node}/storage/{storage}/content",
                              "text" : "content"
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Read storage status.",
                                    "method" : "GET",
                                    "name" : "read_status",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "storage" : {
                                             "description" : "The storage identifier.",
                                             "format" : "pve-storage-id",
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/storage/{storage}",
                                          [
                                             "Datastore.Audit",
                                             "Datastore.AllocateSpace"
                                          ],
                                          "any",
                                          1
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "properties" : {},
                                       "type" : "object"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/storage/{storage}/status",
                              "text" : "status"
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Read storage RRD statistics (returns PNG).",
                                    "method" : "GET",
                                    "name" : "rrd",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "cf" : {
                                             "description" : "The RRD consolidation function",
                                             "enum" : [
                                                "AVERAGE",
                                                "MAX"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "ds" : {
                                             "description" : "The list of datasources you want to display.",
                                             "format" : "pve-configid-list",
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "storage" : {
                                             "description" : "The storage identifier.",
                                             "format" : "pve-storage-id",
                                             "type" : "string"
                                          },
                                          "timeframe" : {
                                             "description" : "Specify the time frame you are interested in.",
                                             "enum" : [
                                                "hour",
                                                "day",
                                                "week",
                                                "month",
                                                "year"
                                             ],
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/storage/{storage}",
                                          [
                                             "Datastore.Audit",
                                             "Datastore.AllocateSpace"
                                          ],
                                          "any",
                                          1
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "properties" : {
                                          "filename" : {
                                             "type" : "string"
                                          }
                                       },
                                       "type" : "object"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/storage/{storage}/rrd",
                              "text" : "rrd"
                           },
                           {
                              "info" : {
                                 "GET" : {
                                    "description" : "Read storage RRD statistics.",
                                    "method" : "GET",
                                    "name" : "rrddata",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "cf" : {
                                             "description" : "The RRD consolidation function",
                                             "enum" : [
                                                "AVERAGE",
                                                "MAX"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "storage" : {
                                             "description" : "The storage identifier.",
                                             "format" : "pve-storage-id",
                                             "type" : "string"
                                          },
                                          "timeframe" : {
                                             "description" : "Specify the time frame you are interested in.",
                                             "enum" : [
                                                "hour",
                                                "day",
                                                "week",
                                                "month",
                                                "year"
                                             ],
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/storage/{storage}",
                                          [
                                             "Datastore.Audit",
                                             "Datastore.AllocateSpace"
                                          ],
                                          "any",
                                          1
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "items" : {
                                          "properties" : {},
                                          "type" : "object"
                                       },
                                       "type" : "array"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/storage/{storage}/rrddata",
                              "text" : "rrddata"
                           },
                           {
                              "info" : {
                                 "POST" : {
                                    "description" : "Upload templates and ISO images.",
                                    "method" : "POST",
                                    "name" : "upload",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "content" : {
                                             "description" : "Content type.",
                                             "format" : "pve-storage-content",
                                             "type" : "string"
                                          },
                                          "filename" : {
                                             "description" : "The name of the file to create.",
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "storage" : {
                                             "description" : "The storage identifier.",
                                             "format" : "pve-storage-id",
                                             "type" : "string"
                                          },
                                          "tmpfilename" : {
                                             "description" : "The source file name. This parameter is usually set by the REST handler. You can only overwrite it when connecting to the trustet port on localhost.",
                                             "optional" : 1,
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/storage/{storage}",
                                          [
                                             "Datastore.AllocateTemplate"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "returns" : {
                                       "type" : "string"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/storage/{storage}/upload",
                              "text" : "upload"
                           }
                        ],
                        "info" : {
                           "GET" : {
                              "description" : "",
                              "method" : "GET",
                              "name" : "diridx",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "storage" : {
                                       "description" : "The storage identifier.",
                                       "format" : "pve-storage-id",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/storage/{storage}",
                                    [
                                       "Datastore.Audit",
                                       "Datastore.AllocateSpace"
                                    ],
                                    "any",
                                    1
                                 ]
                              },
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "subdir" : {
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "links" : [
                                    {
                                       "href" : "{subdir}",
                                       "rel" : "child"
                                    }
                                 ],
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 0,
                        "path" : "/nodes/{node}/storage/{storage}",
                        "text" : "{storage}"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "Get status for all datastores.",
                        "method" : "GET",
                        "name" : "index",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "content" : {
                                 "description" : "Only list stores which support this content type.",
                                 "format" : "pve-storage-content-list",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "enabled" : {
                                 "default" : 0,
                                 "description" : "Only list stores which are enabled (not disabled in config).",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "storage" : {
                                 "description" : "Only list status for  specified storage",
                                 "format" : "pve-storage-id",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "target" : {
                                 "description" : "If target is different to 'node', we only lists shared storages which content is accessible on this 'node' and the specified 'target' node.",
                                 "format" : "pve-node",
                                 "optional" : 1,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "description" : "Only list entries where you have 'Datastore.Audit' or 'Datastore.AllocateSpace' permissions on '/storage/<storage>'",
                           "user" : "all"
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "items" : {
                              "properties" : {
                                 "storage" : {
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{storage}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/nodes/{node}/storage",
                  "text" : "storage"
               },
               {
                  "children" : [
                     {
                        "info" : {
                           "GET" : {
                              "description" : "List available updates.",
                              "method" : "GET",
                              "name" : "list_updates",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {},
                                    "type" : "object"
                                 },
                                 "type" : "array"
                              }
                           },
                           "POST" : {
                              "description" : "This is used to resynchronize the package index files from their sources (apt-get update).",
                              "method" : "POST",
                              "name" : "update_database",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "notify" : {
                                       "default" : 0,
                                       "description" : "Send notification mail about new packages (to email address specified for user 'root@pam').",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "quiet" : {
                                       "default" : 0,
                                       "description" : "Only produces output suitable for logging, omitting progress indicators.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "string"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/apt/update",
                        "text" : "update"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Get package changelogs.",
                              "method" : "GET",
                              "name" : "changelog",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "name" : {
                                       "description" : "Package name.",
                                       "type" : "string"
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "version" : {
                                       "description" : "Package version.",
                                       "optional" : 1,
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "string"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/apt/changelog",
                        "text" : "changelog"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Get package information for important Proxmox packages.",
                              "method" : "GET",
                              "name" : "versions",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {},
                                    "type" : "object"
                                 },
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/apt/versions",
                        "text" : "versions"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "Directory index for apt (Advanced Package Tool).",
                        "method" : "GET",
                        "name" : "index",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "user" : "all"
                        },
                        "returns" : {
                           "items" : {
                              "properties" : {
                                 "id" : {
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{id}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/nodes/{node}/apt",
                  "text" : "apt"
               },
               {
                  "children" : [
                     {
                        "children" : [
                           {
                              "info" : {
                                 "DELETE" : {
                                    "description" : "Delete rule.",
                                    "method" : "DELETE",
                                    "name" : "delete_rule",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "digest" : {
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "pos" : {
                                             "description" : "Update rule at position <pos>.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 },
                                 "GET" : {
                                    "description" : "Get single rule data.",
                                    "method" : "GET",
                                    "name" : "get_rule",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "pos" : {
                                             "description" : "Update rule at position <pos>.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Audit"
                                          ]
                                       ]
                                    },
                                    "proxyto" : "node",
                                    "returns" : {
                                       "properties" : {
                                          "pos" : {
                                             "type" : "integer"
                                          }
                                       },
                                       "type" : "object"
                                    }
                                 },
                                 "PUT" : {
                                    "description" : "Modify rule data.",
                                    "method" : "PUT",
                                    "name" : "update_rule",
                                    "parameters" : {
                                       "additionalProperties" : 0,
                                       "properties" : {
                                          "action" : {
                                             "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                             "maxLength" : 20,
                                             "minLength" : 2,
                                             "optional" : 1,
                                             "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                             "type" : "string"
                                          },
                                          "comment" : {
                                             "description" : "Descriptive comment.",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "delete" : {
                                             "description" : "A list of settings you want to delete.",
                                             "format" : "pve-configid-list",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "dest" : {
                                             "description" : "Restrict packet destination address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                             "format" : "pve-fw-addr-spec",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "digest" : {
                                             "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                             "maxLength" : 40,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "dport" : {
                                             "description" : "Restrict TCP/UDP destination port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                             "format" : "pve-fw-dport-spec",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "enable" : {
                                             "description" : "Flag to enable/disable a rule.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          },
                                          "iface" : {
                                             "description" : "Network interface name. You have to use network configuration key names for VMs and containers ('net\\d+'). Host related rules can use arbitrary strings.",
                                             "format" : "pve-iface",
                                             "maxLength" : 20,
                                             "minLength" : 2,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "macro" : {
                                             "description" : "Use predefined standard macro.",
                                             "maxLength" : 128,
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "moveto" : {
                                             "description" : "Move rule to new position <moveto>. Other arguments are ignored.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          },
                                          "node" : {
                                             "description" : "The cluster node name.",
                                             "format" : "pve-node",
                                             "type" : "string"
                                          },
                                          "pos" : {
                                             "description" : "Update rule at position <pos>.",
                                             "minimum" : 0,
                                             "optional" : 1,
                                             "type" : "integer",
                                             "typetext" : "integer (0- N)"
                                          },
                                          "proto" : {
                                             "description" : "IP protocol. You can use protocol names ('tcp'/'udp') or simple numbers, as defined in '/etc/protocols'.",
                                             "format" : "pve-fw-protocol-spec",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "source" : {
                                             "description" : "Restrict packet source address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                             "format" : "pve-fw-addr-spec",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "sport" : {
                                             "description" : "Restrict TCP/UDP source port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                             "format" : "pve-fw-sport-spec",
                                             "optional" : 1,
                                             "type" : "string"
                                          },
                                          "type" : {
                                             "description" : "Rule type.",
                                             "enum" : [
                                                "in",
                                                "out",
                                                "group"
                                             ],
                                             "optional" : 1,
                                             "type" : "string"
                                          }
                                       }
                                    },
                                    "permissions" : {
                                       "check" : [
                                          "perm",
                                          "/nodes/{node}",
                                          [
                                             "Sys.Modify"
                                          ]
                                       ]
                                    },
                                    "protected" : 1,
                                    "proxyto" : "node",
                                    "returns" : {
                                       "type" : "null"
                                    }
                                 }
                              },
                              "leaf" : 1,
                              "path" : "/nodes/{node}/firewall/rules/{pos}",
                              "text" : "{pos}"
                           }
                        ],
                        "info" : {
                           "GET" : {
                              "description" : "List rules.",
                              "method" : "GET",
                              "name" : "get_rules",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "pos" : {
                                          "type" : "integer"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "links" : [
                                    {
                                       "href" : "{pos}",
                                       "rel" : "child"
                                    }
                                 ],
                                 "type" : "array"
                              }
                           },
                           "POST" : {
                              "description" : "Create new rule.",
                              "method" : "POST",
                              "name" : "create_rule",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "action" : {
                                       "description" : "Rule action ('ACCEPT', 'DROP', 'REJECT') or security group name.",
                                       "maxLength" : 20,
                                       "minLength" : 2,
                                       "optional" : 0,
                                       "pattern" : "[A-Za-z][A-Za-z0-9\\-\\_]+",
                                       "type" : "string"
                                    },
                                    "comment" : {
                                       "description" : "Descriptive comment.",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "dest" : {
                                       "description" : "Restrict packet destination address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                       "format" : "pve-fw-addr-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "digest" : {
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "maxLength" : 40,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "dport" : {
                                       "description" : "Restrict TCP/UDP destination port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                       "format" : "pve-fw-dport-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "enable" : {
                                       "description" : "Flag to enable/disable a rule.",
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0- N)"
                                    },
                                    "iface" : {
                                       "description" : "Network interface name. You have to use network configuration key names for VMs and containers ('net\\d+'). Host related rules can use arbitrary strings.",
                                       "format" : "pve-iface",
                                       "maxLength" : 20,
                                       "minLength" : 2,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "macro" : {
                                       "description" : "Use predefined standard macro.",
                                       "maxLength" : 128,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "pos" : {
                                       "description" : "Update rule at position <pos>.",
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0- N)"
                                    },
                                    "proto" : {
                                       "description" : "IP protocol. You can use protocol names ('tcp'/'udp') or simple numbers, as defined in '/etc/protocols'.",
                                       "format" : "pve-fw-protocol-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "source" : {
                                       "description" : "Restrict packet source address. This can refer to a single IP address, an IP set ('+ipsetname') or an IP alias definition. You can also specify an address range like '20.34.101.207-201.3.9.99', or a list of IP addresses and networks (entries are separated by comma). Please do not mix IPv4 and IPv6 addresses inside such lists.",
                                       "format" : "pve-fw-addr-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "sport" : {
                                       "description" : "Restrict TCP/UDP source port. You can use service names or simple numbers (0-65535), as defined in '/etc/services'. Port ranges can be specified with '\\d+:\\d+', for example '80:85', and you can use comma separated list to match several ports or ranges.",
                                       "format" : "pve-fw-sport-spec",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "type" : {
                                       "description" : "Rule type.",
                                       "enum" : [
                                          "in",
                                          "out",
                                          "group"
                                       ],
                                       "optional" : 0,
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "null"
                              }
                           }
                        },
                        "leaf" : 0,
                        "path" : "/nodes/{node}/firewall/rules",
                        "text" : "rules"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Get host firewall options.",
                              "method" : "GET",
                              "name" : "get_options",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Audit"
                                    ]
                                 ]
                              },
                              "proxyto" : "node",
                              "returns" : {
                                 "properties" : {
                                    "enable" : {
                                       "description" : "Enable host firewall rules.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "log_level_in" : {
                                       "description" : "Log level for incoming traffic.",
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "log_level_out" : {
                                       "description" : "Log level for outgoing traffic.",
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "ndp" : {
                                       "description" : "Enable NDP.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "nf_conntrack_max" : {
                                       "description" : "Maximum number of tracked connections.",
                                       "minimum" : 32768,
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "nf_conntrack_tcp_timeout_established" : {
                                       "description" : "Conntrack established timeout.",
                                       "minimum" : 7875,
                                       "optional" : 1,
                                       "type" : "integer"
                                    },
                                    "nosmurfs" : {
                                       "description" : "Enable SMURFS filter.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "smurf_log_level" : {
                                       "description" : "Log level for SMURFS filter.",
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "tcp_flags_log_level" : {
                                       "description" : "Log level for illegal tcp flags filter.",
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "tcpflags" : {
                                       "description" : "Filter illegal combinations of TCP flags.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    }
                                 },
                                 "type" : "object"
                              }
                           },
                           "PUT" : {
                              "description" : "Set Firewall options.",
                              "method" : "PUT",
                              "name" : "set_options",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "delete" : {
                                       "description" : "A list of settings you want to delete.",
                                       "format" : "pve-configid-list",
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "digest" : {
                                       "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                       "maxLength" : 40,
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "enable" : {
                                       "description" : "Enable host firewall rules.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "log_level_in" : {
                                       "description" : "Log level for incoming traffic.",
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "log_level_out" : {
                                       "description" : "Log level for outgoing traffic.",
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "ndp" : {
                                       "description" : "Enable NDP.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "nf_conntrack_max" : {
                                       "description" : "Maximum number of tracked connections.",
                                       "minimum" : 32768,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (32768- N)"
                                    },
                                    "nf_conntrack_tcp_timeout_established" : {
                                       "description" : "Conntrack established timeout.",
                                       "minimum" : 7875,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (7875- N)"
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "nosmurfs" : {
                                       "description" : "Enable SMURFS filter.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    },
                                    "smurf_log_level" : {
                                       "description" : "Log level for SMURFS filter.",
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "tcp_flags_log_level" : {
                                       "description" : "Log level for illegal tcp flags filter.",
                                       "enum" : [
                                          "emerg",
                                          "alert",
                                          "crit",
                                          "err",
                                          "warning",
                                          "notice",
                                          "info",
                                          "debug",
                                          "nolog"
                                       ],
                                       "optional" : 1,
                                       "type" : "string"
                                    },
                                    "tcpflags" : {
                                       "description" : "Filter illegal combinations of TCP flags.",
                                       "optional" : 1,
                                       "type" : "boolean"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Modify"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "type" : "null"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/firewall/options",
                        "text" : "options"
                     },
                     {
                        "info" : {
                           "GET" : {
                              "description" : "Read firewall log",
                              "method" : "GET",
                              "name" : "log",
                              "parameters" : {
                                 "additionalProperties" : 0,
                                 "properties" : {
                                    "limit" : {
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0- N)"
                                    },
                                    "node" : {
                                       "description" : "The cluster node name.",
                                       "format" : "pve-node",
                                       "type" : "string"
                                    },
                                    "start" : {
                                       "minimum" : 0,
                                       "optional" : 1,
                                       "type" : "integer",
                                       "typetext" : "integer (0- N)"
                                    }
                                 }
                              },
                              "permissions" : {
                                 "check" : [
                                    "perm",
                                    "/nodes/{node}",
                                    [
                                       "Sys.Syslog"
                                    ]
                                 ]
                              },
                              "protected" : 1,
                              "proxyto" : "node",
                              "returns" : {
                                 "items" : {
                                    "properties" : {
                                       "n" : {
                                          "description" : "Line number",
                                          "type" : "integer"
                                       },
                                       "t" : {
                                          "description" : "Line text",
                                          "type" : "string"
                                       }
                                    },
                                    "type" : "object"
                                 },
                                 "type" : "array"
                              }
                           }
                        },
                        "leaf" : 1,
                        "path" : "/nodes/{node}/firewall/log",
                        "text" : "log"
                     }
                  ],
                  "info" : {
                     "GET" : {
                        "description" : "Directory index.",
                        "method" : "GET",
                        "name" : "index",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "user" : "all"
                        },
                        "returns" : {
                           "items" : {
                              "properties" : {},
                              "type" : "object"
                           },
                           "links" : [
                              {
                                 "href" : "{name}",
                                 "rel" : "child"
                              }
                           ],
                           "type" : "array"
                        }
                     }
                  },
                  "leaf" : 0,
                  "path" : "/nodes/{node}/firewall",
                  "text" : "firewall"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "API version details",
                        "method" : "GET",
                        "name" : "version",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "user" : "all"
                        },
                        "proxyto" : "node",
                        "returns" : {
                           "properties" : {
                              "release" : {
                                 "type" : "string"
                              },
                              "repoid" : {
                                 "type" : "string"
                              },
                              "version" : {
                                 "type" : "string"
                              }
                           },
                           "type" : "object"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/version",
                  "text" : "version"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "Read node status",
                        "method" : "GET",
                        "name" : "status",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "proxyto" : "node",
                        "returns" : {
                           "properties" : {},
                           "type" : "object"
                        }
                     },
                     "POST" : {
                        "description" : "Reboot or shutdown a node.",
                        "method" : "POST",
                        "name" : "node_cmd",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "command" : {
                                 "description" : "Specify the command.",
                                 "enum" : [
                                    "reboot",
                                    "shutdown"
                                 ],
                                 "type" : "string"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.PowerMgmt"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/status",
                  "text" : "status"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "Read tap/vm network device interface counters",
                        "method" : "GET",
                        "name" : "netstat",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "proxyto" : "node",
                        "returns" : {
                           "items" : {
                              "properties" : {},
                              "type" : "object"
                           },
                           "type" : "array"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/netstat",
                  "text" : "netstat"
               },
               {
                  "info" : {
                     "POST" : {
                        "description" : "Execute multiple commands in order.",
                        "method" : "POST",
                        "name" : "execute",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "commands" : {
                                 "description" : "JSON encoded array of commands.",
                                 "type" : "string"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "properties" : {},
                           "type" : "array"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/execute",
                  "text" : "execute"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "Read node RRD statistics (returns PNG)",
                        "method" : "GET",
                        "name" : "rrd",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "cf" : {
                                 "description" : "The RRD consolidation function",
                                 "enum" : [
                                    "AVERAGE",
                                    "MAX"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "ds" : {
                                 "description" : "The list of datasources you want to display.",
                                 "format" : "pve-configid-list",
                                 "type" : "string"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "timeframe" : {
                                 "description" : "Specify the time frame you are interested in.",
                                 "enum" : [
                                    "hour",
                                    "day",
                                    "week",
                                    "month",
                                    "year"
                                 ],
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "properties" : {
                              "filename" : {
                                 "type" : "string"
                              }
                           },
                           "type" : "object"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/rrd",
                  "text" : "rrd"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "Read node RRD statistics",
                        "method" : "GET",
                        "name" : "rrddata",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "cf" : {
                                 "description" : "The RRD consolidation function",
                                 "enum" : [
                                    "AVERAGE",
                                    "MAX"
                                 ],
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "timeframe" : {
                                 "description" : "Specify the time frame you are interested in.",
                                 "enum" : [
                                    "hour",
                                    "day",
                                    "week",
                                    "month",
                                    "year"
                                 ],
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "items" : {
                              "properties" : {},
                              "type" : "object"
                           },
                           "type" : "array"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/rrddata",
                  "text" : "rrddata"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "Read system log",
                        "method" : "GET",
                        "name" : "syslog",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "limit" : {
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "since" : {
                                 "description" : "Display all log since this date-time string.",
                                 "optional" : 1,
                                 "pattern" : "^\\d{4}-\\d{2}-\\d{2}( \\d{2}:\\d{2}(:\\d{2})?)?$",
                                 "type" : "string"
                              },
                              "start" : {
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "until" : {
                                 "description" : "Display all log until this date-time string.",
                                 "optional" : 1,
                                 "pattern" : "^\\d{4}-\\d{2}-\\d{2}( \\d{2}:\\d{2}(:\\d{2})?)?$",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Syslog"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "items" : {
                              "properties" : {
                                 "n" : {
                                    "description" : "Line number",
                                    "type" : "integer"
                                 },
                                 "t" : {
                                    "description" : "Line text",
                                    "type" : "string"
                                 }
                              },
                              "type" : "object"
                           },
                           "type" : "array"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/syslog",
                  "text" : "syslog"
               },
               {
                  "info" : {
                     "POST" : {
                        "description" : "Creates a VNC Shell proxy.",
                        "method" : "POST",
                        "name" : "vncshell",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "upgrade" : {
                                 "default" : 0,
                                 "description" : "Run 'apt-get dist-upgrade' instead of normal shell.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "websocket" : {
                                 "description" : "use websocket instead of standard vnc.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Console"
                              ]
                           ],
                           "description" : "Restricted to users on realm 'pam'"
                        },
                        "protected" : 1,
                        "returns" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "cert" : {
                                 "type" : "string"
                              },
                              "port" : {
                                 "type" : "integer"
                              },
                              "ticket" : {
                                 "type" : "string"
                              },
                              "upid" : {
                                 "type" : "string"
                              },
                              "user" : {
                                 "type" : "string"
                              }
                           }
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/vncshell",
                  "text" : "vncshell"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "Opens a weksocket for VNC traffic.",
                        "method" : "GET",
                        "name" : "vncwebsocket",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "port" : {
                                 "description" : "Port number returned by previous vncproxy call.",
                                 "maximum" : 5999,
                                 "minimum" : 5900,
                                 "type" : "integer",
                                 "typetext" : "integer (5900-5999)"
                              },
                              "vncticket" : {
                                 "description" : "Ticket from previous call to vncproxy.",
                                 "maxLength" : 512,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Console"
                              ]
                           ],
                           "description" : "Restricted to users on realm 'pam'. You also need to pass a valid ticket (vncticket)."
                        },
                        "returns" : {
                           "properties" : {
                              "port" : {
                                 "type" : "string"
                              }
                           },
                           "type" : "object"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/vncwebsocket",
                  "text" : "vncwebsocket"
               },
               {
                  "info" : {
                     "POST" : {
                        "description" : "Creates a SPICE shell.",
                        "method" : "POST",
                        "name" : "spiceshell",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "proxy" : {
                                 "description" : "SPICE proxy server. This can be used by the client to specify the proxy server. All nodes in a cluster runs 'spiceproxy', so it is up to the client to choose one. By default, we return the node where the VM is currently running. As resonable setting is to use same node you use to connect to the API (This is window.location.hostname for the JS GUI).",
                                 "format" : "address",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "upgrade" : {
                                 "default" : 0,
                                 "description" : "Run 'apt-get dist-upgrade' instead of normal shell.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Console"
                              ]
                           ],
                           "description" : "Restricted to users on realm 'pam'"
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "additionalProperties" : 1,
                           "description" : "Returned values can be directly passed to the 'remote-viewer' application.",
                           "properties" : {
                              "host" : {
                                 "type" : "string"
                              },
                              "password" : {
                                 "type" : "string"
                              },
                              "proxy" : {
                                 "type" : "string"
                              },
                              "tls-port" : {
                                 "type" : "integer"
                              },
                              "type" : {
                                 "type" : "string"
                              }
                           }
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/spiceshell",
                  "text" : "spiceshell"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "Read DNS settings.",
                        "method" : "GET",
                        "name" : "dns",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "proxyto" : "node",
                        "returns" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "dns1" : {
                                 "description" : "First name server IP address.",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "dns2" : {
                                 "description" : "Second name server IP address.",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "dns3" : {
                                 "description" : "Third name server IP address.",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "search" : {
                                 "description" : "Search domain for host-name lookup.",
                                 "optional" : 1,
                                 "type" : "string"
                              }
                           },
                           "type" : "object"
                        }
                     },
                     "PUT" : {
                        "description" : "Write DNS settings.",
                        "method" : "PUT",
                        "name" : "update_dns",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "dns1" : {
                                 "description" : "First name server IP address.",
                                 "format" : "ip",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "dns2" : {
                                 "description" : "Second name server IP address.",
                                 "format" : "ip",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "dns3" : {
                                 "description" : "Third name server IP address.",
                                 "format" : "ip",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "search" : {
                                 "description" : "Search domain for host-name lookup.",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/dns",
                  "text" : "dns"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "Read server time and time zone settings.",
                        "method" : "GET",
                        "name" : "time",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "proxyto" : "node",
                        "returns" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "localtime" : {
                                 "description" : "Seconds since 1970-01-01 00:00:00 (local time)",
                                 "minimum" : 1297163644,
                                 "type" : "integer"
                              },
                              "time" : {
                                 "description" : "Seconds since 1970-01-01 00:00:00 UTC.",
                                 "minimum" : 1297163644,
                                 "type" : "integer"
                              },
                              "timezone" : {
                                 "description" : "Time zone",
                                 "type" : "string"
                              }
                           },
                           "type" : "object"
                        }
                     },
                     "PUT" : {
                        "description" : "Set time zone.",
                        "method" : "PUT",
                        "name" : "set_timezone",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "timezone" : {
                                 "description" : "Time zone. The file '/usr/share/zoneinfo/zone.tab' contains the list of valid names.",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/time",
                  "text" : "time"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "Get list of appliances.",
                        "method" : "GET",
                        "name" : "aplinfo",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "user" : "all"
                        },
                        "proxyto" : "node",
                        "returns" : {
                           "items" : {
                              "properties" : {},
                              "type" : "object"
                           },
                           "type" : "array"
                        }
                     },
                     "POST" : {
                        "description" : "Download appliance templates.",
                        "method" : "POST",
                        "name" : "apl_download",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "storage" : {
                                 "description" : "The storage where the template will be stored",
                                 "format" : "pve-storage-id",
                                 "type" : "string"
                              },
                              "template" : {
                                 "description" : "The template wich will downloaded",
                                 "maxLength" : 255,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/storage/{storage}",
                              [
                                 "Datastore.AllocateTemplate"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "string"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/aplinfo",
                  "text" : "aplinfo"
               },
               {
                  "info" : {
                     "GET" : {
                        "description" : "Gather various systems information about a node",
                        "method" : "GET",
                        "name" : "report",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/nodes/{node}",
                              [
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "string"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/report",
                  "text" : "report"
               },
               {
                  "info" : {
                     "POST" : {
                        "description" : "Start all VMs and containers (when onboot=1).",
                        "method" : "POST",
                        "name" : "startall",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "force" : {
                                 "description" : "force if onboot=0.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "VM.PowerMgmt"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "string"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/startall",
                  "text" : "startall"
               },
               {
                  "info" : {
                     "POST" : {
                        "description" : "Stop all VMs and Containers.",
                        "method" : "POST",
                        "name" : "stopall",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "VM.PowerMgmt"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "string"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/stopall",
                  "text" : "stopall"
               },
               {
                  "info" : {
                     "POST" : {
                        "description" : "Migrate all VMs and Containers.",
                        "method" : "POST",
                        "name" : "migrateall",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "maxworkers" : {
                                 "description" : "Maximal number of parallel migration job. If not set use 'max_workers' from datacenter.cfg, one of both must be set!",
                                 "minimum" : 1,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (1- N)"
                              },
                              "node" : {
                                 "description" : "The cluster node name.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              },
                              "target" : {
                                 "description" : "Target node.",
                                 "format" : "pve-node",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/",
                              [
                                 "VM.Migrate"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "proxyto" : "node",
                        "returns" : {
                           "type" : "string"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/nodes/{node}/migrateall",
                  "text" : "migrateall"
               }
            ],
            "info" : {
               "GET" : {
                  "description" : "Node index.",
                  "method" : "GET",
                  "name" : "index",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "node" : {
                           "description" : "The cluster node name.",
                           "format" : "pve-node",
                           "type" : "string"
                        }
                     }
                  },
                  "permissions" : {
                     "user" : "all"
                  },
                  "returns" : {
                     "items" : {
                        "properties" : {},
                        "type" : "object"
                     },
                     "links" : [
                        {
                           "href" : "{name}",
                           "rel" : "child"
                        }
                     ],
                     "type" : "array"
                  }
               }
            },
            "leaf" : 0,
            "path" : "/nodes/{node}",
            "text" : "{node}"
         }
      ],
      "info" : {
         "GET" : {
            "description" : "Cluster node index.",
            "method" : "GET",
            "name" : "index",
            "parameters" : {
               "additionalProperties" : 0
            },
            "permissions" : {
               "user" : "all"
            },
            "returns" : {
               "items" : {
                  "properties" : {},
                  "type" : "object"
               },
               "links" : [
                  {
                     "href" : "{node}",
                     "rel" : "child"
                  }
               ],
               "type" : "array"
            }
         }
      },
      "leaf" : 0,
      "path" : "/nodes",
      "text" : "nodes"
   },
   {
      "children" : [
         {
            "info" : {
               "DELETE" : {
                  "description" : "Delete storage configuration.",
                  "method" : "DELETE",
                  "name" : "delete",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "storage" : {
                           "description" : "The storage identifier.",
                           "format" : "pve-storage-id",
                           "type" : "string"
                        }
                     }
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/storage",
                        [
                           "Datastore.Allocate"
                        ]
                     ]
                  },
                  "protected" : 1,
                  "returns" : {
                     "type" : "null"
                  }
               },
               "GET" : {
                  "description" : "Read storage configuration.",
                  "method" : "GET",
                  "name" : "read",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "storage" : {
                           "description" : "The storage identifier.",
                           "format" : "pve-storage-id",
                           "type" : "string"
                        }
                     }
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/storage/{storage}",
                        [
                           "Datastore.Allocate"
                        ]
                     ]
                  },
                  "returns" : {}
               },
               "PUT" : {
                  "description" : "Update storage configuration.",
                  "method" : "PUT",
                  "name" : "update",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "blocksize" : {
                           "description" : "block size",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "comstar_hg" : {
                           "description" : "host group for comstar views",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "comstar_tg" : {
                           "description" : "target group for comstar views",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "content" : {
                           "description" : "Allowed content types.\n\nNOTE: the value 'rootdir' is used for Containers, and value 'images' for VMs.\n",
                           "format" : "pve-storage-content-list",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "delete" : {
                           "description" : "A list of settings you want to delete.",
                           "format" : "pve-configid-list",
                           "maxLength" : 4096,
                           "optional" : 1,
                           "type" : "string"
                        },
                        "digest" : {
                           "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                           "maxLength" : 40,
                           "optional" : 1,
                           "type" : "string"
                        },
                        "disable" : {
                           "description" : "Flag to disable the storage.",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "format" : {
                           "description" : "Default image format.",
                           "format" : "pve-storage-format",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "krbd" : {
                           "description" : "Access rbd through krbd kernel module.",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "maxfiles" : {
                           "description" : "Maximal number of backup files per VM. Use '0' for unlimted.",
                           "minimum" : 0,
                           "optional" : 1,
                           "type" : "integer",
                           "typetext" : "integer (0- N)"
                        },
                        "mkdir" : {
                           "default" : "yes",
                           "description" : "Create the directory if it doesn't exist.",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "nodes" : {
                           "description" : "List of cluster node names.",
                           "format" : "pve-node-list",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "nowritecache" : {
                           "description" : "disable write caching on the target",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "options" : {
                           "description" : "NFS mount options (see 'man nfs')",
                           "format" : "pve-storage-options",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "pool" : {
                           "description" : "Pool.",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "redundancy" : {
                           "default" : 2,
                           "description" : "The redundancy count specifies the number of nodes to which the resource should be deployed. It must be at least 1 and at most the number of nodes in the cluster.",
                           "maximum" : 16,
                           "minimum" : 1,
                           "optional" : 1,
                           "type" : "integer",
                           "typetext" : "integer (1-16)"
                        },
                        "saferemove" : {
                           "description" : "Zero-out data when removing LVs.",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "saferemove_throughput" : {
                           "description" : "Wipe throughput (cstream -t parameter value).",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "server" : {
                           "description" : "Server IP or DNS name.",
                           "format" : "pve-storage-server",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "server2" : {
                           "description" : "Backup volfile server IP or DNS name.",
                           "format" : "pve-storage-server",
                           "optional" : 1,
                           "requires" : "server",
                           "type" : "string"
                        },
                        "shared" : {
                           "description" : "Mark storage as shared.",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "sparse" : {
                           "description" : "use sparse volumes",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "storage" : {
                           "description" : "The storage identifier.",
                           "format" : "pve-storage-id",
                           "type" : "string"
                        },
                        "tagged_only" : {
                           "description" : "Only use logical volumes tagged with 'pve-vm-ID'.",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "transport" : {
                           "description" : "Gluster transport: tcp or rdma",
                           "enum" : [
                              "tcp",
                              "rdma",
                              "unix"
                           ],
                           "optional" : 1,
                           "type" : "string"
                        },
                        "username" : {
                           "description" : "RBD Id.",
                           "optional" : 1,
                           "type" : "string"
                        }
                     },
                     "type" : "object"
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/storage",
                        [
                           "Datastore.Allocate"
                        ]
                     ]
                  },
                  "protected" : 1,
                  "returns" : {
                     "type" : "null"
                  }
               }
            },
            "leaf" : 1,
            "path" : "/storage/{storage}",
            "text" : "{storage}"
         }
      ],
      "info" : {
         "GET" : {
            "description" : "Storage index.",
            "method" : "GET",
            "name" : "index",
            "parameters" : {
               "additionalProperties" : 0,
               "properties" : {
                  "type" : {
                     "description" : "Only list storage of specific type",
                     "enum" : [
                        "dir",
                        "drbd",
                        "glusterfs",
                        "iscsi",
                        "iscsidirect",
                        "lvm",
                        "lvmthin",
                        "nfs",
                        "rbd",
                        "sheepdog",
                        "zfs",
                        "zfspool"
                     ],
                     "optional" : 1,
                     "type" : "string"
                  }
               }
            },
            "permissions" : {
               "description" : "Only list entries where you have 'Datastore.Audit' or 'Datastore.AllocateSpace' permissions on '/storage/<storage>'",
               "user" : "all"
            },
            "returns" : {
               "items" : {
                  "properties" : {
                     "storage" : {
                        "type" : "string"
                     }
                  },
                  "type" : "object"
               },
               "links" : [
                  {
                     "href" : "{storage}",
                     "rel" : "child"
                  }
               ],
               "type" : "array"
            }
         },
         "POST" : {
            "description" : "Create a new storage.",
            "method" : "POST",
            "name" : "create",
            "parameters" : {
               "additionalProperties" : 0,
               "properties" : {
                  "authsupported" : {
                     "description" : "Authsupported.",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "base" : {
                     "description" : "Base volume. This volume is automatically activated.",
                     "format" : "pve-volume-id",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "blocksize" : {
                     "description" : "block size",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "comstar_hg" : {
                     "description" : "host group for comstar views",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "comstar_tg" : {
                     "description" : "target group for comstar views",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "content" : {
                     "description" : "Allowed content types.\n\nNOTE: the value 'rootdir' is used for Containers, and value 'images' for VMs.\n",
                     "format" : "pve-storage-content-list",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "disable" : {
                     "description" : "Flag to disable the storage.",
                     "optional" : 1,
                     "type" : "boolean"
                  },
                  "export" : {
                     "description" : "NFS export path.",
                     "format" : "pve-storage-path",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "format" : {
                     "description" : "Default image format.",
                     "format" : "pve-storage-format",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "iscsiprovider" : {
                     "description" : "iscsi provider",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "krbd" : {
                     "description" : "Access rbd through krbd kernel module.",
                     "optional" : 1,
                     "type" : "boolean"
                  },
                  "maxfiles" : {
                     "description" : "Maximal number of backup files per VM. Use '0' for unlimted.",
                     "minimum" : 0,
                     "optional" : 1,
                     "type" : "integer",
                     "typetext" : "integer (0- N)"
                  },
                  "mkdir" : {
                     "default" : "yes",
                     "description" : "Create the directory if it doesn't exist.",
                     "optional" : 1,
                     "type" : "boolean"
                  },
                  "monhost" : {
                     "description" : "Monitors daemon ips.",
                     "format" : "pve-storage-portal-dns-list",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "nodes" : {
                     "description" : "List of cluster node names.",
                     "format" : "pve-node-list",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "nowritecache" : {
                     "description" : "disable write caching on the target",
                     "optional" : 1,
                     "type" : "boolean"
                  },
                  "options" : {
                     "description" : "NFS mount options (see 'man nfs')",
                     "format" : "pve-storage-options",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "path" : {
                     "description" : "File system path.",
                     "format" : "pve-storage-path",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "pool" : {
                     "description" : "Pool.",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "portal" : {
                     "description" : "iSCSI portal (IP or DNS name with optional port).",
                     "format" : "pve-storage-portal-dns",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "redundancy" : {
                     "default" : 2,
                     "description" : "The redundancy count specifies the number of nodes to which the resource should be deployed. It must be at least 1 and at most the number of nodes in the cluster.",
                     "maximum" : 16,
                     "minimum" : 1,
                     "optional" : 1,
                     "type" : "integer",
                     "typetext" : "integer (1-16)"
                  },
                  "saferemove" : {
                     "description" : "Zero-out data when removing LVs.",
                     "optional" : 1,
                     "type" : "boolean"
                  },
                  "saferemove_throughput" : {
                     "description" : "Wipe throughput (cstream -t parameter value).",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "server" : {
                     "description" : "Server IP or DNS name.",
                     "format" : "pve-storage-server",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "server2" : {
                     "description" : "Backup volfile server IP or DNS name.",
                     "format" : "pve-storage-server",
                     "optional" : 1,
                     "requires" : "server",
                     "type" : "string"
                  },
                  "shared" : {
                     "description" : "Mark storage as shared.",
                     "optional" : 1,
                     "type" : "boolean"
                  },
                  "sparse" : {
                     "description" : "use sparse volumes",
                     "optional" : 1,
                     "type" : "boolean"
                  },
                  "storage" : {
                     "description" : "The storage identifier.",
                     "format" : "pve-storage-id",
                     "type" : "string"
                  },
                  "tagged_only" : {
                     "description" : "Only use logical volumes tagged with 'pve-vm-ID'.",
                     "optional" : 1,
                     "type" : "boolean"
                  },
                  "target" : {
                     "description" : "iSCSI target.",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "thinpool" : {
                     "description" : "LVM thin pool LV name.",
                     "format" : "pve-storage-vgname",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "transport" : {
                     "description" : "Gluster transport: tcp or rdma",
                     "enum" : [
                        "tcp",
                        "rdma",
                        "unix"
                     ],
                     "optional" : 1,
                     "type" : "string"
                  },
                  "type" : {
                     "description" : "Storage type.",
                     "enum" : [
                        "dir",
                        "drbd",
                        "glusterfs",
                        "iscsi",
                        "iscsidirect",
                        "lvm",
                        "lvmthin",
                        "nfs",
                        "rbd",
                        "sheepdog",
                        "zfs",
                        "zfspool"
                     ],
                     "type" : "string"
                  },
                  "username" : {
                     "description" : "RBD Id.",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "vgname" : {
                     "description" : "Volume group name.",
                     "format" : "pve-storage-vgname",
                     "optional" : 1,
                     "type" : "string"
                  },
                  "volume" : {
                     "description" : "Glusterfs Volume.",
                     "optional" : 1,
                     "type" : "string"
                  }
               },
               "type" : "object"
            },
            "permissions" : {
               "check" : [
                  "perm",
                  "/storage",
                  [
                     "Datastore.Allocate"
                  ]
               ]
            },
            "protected" : 1,
            "returns" : {
               "type" : "null"
            }
         }
      },
      "leaf" : 0,
      "path" : "/storage",
      "text" : "storage"
   },
   {
      "children" : [
         {
            "children" : [
               {
                  "info" : {
                     "DELETE" : {
                        "description" : "Delete user.",
                        "method" : "DELETE",
                        "name" : "delete_user",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "userid" : {
                                 "description" : "User ID",
                                 "format" : "pve-userid",
                                 "maxLength" : 64,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "and",
                              [
                                 "userid-param",
                                 "Realm.AllocateUser"
                              ],
                              [
                                 "userid-group",
                                 [
                                    "User.Modify"
                                 ]
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     },
                     "GET" : {
                        "description" : "Get user configuration.",
                        "method" : "GET",
                        "name" : "read_user",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "userid" : {
                                 "description" : "User ID",
                                 "format" : "pve-userid",
                                 "maxLength" : 64,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "userid-group",
                              [
                                 "User.Modify",
                                 "Sys.Audit"
                              ]
                           ]
                        },
                        "returns" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "comment" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "email" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "enable" : {
                                 "type" : "boolean"
                              },
                              "expire" : {
                                 "optional" : 1,
                                 "type" : "integer"
                              },
                              "firstname" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "groups" : {
                                 "type" : "array"
                              },
                              "keys" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "lastname" : {
                                 "optional" : 1,
                                 "type" : "string"
                              }
                           }
                        }
                     },
                     "PUT" : {
                        "description" : "Update user configuration.",
                        "method" : "PUT",
                        "name" : "update_user",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "append" : {
                                 "optional" : 1,
                                 "requires" : "groups",
                                 "type" : "boolean"
                              },
                              "comment" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "email" : {
                                 "format" : "email-opt",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "enable" : {
                                 "description" : "Enable/disable the account.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "expire" : {
                                 "description" : "Account expiration date (seconds since epoch). '0' means no expiration date.",
                                 "minimum" : 0,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (0- N)"
                              },
                              "firstname" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "groups" : {
                                 "format" : "pve-groupid-list",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "keys" : {
                                 "description" : "Keys for two factor auth (yubico).",
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "lastname" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "userid" : {
                                 "description" : "User ID",
                                 "format" : "pve-userid",
                                 "maxLength" : 64,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "userid-group",
                              [
                                 "User.Modify"
                              ],
                              "groups_param",
                              1
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/access/users/{userid}",
                  "text" : "{userid}"
               }
            ],
            "info" : {
               "GET" : {
                  "description" : "User index.",
                  "method" : "GET",
                  "name" : "index",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "enabled" : {
                           "description" : "Optional filter for enable property.",
                           "optional" : 1,
                           "type" : "boolean"
                        }
                     }
                  },
                  "permissions" : {
                     "description" : "The returned list is restricted to users where you have 'User.Modify' or 'Sys.Audit' permissions on '/access/groups' or on a group the user belongs too. But it always includes the current (authenticated) user.",
                     "user" : "all"
                  },
                  "returns" : {
                     "items" : {
                        "properties" : {
                           "userid" : {
                              "type" : "string"
                           }
                        },
                        "type" : "object"
                     },
                     "links" : [
                        {
                           "href" : "{userid}",
                           "rel" : "child"
                        }
                     ],
                     "type" : "array"
                  }
               },
               "POST" : {
                  "description" : "Create new user.",
                  "method" : "POST",
                  "name" : "create_user",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "comment" : {
                           "optional" : 1,
                           "type" : "string"
                        },
                        "email" : {
                           "format" : "email-opt",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "enable" : {
                           "default" : 1,
                           "description" : "Enable the account (default). You can set this to '0' to disable the accout",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "expire" : {
                           "description" : "Account expiration date (seconds since epoch). '0' means no expiration date.",
                           "minimum" : 0,
                           "optional" : 1,
                           "type" : "integer",
                           "typetext" : "integer (0- N)"
                        },
                        "firstname" : {
                           "optional" : 1,
                           "type" : "string"
                        },
                        "groups" : {
                           "format" : "pve-groupid-list",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "keys" : {
                           "description" : "Keys for two factor auth (yubico).",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "lastname" : {
                           "optional" : 1,
                           "type" : "string"
                        },
                        "password" : {
                           "description" : "Initial password.",
                           "maxLength" : 64,
                           "minLength" : 5,
                           "optional" : 1,
                           "type" : "string"
                        },
                        "userid" : {
                           "description" : "User ID",
                           "format" : "pve-userid",
                           "maxLength" : 64,
                           "type" : "string"
                        }
                     }
                  },
                  "permissions" : {
                     "check" : [
                        "and",
                        [
                           "userid-param",
                           "Realm.AllocateUser"
                        ],
                        [
                           "userid-group",
                           [
                              "User.Modify"
                           ],
                           "groups_param",
                           1
                        ]
                     ],
                     "description" : "You need 'Realm.AllocateUser' on '/access/realm/<realm>' on the realm of user <userid>, and 'User.Modify' permissions to '/access/groups/<group>' for any group specified (or 'User.Modify' on '/access/groups' if you pass no groups."
                  },
                  "protected" : 1,
                  "returns" : {
                     "type" : "null"
                  }
               }
            },
            "leaf" : 0,
            "path" : "/access/users",
            "text" : "users"
         },
         {
            "children" : [
               {
                  "info" : {
                     "DELETE" : {
                        "description" : "Delete group.",
                        "method" : "DELETE",
                        "name" : "delete_group",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "groupid" : {
                                 "format" : "pve-groupid",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access/groups",
                              [
                                 "Group.Allocate"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     },
                     "GET" : {
                        "description" : "Get group configuration.",
                        "method" : "GET",
                        "name" : "read_group",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "groupid" : {
                                 "format" : "pve-groupid",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access/groups",
                              [
                                 "Sys.Audit",
                                 "Group.Allocate"
                              ],
                              "any",
                              1
                           ]
                        },
                        "returns" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "comment" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "members" : {
                                 "items" : {
                                    "type" : "string"
                                 },
                                 "type" : "array"
                              }
                           },
                           "type" : "object"
                        }
                     },
                     "PUT" : {
                        "description" : "Update group data.",
                        "method" : "PUT",
                        "name" : "update_group",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "comment" : {
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "groupid" : {
                                 "format" : "pve-groupid",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access/groups",
                              [
                                 "Group.Allocate"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/access/groups/{groupid}",
                  "text" : "{groupid}"
               }
            ],
            "info" : {
               "GET" : {
                  "description" : "Group index.",
                  "method" : "GET",
                  "name" : "index",
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "permissions" : {
                     "description" : "The returned list is restricted to groups where you have 'User.Modify', 'Sys.Audit'  or 'Group.Allocate' permissions on /access/groups/<group>.",
                     "user" : "all"
                  },
                  "returns" : {
                     "items" : {
                        "properties" : {
                           "groupid" : {
                              "type" : "string"
                           }
                        },
                        "type" : "object"
                     },
                     "links" : [
                        {
                           "href" : "{groupid}",
                           "rel" : "child"
                        }
                     ],
                     "type" : "array"
                  }
               },
               "POST" : {
                  "description" : "Create new group.",
                  "method" : "POST",
                  "name" : "create_group",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "comment" : {
                           "optional" : 1,
                           "type" : "string"
                        },
                        "groupid" : {
                           "format" : "pve-groupid",
                           "type" : "string"
                        }
                     }
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/access/groups",
                        [
                           "Group.Allocate"
                        ]
                     ]
                  },
                  "protected" : 1,
                  "returns" : {
                     "type" : "null"
                  }
               }
            },
            "leaf" : 0,
            "path" : "/access/groups",
            "text" : "groups"
         },
         {
            "children" : [
               {
                  "info" : {
                     "DELETE" : {
                        "description" : "Delete role.",
                        "method" : "DELETE",
                        "name" : "delete_role",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "roleid" : {
                                 "format" : "pve-roleid",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     },
                     "GET" : {
                        "description" : "Get role configuration.",
                        "method" : "GET",
                        "name" : "read_role",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "roleid" : {
                                 "format" : "pve-roleid",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "user" : "all"
                        },
                        "returns" : {}
                     },
                     "PUT" : {
                        "description" : "Create new role.",
                        "method" : "PUT",
                        "name" : "update_role",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "append" : {
                                 "optional" : 1,
                                 "requires" : "privs",
                                 "type" : "boolean"
                              },
                              "privs" : {
                                 "format" : "pve-priv-list",
                                 "type" : "string"
                              },
                              "roleid" : {
                                 "format" : "pve-roleid",
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access",
                              [
                                 "Sys.Modify"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/access/roles/{roleid}",
                  "text" : "{roleid}"
               }
            ],
            "info" : {
               "GET" : {
                  "description" : "Role index.",
                  "method" : "GET",
                  "name" : "index",
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "permissions" : {
                     "user" : "all"
                  },
                  "returns" : {
                     "items" : {
                        "properties" : {
                           "roleid" : {
                              "type" : "string"
                           }
                        },
                        "type" : "object"
                     },
                     "links" : [
                        {
                           "href" : "{roleid}",
                           "rel" : "child"
                        }
                     ],
                     "type" : "array"
                  }
               },
               "POST" : {
                  "description" : "Create new role.",
                  "method" : "POST",
                  "name" : "create_role",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "privs" : {
                           "format" : "pve-priv-list",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "roleid" : {
                           "format" : "pve-roleid",
                           "type" : "string"
                        }
                     }
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/access",
                        [
                           "Sys.Modify"
                        ]
                     ]
                  },
                  "protected" : 1,
                  "returns" : {
                     "type" : "null"
                  }
               }
            },
            "leaf" : 0,
            "path" : "/access/roles",
            "text" : "roles"
         },
         {
            "info" : {
               "GET" : {
                  "description" : "Get Access Control List (ACLs).",
                  "method" : "GET",
                  "name" : "read_acl",
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "permissions" : {
                     "description" : "The returned list is restricted to objects where you have rights to modify permissions.",
                     "user" : "all"
                  },
                  "returns" : {
                     "items" : {
                        "additionalProperties" : 0,
                        "properties" : {
                           "path" : {
                              "type" : "string"
                           },
                           "propagate" : {
                              "type" : "boolean"
                           },
                           "roleid" : {
                              "type" : "string"
                           },
                           "type" : {
                              "enum" : [
                                 "user",
                                 "group"
                              ],
                              "type" : "string"
                           },
                           "ugid" : {
                              "type" : "string"
                           }
                        },
                        "type" : "object"
                     },
                     "type" : "array"
                  }
               },
               "PUT" : {
                  "description" : "Update Access Control List (add or remove permissions).",
                  "method" : "PUT",
                  "name" : "update_acl",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "delete" : {
                           "description" : "Remove permissions (instead of adding it).",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "groups" : {
                           "description" : "List of groups.",
                           "format" : "pve-groupid-list",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "path" : {
                           "description" : "Access control path",
                           "type" : "string"
                        },
                        "propagate" : {
                           "default" : 1,
                           "description" : "Allow to propagate (inherit) permissions.",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "roles" : {
                           "description" : "List of roles.",
                           "format" : "pve-roleid-list",
                           "type" : "string"
                        },
                        "users" : {
                           "description" : "List of users.",
                           "format" : "pve-userid-list",
                           "optional" : 1,
                           "type" : "string"
                        }
                     }
                  },
                  "permissions" : {
                     "check" : [
                        "perm-modify",
                        "{path}"
                     ]
                  },
                  "protected" : 1,
                  "returns" : {
                     "type" : "null"
                  }
               }
            },
            "leaf" : 1,
            "path" : "/access/acl",
            "text" : "acl"
         },
         {
            "children" : [
               {
                  "info" : {
                     "DELETE" : {
                        "description" : "Delete an authentication server.",
                        "method" : "DELETE",
                        "name" : "delete",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "realm" : {
                                 "description" : "Authentication domain ID",
                                 "format" : "pve-realm",
                                 "maxLength" : 32,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access/realm",
                              [
                                 "Realm.Allocate"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     },
                     "GET" : {
                        "description" : "Get auth server configuration.",
                        "method" : "GET",
                        "name" : "read",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "realm" : {
                                 "description" : "Authentication domain ID",
                                 "format" : "pve-realm",
                                 "maxLength" : 32,
                                 "type" : "string"
                              }
                           }
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access/realm",
                              [
                                 "Realm.Allocate",
                                 "Sys.Audit"
                              ],
                              "any",
                              1
                           ]
                        },
                        "returns" : {}
                     },
                     "PUT" : {
                        "description" : "Update authentication server settings.",
                        "method" : "PUT",
                        "name" : "update",
                        "parameters" : {
                           "additionalProperties" : 0,
                           "properties" : {
                              "base_dn" : {
                                 "description" : "LDAP base domain name",
                                 "maxLength" : 256,
                                 "optional" : 1,
                                 "pattern" : "\\w+=[^,]+(,\\s*\\w+=[^,]+)*",
                                 "type" : "string"
                              },
                              "bind_dn" : {
                                 "description" : "LDAP bind domain name",
                                 "maxLength" : 256,
                                 "optional" : 1,
                                 "pattern" : "\\w+=[^,]+(,\\s*\\w+=[^,]+)*",
                                 "type" : "string"
                              },
                              "comment" : {
                                 "description" : "Description.",
                                 "maxLength" : 4096,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "default" : {
                                 "description" : "Use this as default realm",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "delete" : {
                                 "description" : "A list of settings you want to delete.",
                                 "format" : "pve-configid-list",
                                 "maxLength" : 4096,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "digest" : {
                                 "description" : "Prevent changes if current configuration file has different SHA1 digest. This can be used to prevent concurrent modifications.",
                                 "maxLength" : 40,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "domain" : {
                                 "description" : "AD domain name",
                                 "maxLength" : 256,
                                 "optional" : 1,
                                 "pattern" : "\\S+",
                                 "type" : "string"
                              },
                              "port" : {
                                 "description" : "Server port.",
                                 "maximum" : 65535,
                                 "minimum" : 1,
                                 "optional" : 1,
                                 "type" : "integer",
                                 "typetext" : "integer (1-65535)"
                              },
                              "realm" : {
                                 "description" : "Authentication domain ID",
                                 "format" : "pve-realm",
                                 "maxLength" : 32,
                                 "type" : "string"
                              },
                              "secure" : {
                                 "description" : "Use secure LDAPS protocol.",
                                 "optional" : 1,
                                 "type" : "boolean"
                              },
                              "server1" : {
                                 "description" : "Server IP address (or DNS name)",
                                 "format" : "address",
                                 "maxLength" : 256,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "server2" : {
                                 "description" : "Fallback Server IP address (or DNS name)",
                                 "format" : "address",
                                 "maxLength" : 256,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "tfa" : {
                                 "description" : "Use Two-factor authentication.",
                                 "format" : "pve-tfa-config",
                                 "maxLength" : 128,
                                 "optional" : 1,
                                 "type" : "string"
                              },
                              "user_attr" : {
                                 "description" : "LDAP user attribute name",
                                 "maxLength" : 256,
                                 "optional" : 1,
                                 "pattern" : "\\S{2,}",
                                 "type" : "string"
                              }
                           },
                           "type" : "object"
                        },
                        "permissions" : {
                           "check" : [
                              "perm",
                              "/access/realm",
                              [
                                 "Realm.Allocate"
                              ]
                           ]
                        },
                        "protected" : 1,
                        "returns" : {
                           "type" : "null"
                        }
                     }
                  },
                  "leaf" : 1,
                  "path" : "/access/domains/{realm}",
                  "text" : "{realm}"
               }
            ],
            "info" : {
               "GET" : {
                  "description" : "Authentication domain index.",
                  "method" : "GET",
                  "name" : "index",
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "permissions" : {
                     "description" : "Anyone can access that, because we need that list for the login box (before the user is authenticated).",
                     "user" : "world"
                  },
                  "returns" : {
                     "items" : {
                        "properties" : {
                           "comment" : {
                              "optional" : 1,
                              "type" : "string"
                           },
                           "realm" : {
                              "type" : "string"
                           },
                           "tfa" : {
                              "description" : "Two-factor authentication provider.",
                              "enum" : [
                                 "yubico",
                                 "oath"
                              ],
                              "optional" : 1,
                              "type" : "string"
                           }
                        },
                        "type" : "object"
                     },
                     "links" : [
                        {
                           "href" : "{realm}",
                           "rel" : "child"
                        }
                     ],
                     "type" : "array"
                  }
               },
               "POST" : {
                  "description" : "Add an authentication server.",
                  "method" : "POST",
                  "name" : "create",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "base_dn" : {
                           "description" : "LDAP base domain name",
                           "maxLength" : 256,
                           "optional" : 1,
                           "pattern" : "\\w+=[^,]+(,\\s*\\w+=[^,]+)*",
                           "type" : "string"
                        },
                        "bind_dn" : {
                           "description" : "LDAP bind domain name",
                           "maxLength" : 256,
                           "optional" : 1,
                           "pattern" : "\\w+=[^,]+(,\\s*\\w+=[^,]+)*",
                           "type" : "string"
                        },
                        "comment" : {
                           "description" : "Description.",
                           "maxLength" : 4096,
                           "optional" : 1,
                           "type" : "string"
                        },
                        "default" : {
                           "description" : "Use this as default realm",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "domain" : {
                           "description" : "AD domain name",
                           "maxLength" : 256,
                           "optional" : 1,
                           "pattern" : "\\S+",
                           "type" : "string"
                        },
                        "port" : {
                           "description" : "Server port.",
                           "maximum" : 65535,
                           "minimum" : 1,
                           "optional" : 1,
                           "type" : "integer",
                           "typetext" : "integer (1-65535)"
                        },
                        "realm" : {
                           "description" : "Authentication domain ID",
                           "format" : "pve-realm",
                           "maxLength" : 32,
                           "type" : "string"
                        },
                        "secure" : {
                           "description" : "Use secure LDAPS protocol.",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "server1" : {
                           "description" : "Server IP address (or DNS name)",
                           "format" : "address",
                           "maxLength" : 256,
                           "optional" : 1,
                           "type" : "string"
                        },
                        "server2" : {
                           "description" : "Fallback Server IP address (or DNS name)",
                           "format" : "address",
                           "maxLength" : 256,
                           "optional" : 1,
                           "type" : "string"
                        },
                        "tfa" : {
                           "description" : "Use Two-factor authentication.",
                           "format" : "pve-tfa-config",
                           "maxLength" : 128,
                           "optional" : 1,
                           "type" : "string"
                        },
                        "type" : {
                           "description" : "Realm type.",
                           "enum" : [
                              "ad",
                              "ldap",
                              "pam",
                              "pve"
                           ],
                           "type" : "string"
                        },
                        "user_attr" : {
                           "description" : "LDAP user attribute name",
                           "maxLength" : 256,
                           "optional" : 1,
                           "pattern" : "\\S{2,}",
                           "type" : "string"
                        }
                     },
                     "type" : "object"
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/access/realm",
                        [
                           "Realm.Allocate"
                        ]
                     ]
                  },
                  "protected" : 1,
                  "returns" : {
                     "type" : "null"
                  }
               }
            },
            "leaf" : 0,
            "path" : "/access/domains",
            "text" : "domains"
         },
         {
            "info" : {
               "GET" : {
                  "description" : "Dummy. Useful for formaters which want to priovde a login page.",
                  "method" : "GET",
                  "name" : "get_ticket",
                  "parameters" : {
                     "additionalProperties" : 0
                  },
                  "permissions" : {
                     "user" : "world"
                  },
                  "returns" : {
                     "type" : "null"
                  }
               },
               "POST" : {
                  "description" : "Create or verify authentication ticket.",
                  "method" : "POST",
                  "name" : "create_ticket",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "otp" : {
                           "description" : "One-time password for Two-factor authentication.",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "password" : {
                           "description" : "The secret password. This can also be a valid ticket.",
                           "type" : "string"
                        },
                        "path" : {
                           "description" : "Verify ticket, and check if user have access 'privs' on 'path'",
                           "maxLength" : 64,
                           "optional" : 1,
                           "requires" : "privs",
                           "type" : "string"
                        },
                        "privs" : {
                           "description" : "Verify ticket, and check if user have access 'privs' on 'path'",
                           "format" : "pve-priv-list",
                           "maxLength" : 64,
                           "optional" : 1,
                           "requires" : "path",
                           "type" : "string"
                        },
                        "realm" : {
                           "description" : "You can optionally pass the realm using this parameter. Normally the realm is simply added to the username <username>@<relam>.",
                           "format" : "pve-realm",
                           "maxLength" : 32,
                           "optional" : 1,
                           "type" : "string"
                        },
                        "username" : {
                           "description" : "User name",
                           "maxLength" : 64,
                           "type" : "string"
                        }
                     }
                  },
                  "permissions" : {
                     "description" : "You need to pass valid credientials.",
                     "user" : "world"
                  },
                  "protected" : 1,
                  "returns" : {
                     "properties" : {
                        "CSRFPreventionToken" : {
                           "optional" : 1,
                           "type" : "string"
                        },
                        "ticket" : {
                           "optional" : 1,
                           "type" : "string"
                        },
                        "username" : {
                           "type" : "string"
                        }
                     },
                     "type" : "object"
                  }
               }
            },
            "leaf" : 1,
            "path" : "/access/ticket",
            "text" : "ticket"
         },
         {
            "info" : {
               "PUT" : {
                  "description" : "Change user password.",
                  "method" : "PUT",
                  "name" : "change_passsword",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "password" : {
                           "description" : "The new password.",
                           "maxLength" : 64,
                           "minLength" : 5,
                           "type" : "string"
                        },
                        "userid" : {
                           "description" : "User ID",
                           "format" : "pve-userid",
                           "maxLength" : 64,
                           "type" : "string"
                        }
                     }
                  },
                  "permissions" : {
                     "check" : [
                        "or",
                        [
                           "userid-param",
                           "self"
                        ],
                        [
                           "and",
                           [
                              "userid-param",
                              "Realm.AllocateUser"
                           ],
                           [
                              "userid-group",
                              [
                                 "User.Modify"
                              ]
                           ]
                        ]
                     ],
                     "description" : "Each user is allowed to change his own password. A user can change the password of another user if he has 'Realm.AllocateUser' (on the realm of user <userid>) and 'User.Modify' permission on /access/groups/<group> on a group where user <userid> is member of."
                  },
                  "protected" : 1,
                  "returns" : {
                     "type" : "null"
                  }
               }
            },
            "leaf" : 1,
            "path" : "/access/password",
            "text" : "password"
         }
      ],
      "info" : {
         "GET" : {
            "description" : "Directory index.",
            "method" : "GET",
            "name" : "index",
            "parameters" : {
               "additionalProperties" : 0
            },
            "permissions" : {
               "user" : "all"
            },
            "returns" : {
               "items" : {
                  "properties" : {
                     "subdir" : {
                        "type" : "string"
                     }
                  },
                  "type" : "object"
               },
               "links" : [
                  {
                     "href" : "{subdir}",
                     "rel" : "child"
                  }
               ],
               "type" : "array"
            }
         }
      },
      "leaf" : 0,
      "path" : "/access",
      "text" : "access"
   },
   {
      "children" : [
         {
            "info" : {
               "DELETE" : {
                  "description" : "Delete pool.",
                  "method" : "DELETE",
                  "name" : "delete_pool",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "poolid" : {
                           "format" : "pve-poolid",
                           "type" : "string"
                        }
                     }
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/pool/{poolid}",
                        [
                           "Pool.Allocate"
                        ]
                     ],
                     "description" : "You can only delete empty pools (no members)."
                  },
                  "protected" : 1,
                  "returns" : {
                     "type" : "null"
                  }
               },
               "GET" : {
                  "description" : "Get pool configuration.",
                  "method" : "GET",
                  "name" : "read_pool",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "poolid" : {
                           "format" : "pve-poolid",
                           "type" : "string"
                        }
                     }
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/pool/{poolid}",
                        [
                           "Pool.Allocate"
                        ]
                     ]
                  },
                  "returns" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "comment" : {
                           "optional" : 1,
                           "type" : "string"
                        },
                        "members" : {
                           "items" : {
                              "additionalProperties" : 1,
                              "properties" : {
                                 "id" : {
                                    "type" : "string"
                                 },
                                 "node" : {
                                    "type" : "string"
                                 },
                                 "storage" : {
                                    "optional" : 1,
                                    "type" : "string"
                                 },
                                 "type" : {
                                    "enum" : [
                                       "qemu",
                                       "lxc",
                                       "openvz",
                                       "storage"
                                    ],
                                    "type" : "string"
                                 },
                                 "vmid" : {
                                    "optional" : 1,
                                    "type" : "integer"
                                 }
                              },
                              "type" : "object"
                           },
                           "type" : "array"
                        }
                     },
                     "type" : "object"
                  }
               },
               "PUT" : {
                  "description" : "Update pool data.",
                  "method" : "PUT",
                  "name" : "update_pool",
                  "parameters" : {
                     "additionalProperties" : 0,
                     "properties" : {
                        "comment" : {
                           "optional" : 1,
                           "type" : "string"
                        },
                        "delete" : {
                           "description" : "Remove vms/storage (instead of adding it).",
                           "optional" : 1,
                           "type" : "boolean"
                        },
                        "poolid" : {
                           "format" : "pve-poolid",
                           "type" : "string"
                        },
                        "storage" : {
                           "description" : "List of storage IDs.",
                           "format" : "pve-storage-id-list",
                           "optional" : 1,
                           "type" : "string"
                        },
                        "vms" : {
                           "description" : "List of virtual machines.",
                           "format" : "pve-vmid-list",
                           "optional" : 1,
                           "type" : "string"
                        }
                     }
                  },
                  "permissions" : {
                     "check" : [
                        "perm",
                        "/pool/{poolid}",
                        [
                           "Pool.Allocate"
                        ]
                     ],
                     "description" : "You also need the right to modify permissions on any object you add/delete."
                  },
                  "protected" : 1,
                  "returns" : {
                     "type" : "null"
                  }
               }
            },
            "leaf" : 1,
            "path" : "/pools/{poolid}",
            "text" : "{poolid}"
         }
      ],
      "info" : {
         "GET" : {
            "description" : "Pool index.",
            "method" : "GET",
            "name" : "index",
            "parameters" : {
               "additionalProperties" : 0
            },
            "permissions" : {
               "description" : "List all pools where you have Pool.Allocate or VM.Allocate permissions on /pool/<pool>.",
               "user" : "all"
            },
            "returns" : {
               "items" : {
                  "properties" : {
                     "poolid" : {
                        "type" : "string"
                     }
                  },
                  "type" : "object"
               },
               "links" : [
                  {
                     "href" : "{poolid}",
                     "rel" : "child"
                  }
               ],
               "type" : "array"
            }
         },
         "POST" : {
            "description" : "Create new pool.",
            "method" : "POST",
            "name" : "create_pool",
            "parameters" : {
               "additionalProperties" : 0,
               "properties" : {
                  "comment" : {
                     "optional" : 1,
                     "type" : "string"
                  },
                  "poolid" : {
                     "format" : "pve-poolid",
                     "type" : "string"
                  }
               }
            },
            "permissions" : {
               "check" : [
                  "perm",
                  "/pool/{poolid}",
                  [
                     "Pool.Allocate"
                  ]
               ]
            },
            "protected" : 1,
            "returns" : {
               "type" : "null"
            }
         }
      },
      "leaf" : 0,
      "path" : "/pools",
      "text" : "pools"
   },
   {
      "info" : {
         "GET" : {
            "description" : "API version details. The result also includes the global datacenter confguration.",
            "method" : "GET",
            "name" : "version",
            "parameters" : {
               "additionalProperties" : 0
            },
            "permissions" : {
               "user" : "all"
            },
            "returns" : {
               "properties" : {
                  "release" : {
                     "type" : "string"
                  },
                  "repoid" : {
                     "type" : "string"
                  },
                  "version" : {
                     "type" : "string"
                  }
               },
               "type" : "object"
            }
         }
      },
      "leaf" : 1,
      "path" : "/version",
      "text" : "version"
   }
]
;

// avoid errors when running without development tools
if (!Ext.isDefined(Ext.global.console)) {   
    var console = { 
        dir: function() {}, 
        log: function() {} 
    };
}

Ext.onReady(function() {

    Ext.define('pve-param-schema', {
        extend: 'Ext.data.Model',
        fields:  [ 
	    'name', 'type', 'typetext', 'description', 'verbose_description',
	    'enum', 'minimum', 'maximum', 'minLength', 'maxLength',
	    'pattern', 'title', 'requires', 'format', 'default',
	    'disallow', 'extends', 'links',
	    {
		name: 'optional',
		type: 'boolean'
	    }
	]
    });

    var store = Ext.create('Ext.data.TreeStore', {
	model: Ext.define('pve-api-doc', {
            extend: 'Ext.data.Model',
            fields:  [ 
		'path', 'info', 'text',
	    ]
	}),
        proxy: {
            type: 'memory',
            data: pveapi
        },
        sorters: [{
            property: 'leaf',
            direction: 'ASC'
        }, {
            property: 'text',
            direction: 'ASC'
        }]
    });
    
    var render_description = function(value, metaData, record) {
	var pdef = record.data;

	value = pdef.verbose_description || value;

	// TODO: try to render asciidoc correctly

	metaData.style = 'white-space:pre-wrap;'

	return Ext.htmlEncode(value);
    };

    var render_type = function(value, metaData, record) {
	var pdef = record.data;

	return pdef['enum'] ? 'enum' : (pdef.type || 'string');
    };

    var render_format = function(value, metaData, record) {
	var pdef = record.data;

	metaData.style = 'white-space:normal;'

	if (pdef.typetext)
	    return Ext.htmlEncode(pdef.typetext);

	if (pdef['enum'])
	    return pdef['enum'].join(' | ');

	if (pdef.format) 
	    return pdef.format;

	if (pdef.pattern) 
	    return Ext.htmlEncode(pdef.pattern);

	return '';
    };

    var render_docu = function(data) {
	var md = data.info;

	// console.dir(data);

	var items = [];

	var clicmdhash = {
	    GET: 'get',
	    POST: 'create',
	    PUT: 'set',
	    DELETE: 'delete'
	};

	Ext.Array.each(['GET', 'POST', 'PUT', 'DELETE'], function(method) {
	    var info = md[method];
	    if (info) {

		var usage = "";

		usage += "<table><tr><td>HTTP:&nbsp;&nbsp;&nbsp;</td><td>" + method + " /api2/json" + data.path + "</td></tr><tr><td>&nbsp</td></tr>";
		usage += "<tr><td>CLI:</td><td>pvesh " + clicmdhash[method] + " " + data.path + "</td></tr></table>";

		var sections = [
		    {
			title: 'Description',
			html: Ext.htmlEncode(info.description),
			bodyPadding: 10
		    },
		    {
			title: 'Usage',
			html: usage,
			bodyPadding: 10
		    }
		];

		if (info.parameters && info.parameters.properties) {

		    var pstore = Ext.create('Ext.data.Store', {
			model: 'pve-param-schema',
			proxy: {
			    type: 'memory'
			},
			groupField: 'optional',
			sorters: [
			    {
				property: 'name',
				direction: 'ASC'
			    }
			]
		    });

		    Ext.Object.each(info.parameters.properties, function(name, pdef) {
			pdef.name = name;
			pstore.add(pdef);
		    });

		    pstore.sort();

		    var groupingFeature = Ext.create('Ext.grid.feature.Grouping',{
			enableGroupingMenu: false,
			groupHeaderTpl: '<tpl if="groupValue">Optional</tpl><tpl if="!groupValue">Required</tpl>'
		    });

		    sections.push({
			xtype: 'gridpanel',
			title: 'Parameters',
			features: [groupingFeature],
			store: pstore,
			viewConfig: {
			    trackOver: false,
			    stripeRows: true
			},
			columns: [
			    { 
				header: 'Name',
				dataIndex: 'name'
			    },
			    { 
				header: 'Type',
				dataIndex: 'type',
				renderer: render_type,
			    },
			    { 
				header: 'Format',
				dataIndex: 'type',
				renderer: render_format,
				flex: 1
			    },
			    { 
				header: 'Description',
				dataIndex: 'description',
				renderer: render_description,
				flex: 2
			    }
			]
		    });

		}

		if (info.returns) {

		    var rtype = info.returns.type;
		    if (!rtype && info.returns.items)
			rtype = 'array';
		    if (!rtype)
			rtype = 'object';

		    sections.push({
			title: 'Returns: ' + rtype
		    });
		}

		var permhtml = '';
		if (!info.permissions) {
		    permhtml = "Root only.";
		} else {
		    if (info.permissions.description) {
			permhtml += "<div style='white-space:pre-wrap;padding-bottom:10px;'>" +
			    Ext.htmlEncode(info.permissions.description) + "</div>";
		    }

		    if (info.permissions.user) {
			if (!info.permissions.description) {
			    if (info.permissions.user === 'world') {
				permhtml += "Accessible without any authententification.";
			    } else if (info.permissions.user === 'all') {
				permhtml += "Accessible by all authententicated users.";
			    } else {
				permhtml += 'Onyl accessible by user "' + 
				    info.permissions.user + '"';
			    }
			}
		    } else if (info.permissions.check) {
			permhtml += "<pre>Check: " + 
			    Ext.htmlEncode(Ext.JSON.encode(info.permissions.check))  + "</pre>";
		    } else {
			permhtml += "Unknown systax!";
		    }
		}

		sections.push({
		    title: 'Required permissions',
		    bodyPadding: 10,
		    html: permhtml
		});
    
  
		items.push({
		    title: method,
		    autoScroll: true,
		    defaults: {
			border: false
		    },
		    items: sections
		});
	    }
	});

	var ct = Ext.getCmp('docview');
	ct.setTitle("Path: " + data.path);
	ct.removeAll(true);
	ct.add(items);
	ct.setActiveTab(0);
    };

    var tree = Ext.create('Ext.tree.Panel', {
        title: 'Resource Tree',
        store: store,
	width: 200,
        region: 'west',
        split: true,
        margins: '5 0 5 5',
        rootVisible: false,
	listeners: {
	    selectionchange: function(v, selections) {
		if (!selections[0])
		    return;
		var rec = selections[0];
		render_docu(rec.data);
	    }
	}
    });

    Ext.create('Ext.container.Viewport', {
	layout: 'border',
	renderTo: Ext.getBody(),
	items: [
	    tree,
	    {
		xtype: 'tabpanel',
		title: 'Documentation',
		id: 'docview',
		region: 'center',
		margins: '5 5 5 0',
		layout: 'fit',
		items: []
	    }
	]
    });

});
